<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2005 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

// Form

$CNT_TMP .= headline($crow["acontent_title"], $crow["acontent_subtitle"], $template_default["article"]);
$cnt_form = unserialize($crow["acontent_form"]);
$form_cnt = '';
$form_error_text = '';

/*
 * Browse form fields
 */
if(isset($cnt_form["fields"]) && is_array($cnt_form["fields"]) && count($cnt_form["fields"])) {
	
	$form_counter = 0;
	$cnt_form['label_wrap'] = explode('|', $cnt_form['label_wrap']);
	$cnt_form['label_wrap'][0] = !empty($cnt_form['label_wrap'][0]) ? trim($cnt_form['label_wrap'][0]) : '';
	$cnt_form['label_wrap'][1] = !empty($cnt_form['label_wrap'][1]) ? trim($cnt_form['label_wrap'][1]) : '';
	$form_field_hidden = '';
	
	if(!empty($_POST['cpID'.$crow["acontent_id"]]) && intval($_POST['cpID'.$crow["acontent_id"]]) == $crow["acontent_id"]) {
		$POST_DO = true;
		$POST_val = array();
		$cache_nosave = true;
	} else {
		$POST_DO = false;
	}	
	
	foreach($cnt_form["fields"] as $key => $value) {
	
		$form_field = '';
		$form_name = html_specialchars($cnt_form["fields"][$key]['name']);	
		$POST_name = $cnt_form["fields"][$key]['name'];
		
		switch($cnt_form["fields"][$key]['type']) {
	
			case 'text'		:	/*
								 * Text
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = $POST_val[$POST_name];
									}
								}
								//
								$form_field .= '<input type="text" name="'.$form_name.'" id="'.$form_name.'" ';
								$form_field .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'"';
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' size="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' maxlength="'.$cnt_form["fields"][$key]['max'].'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ' />';
								break;
								
			case 'special'	:	/*
								 * Special
								 */
								if($cnt_form["fields"][$key]['value']) {
									$cnt_form['special_value'] = str_replace('"', '', $cnt_form["fields"][$key]['value']);
									$cnt_form['special_value'] = str_replace("'", '',$cnt_form['special_value']);
									$cnt_form['special_value'] = str_replace("\r'", '',$cnt_form['special_value']);
									$cnt_form['special_value'] = explode("\n", $cnt_form['special_value']);
									$cnt_form["fields"][$key]['value'] = '';
									
									if(is_array($cnt_form['special_value']) && count($cnt_form['special_value'])) {
										foreach($cnt_form['special_value'] as $cnt_form['special_key'] => $cnt_form['special_val']) {
											$temp_array = explode('=', $cnt_form['special_val']);
											switch($temp_array[0]) {
												case 'default':		$cnt_form['special_attribute']['default'] = isset($temp_array[1]) ? $temp_array[1] : '';
																	break;
												case 'type':		$cnt_form['special_attribute']['type'] = isset($temp_array[1]) ? $temp_array[1] : 'MIX';
																	break;
												case 'dateformat':	$cnt_form['special_attribute']['dateformat'] = isset($temp_array[1]) ? $temp_array[1] : 'm/d/Y';
																	break;
											}
										}
									}
								}
								

								
								$cnt_form["fields"][$key]['value'] = isset($cnt_form['special_attribute']['default']) ? $cnt_form['special_attribute']['default'] : '';
								 
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = $POST_val[$POST_name];
										// try to check for special value
										if(isset($cnt_form['special_attribute']['type'])) {
											switch($cnt_form['special_attribute']['type']) {
										
												//case 'MIX':		
												//				break;
												
												case 'INT':		if(!preg_match('/^[0-9\-\+]+$/', $cnt_form["fields"][$key]['value'])) {
																	$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
																} else {
																	 $cnt_form["fields"][$key]['value'] = intval( $cnt_form["fields"][$key]['value']);
																}
																break;
												
												case 'DEC':
												case 'FLOAT':	if(!is_float_ex($cnt_form["fields"][$key]['value'])) {
																	$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
																}
																break;
												
												case 'IDENT':	if(isset($cnt_form['special_attribute']['default']) && 
																   decode_entities($cnt_form['special_attribute']['default']) != decode_entities($cnt_form["fields"][$key]['value'])) {
																	$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
																}
																break;
												
												case 'MIX':
												case 'STRING':	
																break;
												
												case 'DATE':	if(isset($cnt_form['special_attribute']['dateformat']) && 
																   !is_date($cnt_form["fields"][$key]['value'], $cnt_form['special_attribute']['dateformat'])) {
																	$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
																	$cnt_form["fields"][$key]['value'] = date($cnt_form['special_attribute']['dateformat']);
																}
																break;
										
											}
										}
									}
								} else {
								
									if(isset($cnt_form['special_attribute']['default']) && isset($cnt_form['special_attribute']['type']) &&
									   $cnt_form['special_attribute']['type'] == 'DATE' && $cnt_form['special_attribute']['default'] == 'NOW') {
									   	echo 'ja';
									 	if(isset($cnt_form['special_attribute']['dateformat'])) {
											$cnt_form["fields"][$key]['value'] = date($cnt_form['special_attribute']['dateformat']);
										} else {
											$cnt_form["fields"][$key]['value'] = date('m/d/Y');
										}
									}
								}
								//
								$form_field .= '<input type="text" name="'.$form_name.'" id="'.$form_name.'" ';
								$form_field .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'"';
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' size="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' maxlength="'.$cnt_form["fields"][$key]['max'].'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ' />';
								break;
								
			case 'email'	:	/*
								 * Email
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if(($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) || !is_valid_email($POST_val[$POST_name])) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									}
									$cnt_form["fields"][$key]['value'] = $POST_val[$POST_name];
								}
								//
								$form_field .= '<input type="text" name="'.$form_name.'" id="'.$form_name.'" ';
								$form_field .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'"';
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' size="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' maxlength="'.$cnt_form["fields"][$key]['max'].'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ' />';
								break;

			case 'textarea'	:	/*
								 * Textarea
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = $POST_val[$POST_name];
									}
								}
								//
								$form_field .= '<textarea name="'.$form_name.'" id="'.$form_name.'"';
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' cols="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' rows="'.$cnt_form["fields"][$key]['max'].'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= '>'.html_specialchars($cnt_form["fields"][$key]['value']).'</textarea>';
								break;

			case 'hidden'	:	/*
								 * Hidden
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = $POST_val[$POST_name];
									}
								}
								//
								$form_field_hidden .= '<input type="hidden" name="'.$form_name.'" ';
								$form_field_hidden .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'" />';
								break;

			case 'password'	:	/*
								 * Password
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = $POST_val[$POST_name];
									}
								}
								//
								$form_field .= '<input type="password" name="'.$form_name.'" id="'.$form_name.'" ';
								$form_field .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'"';
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' size="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' maxlength="'.$cnt_form["fields"][$key]['max'].'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ' autocomplete="off" />';
								break;

			case 'select'	:	/*
								 * Men
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = str_replace(' selected', '', $cnt_form["fields"][$key]['value']);
									}
								}
								//
								$form_field .= '<select name="'.$form_name.'" id="'.$form_name.'"';
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ">\n";
								$form_value = explode("\n", $cnt_form["fields"][$key]['value']);
								$form_value = array_map('trim', $form_value);
								$form_value = array_diff($form_value, array(''));
								if(count($form_value)) {
									foreach($form_value as $option_value) {
									
										if(isset($POST_val[$POST_name]) && $POST_val[$POST_name] == $option_value) {
											$option_value .= ' selected';
										}
										
										$option_value = html_specialchars($option_value);
										if(strtolower(substr($option_value, -9)) != ' selected') {
											$form_field .= '<option value="'.$option_value.'"';
										} else {
											$option_value = str_replace(' selected', '', $option_value);
											$form_field .= '<option value="'.$option_value.'" selected="selected"';
										}
										$form_field .= '>'.$option_value."</option>\n";
									}
								}
								$form_field .= '</select>';
								break;

			case 'list'		:	/*
								 * Liste
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									if(is_array($_POST[$POST_name])) {
										$POST_val[$POST_name] = array_map('combined_POST_cleaning', $_POST[$POST_name]);
										$POST_val[$POST_name] = array_diff($POST_val[$POST_name], array(''));
										if(!count($POST_val[$POST_name])) {
											$POST_val[$POST_name] = false;
										}
									} else {
										$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									}
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = str_replace(' selected', '', $cnt_form["fields"][$key]['value']);
									}
								}
								//
								$form_field .= '<select id="'.$form_name.'"';
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' size="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' multiple';
									$form_field .= ' name="'.$form_name.'[]"';
								} else {
									$form_field .= ' name="'.$form_name.'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ">\n";
								$form_value = explode("\n", $cnt_form["fields"][$key]['value']);
								$form_value = array_map('trim', $form_value);
								$form_value = array_diff($form_value, array(''));
								if(count($form_value)) {
									foreach($form_value as $option_value) {
										// try to set given POST var as selected
										if(isset($POST_val[$POST_name])) {
											if(is_array($POST_val[$POST_name])) {
												foreach($POST_val[$POST_name] as $postvar_value) {
													if($postvar_value == $option_value) {
														$option_value .= ' selected';
													}
												}
											} elseif ($POST_val[$POST_name] == $option_value) {
												$option_value .= ' selected';
											}
										}
										
										$option_value = html_specialchars($option_value);
										if(substr($option_value, -9) != ' selected') {
											$form_field .= '<option value="'.$option_value.'"';
										} else {
											$option_value = str_replace(' selected', '', $option_value);
											$form_field .= '<option value="'.$option_value.'" selected="selected"';
										}
										$form_field .= '>'.$option_value."</option>\n";
									}
								}
								$form_field .= '</select>';
								break;

			case 'checkbox'	:	/*
								 * Checkbox
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									if(is_array($_POST[$POST_name])) {
										$POST_val[$POST_name] = array_map('combined_POST_cleaning', $_POST[$POST_name]);
										$POST_val[$POST_name] = array_diff($POST_val[$POST_name], array(''));
										if(!count($POST_val[$POST_name])) {
											$POST_val[$POST_name] = false;
										}
									} else {
										$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									}
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = str_replace(' checked', '', $cnt_form["fields"][$key]['value']);
									}
								}
								//
								$form_value = explode("\n", $cnt_form["fields"][$key]['value']);
								$form_value = array_map('trim', $form_value);
								$form_value = array_diff($form_value, array(''));
								if($cnt_form["fields"][$key]['style']) {
									$checkbox_style = ' style="'.$cnt_form["fields"][$key]['style'].'"';
								} else {
									$checkbox_style = '';
								}
								if(count($form_value) == 1 || count($form_value) == 0 || !$form_value) {
									// only 1 checkbox
									$checkbox_value = is_array($form_value) ? implode('', $form_value) : $form_value;
									$checkbox_value = trim($checkbox_value);
									if(isset($POST_val[$POST_name]) && $POST_val[$POST_name] == ($checkbox_value ? $checkbox_value : $form_name)) {
										$checkbox_value .= ' checked';
									}
									$checkbox_value = $checkbox_value ? html_specialchars($checkbox_value) : $form_name;
									$form_field .= '<input type="checkbox" name="'.$form_name.'" id="'.$form_name.'" ';
									if(substr($checkbox_value, -8) != ' checked') {
										$form_field .= 'value="' . $checkbox_value . '" />';
									} else {
										$checkbox_value = str_replace(' checked', '', $checkbox_value);
										$form_field .= 'value="' . $checkbox_value . '" checked="checked" />';
									}
									$form_field .= '<label for="'.$form_name.'"';
									$form_field .= $checkbox_style;
									$form_field .= '>'.$checkbox_value .'</label>';
									
								} else {
									// list of checkboxes
									$checkbox_counter = 0;
									$checkbox_spacer  = $cnt_form["fields"][$key]['size'] ? '<br />' : ' ';
									foreach($form_value as $checkbox_value) {
									
										if(isset($POST_val[$POST_name]) && is_array($POST_val[$POST_name])) {
											foreach($POST_val[$POST_name] as $postvar_value) {
												if($postvar_value == $checkbox_value) {
													$checkbox_value .= ' checked';
												}
											}
										}
									
										$checkbox_value =  html_specialchars(trim($checkbox_value));
										if($checkbox_counter) {
											$form_field .= $checkbox_spacer;
										}
										$form_field .= '<input type="checkbox" name="'.$form_name.'[]" id="'.$form_name.$checkbox_counter.'" ';
										if(substr($checkbox_value, -8) != ' checked') {
											$form_field .= 'value="' . $checkbox_value . '" />';
										} else {
											$checkbox_value = str_replace(' checked', '', $checkbox_value);
											$form_field .= 'value="' . $checkbox_value . '" checked="checked" />';
										}
										$form_field .= '<label for="'.$form_name.$checkbox_counter.'"';
										$form_field .= $checkbox_style;
										$form_field .= '>'.$checkbox_value .'</label>';
										$checkbox_counter++;
									}
								}
								break;

			case 'radio'	:	/*
								 * Radiobutton
								 */
								if($POST_DO && isset($_POST[$POST_name])) {
									$POST_val[$POST_name] = remove_unsecure_rptags(clean_slweg($_POST[$POST_name]));
									if($cnt_form["fields"][$key]['required'] && !$POST_val[$POST_name]) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} else {
										$cnt_form["fields"][$key]['value'] = str_replace(' checked', '', $cnt_form["fields"][$key]['value']);
									}
								}
								//
								$form_value = explode("\n", $cnt_form["fields"][$key]['value']);
								$form_value = array_map('trim', $form_value);
								$form_value = array_diff($form_value, array(''));
								if($cnt_form["fields"][$key]['style']) {
									$checkbox_style = ' style="'.$cnt_form["fields"][$key]['style'].'"';
								} else {
									$checkbox_style = '';
								}
								if(count($form_value) == 1 || count($form_value) == 0 || !$form_value) {
									// only 1 checkbox
									$checkbox_value = is_array($form_value) ? implode('', $form_value) : $form_value;
									$checkbox_value = trim($checkbox_value);
									if(isset($POST_val[$POST_name]) && $POST_val[$POST_name] == ($checkbox_value ? $checkbox_value : $form_name)) {
										$checkbox_value .= ' checked';
									}
									$checkbox_value = $checkbox_value ? html_specialchars($checkbox_value) : $form_name;
									$form_field .= '<input type="radio" name="'.$form_name.'" id="'.$form_name.'" ';
									if(substr($checkbox_value, -8) != ' checked') {
										$form_field .= 'value="' . $checkbox_value . '" />';
									} else {
										$checkbox_value = str_replace(' checked', '', $checkbox_value);
										$form_field .= 'value="' . $checkbox_value . '" checked="checked" />';
									}
									$form_field .= '<label for="'.$form_name.'"';
									$form_field .= $checkbox_style;
									$form_field .= '>'.$checkbox_value .'</label>';
									
								} else {
									// list of checkboxes
									$checkbox_counter = 0;
									$checkbox_spacer  = $cnt_form["fields"][$key]['size'] ? '<br />' : ' ';
									foreach($form_value as $checkbox_value) {
										if(isset($POST_val[$POST_name]) && $POST_val[$POST_name] == $checkbox_value) {
											$checkbox_value .= ' checked';
										}
										$checkbox_value =  html_specialchars(trim($checkbox_value));
										if($checkbox_counter) {
											$form_field .= $checkbox_spacer;
										}
										$form_field .= '<input type="radio" name="'.$form_name.'" id="'.$form_name.$checkbox_counter.'" ';
										if(substr($checkbox_value, -8) != ' checked') {
											$form_field .= 'value="' . $checkbox_value . '" />';
										} else {
											$checkbox_value = str_replace(' checked', '', $checkbox_value);
											$form_field .= 'value="' . $checkbox_value . '" checked="checked" />';
										}
										$form_field .= '<label for="'.$form_name.$checkbox_counter.'"';
										$form_field .= $checkbox_style;
										$form_field .= '>'.$checkbox_value .'</label>';
										$checkbox_counter++;
									}
								}
								break;

			case 'upload'	:	/*
								 * Upload
								 */
								if($cnt_form["fields"][$key]['value']) {
									$cnt_form['upload_value'] = str_replace('"', '', $cnt_form["fields"][$key]['value']);
									$cnt_form['upload_value'] = str_replace("'", '',$cnt_form['upload_value']);
									$cnt_form['upload_value'] = str_replace("\r'", '',$cnt_form['upload_value']);
									$cnt_form['upload_value'] = explode("\n", $cnt_form['upload_value']);
									if(is_array($cnt_form['upload_value']) && count($cnt_form['upload_value'])) {
										foreach($cnt_form['upload_value'] as $cnt_form['upload_key'] => $cnt_form['upload_val']) {
											$temp_array = explode('=', $cnt_form['upload_val']);
											unset($cnt_form['upload_value'][$cnt_form['upload_key']]);
											if(!empty($temp_array[0]) && !empty($temp_array[1])) {
												$cnt_form['upload_value'][$temp_array[0]] = $temp_array[1];
											}
										}
									}
								}
								if(empty($cnt_form['upload_value']['folder'])) {
									$cnt_form['upload_value']['folder'] = 'content/form/';
								}
								if(empty($cnt_form['upload_value']['attachment'])) {
									$cnt_form['upload_value']['attachment'] = 0;
								}
								if(empty($cnt_form['upload_value']['exclude'])) {
									$cnt_form['upload_value']['exclude'] = 'php,asp,php3,php4,php5,aspx,cfm,js';
								}
								//
								if($POST_DO && isset($_FILES[$POST_name])) {
									$POST_val[$POST_name]['folder'] = $cnt_form['upload_value']['folder'];
									$POST_val[$POST_name]['attachment'] = $cnt_form['upload_value']['attachment'];
									$POST_val[$POST_name]['name'] = '';
									$cnt_form['upload_value']['exclude'] = str_replace(' ', '', $cnt_form['upload_value']['exclude']);
									$cnt_form['upload_value']['exclude'] = str_replace('.', '', $cnt_form['upload_value']['exclude']);									
									$cnt_form['upload_value']['exclude'] = explode(',', $cnt_form['upload_value']['exclude']);
									$cnt_form['upload_value']['exclude'] = array_diff($cnt_form['upload_value']['exclude'], array(''));
									$cnt_form['upload_value']['exclude'] = implode('|', $cnt_form['upload_value']['exclude']);
									$cnt_form['upload_value']['exclude'] = strtolower($cnt_form['upload_value']['exclude']);
									$cnt_form['upload_value']['regexp'] = '/(.'.$cnt_form['upload_value']['exclude'].')$/';
									if($cnt_form["fields"][$key]['required'] && empty($_FILES[$POST_name]['name'])) {
										$POST_ERR[$key] = $cnt_form["fields"][$key]['error'];
									} elseif(!empty($_FILES[$POST_name]['name'])) {
										$cnt_form['upload_value']['filename'] = time().'_'.$_FILES[$POST_name]['name'];
										if( (!empty($cnt_form['upload_value']['maxlength']) && $_FILES[$POST_name]['size'] > intval($cnt_form['upload_value']['maxlength']))
											|| preg_match($cnt_form['upload_value']['regexp'], strtolower($_FILES[$POST_name]['name'])) 
											|| !@move_uploaded_file($_FILES[$POST_name]['tmp_name'], 
											   PHPWCMS_ROOT.'/'.$cnt_form['upload_value']['folder'].'/'.$cnt_form['upload_value']['filename'])
											   ) {
											   $POST_ERR[$key]  = $cnt_form["fields"][$key]['error'];
											   $POST_ERR[$key]	= str_replace('{MAXLENGTH}', empty($cnt_form['upload_value']['maxlength']) ? '' : fsize($cnt_form['upload_value']['maxlength'], ' '), $POST_ERR[$key]);
											   $POST_ERR[$key]  = str_replace('{FILESIZE}', !empty($_FILES[$POST_name]['size']) ? fsize($_FILES[$POST_name]['size'], ' ') : '', $POST_ERR[$key]);
											   $POST_ERR[$key]  = str_replace('{FILENAME}', !empty($_FILES[$POST_name]['name']) ? $_FILES[$POST_name]['name'] : '"n.a."', $POST_ERR[$key]);
											   $POST_ERR[$key]  = str_replace('{FILEEXT}', '.'.str_replace('|', ', .', str_replace(',', ', .', $cnt_form['upload_value']['exclude'])), $POST_ERR[$key]);											   
										} else {
											$POST_val[$POST_name]['name'] = $cnt_form['upload_value']['filename'];
										}
									}
									if(isset($POST_ERR[$key])) {
										@unlink($_FILES[$POST_name]['tmp_name']);
										@unlink(PHPWCMS_ROOT.'/'.$cnt_form['upload_value']['folder'].'/'.$cnt_form['upload_value']['filename']);
									}
								}
								//
								$form_field .= '<input type="file" name="'.$form_name.'" id="'.$form_name.'"';
								if(!empty($cnt_form['upload_value']['accept']) ) {
									$form_field .= ' accept="'.$cnt_form['upload_value']['accept'].'"';
								}
								if($cnt_form["fields"][$key]['size']) {
									$form_field .= ' size="'.$cnt_form["fields"][$key]['size'].'"';
								}
								if($cnt_form["fields"][$key]['max']) {
									$form_field .= ' maxlength="'.$cnt_form["fields"][$key]['max'].'"';
								} elseif (!empty($cnt_form['upload_value']['maxlength'])) {
									$form_field .= ' maxlength="'.$cnt_form['upload_value']['maxlength'].'"';
								}
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
								}
								$form_field .= ' title="';
								if($cnt_form['upload_value']['maxlength']) {
									$form_field .= 'max. '.fsize($cnt_form['upload_value']['maxlength'],' ',1);
								}
								$form_field .= '" />';
								unset($cnt_form['upload_value']);
								break;

			case 'submit'	:	/*
								 * Submit
								 */
								if(strpos(strtolower($cnt_form["fields"][$key]['value']), 'src=') === false) {
									$form_field .= '<input type="submit" name="'.$form_name.'" id="'.$form_name.'" ';
									if($cnt_form["fields"][$key]['value'] != '') {
										$form_field .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'"';
									}
									if($cnt_form["fields"][$key]['style']) {
										$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
									}
									$form_field .= ' />###RESET###';
								} else {
									$form_field .= '<input type="image" name="'.$form_name.'" id="'.$form_name.'" ';
									$form_field .= $cnt_form["fields"][$key]['value'];
									if($cnt_form["fields"][$key]['style']) {
										$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
									}
									$form_field .= ' />###RESET###';
								}
								break;
								
			
			case 'reset'	:	/*
								 * Reset
								 */
								if(strpos(strtolower($cnt_form["fields"][$key]['value']), 'src=') === false) {
									$form_field .= '<input type="reset" name="'.$form_name.'" id="'.$form_name.'" ';
									if($cnt_form["fields"][$key]['value'] != '') {
										$form_field .= 'value="'.html_specialchars($cnt_form["fields"][$key]['value']).'"';
									}
									if($cnt_form["fields"][$key]['style']) {
										$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
									}
									$form_field .= ' />';
								} else {
									$form_field .= '<img name="'.$form_name.'" id="'.$form_name.'" ';
									$form_field .= $cnt_form["fields"][$key]['value'];
									if($cnt_form["fields"][$key]['style']) {
										$form_field .= ' style="'.$cnt_form["fields"][$key]['style'].'"';
									}
									$form_field .= ' border="0" onClick="document.phpwcmsForm'.$crow["acontent_id"].'.reset();" />';
								}
								break;
	
			case 'break'	:	/*
								 * Break
								 */
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= '<div id="'.$form_name.'" style="'.$cnt_form["fields"][$key]['style'].'">';
									$form_field .= $cnt_form["fields"][$key]['value'];
									$form_field .= '</div>';
								} else {
									$form_field .= $cnt_form["fields"][$key]['value'];
								}
								break;
	
			case 'breaktext':	/*
								 * Breaktext
								 */
								if($cnt_form["fields"][$key]['style']) {
									$form_field .= '<span id="'.$form_name.'" style="'.$cnt_form["fields"][$key]['style'].'">';
									$form_field .= nl2br(html_specialchars($cnt_form["fields"][$key]['value']));
									$form_field .= '</span>';
								} else {
									$form_field .= nl2br(html_specialchars($cnt_form["fields"][$key]['value']));
								}
								break;
		}


		if($form_field && $cnt_form["fields"][$key]['type'] != 'hidden') {

			if($cnt_form["fields"][$key]['type'] == 'reset' && strpos($form_cnt, '###RESET###')) {
			
				$form_cnt = str_replace('###RESET###', $form_field, $form_cnt);
			
			} else {
			
				if($cnt_form["fields"][$key]['required']) {
					$cnt_form['labelClass']   = 'formLabelRequired';
					$cnt_form['labelReqMark'] = $cnt_form["cform_reqmark"];
				} else {
					$cnt_form['labelClass']   = 'formLabel';
					$cnt_form['labelReqMark'] = '';
				}
			
				if($cnt_form['labelpos'] == 0) {
					// label: field
					if($cnt_form["fields"][$key]['type'] != 'break') {
						$form_cnt .= "<tr>\n".'<td class="'.$cnt_form['labelClass'].'">';
						if($cnt_form["fields"][$key]['label'] != '') {
							$form_cnt .= $cnt_form['label_wrap'][0];
							$form_cnt .= html_specialchars($cnt_form["fields"][$key]['label']);
							$form_cnt .= $cnt_form['labelReqMark'];
							$form_cnt .= $cnt_form['label_wrap'][1];
						} else {
							$form_cnt .= '&nbsp;';
						}
						$form_cnt .= "</td>\n";
						$form_cnt .= '<td class="formField">'.$form_field."</td>\n</tr>\n";
					} else {
						// colspan for break
						$form_cnt .= '<tr><td colspan="2">'.$form_field."</td></tr>\n";
					}
				} else {
					// label:
					// field
					if($cnt_form["fields"][$key]['label'] != '') {
						$form_cnt .= '<tr><td class="'.$cnt_form['labelClass'].'">'.$cnt_form['label_wrap'][0];
						$form_cnt .= html_specialchars($cnt_form["fields"][$key]['label']);
						$form_cnt .= $cnt_form['labelReqMark'];
						$form_cnt .= $cnt_form['label_wrap'][1]."</td></tr>\n";
					}
					$form_cnt .= '<tr><td class="formField">'.$form_field."</td></tr>\n";
				}
			}
		}

		$form_counter++;
	}
}

if($POST_DO && empty($POST_ERR)) {

	$POST_attach = array();
	
	$cnt_form["fromEmail"]		= $phpwcms['SMTP_USER'];

	// now prepare form values for sending or storing
	if(isset($POST_val) && is_array($POST_val) && count($POST_val)) {
	
		//$content['form']["template_format"]
		//$content['form']["template"] 
		foreach($POST_val as $POST_key => $POST_keyval) {
		
			$POST_valurl = '';
			
			if(isset($cnt_form["copyto"]) && $cnt_form["copyto"] == $POST_key) {
				$cnt_form["copyto"] = $POST_keyval;
				$cnt_form["fromEmail"] = $cnt_form["copyto"];				
			}
		
			if(is_array($POST_keyval) && !isset($POST_keyval['folder'])) {
				// check if this is an array - but no upload value
				$POST_keyval = implode(', ', $POST_keyval);
			
			} elseif(is_array($POST_keyval) && isset($POST_keyval['folder'])) {
				// check if this is an array - and is an upload value
				$POST_valurl = PHPWCMS_URL.$POST_keyval['folder'].'/'.rawurlencode($POST_keyval['name']);
				if(isset($POST_keyval['attachment']) && $POST_keyval['attachment']) {
					$POST_attach[] = PHPWCMS_ROOT.'/'.$POST_keyval['folder'].'/'.$POST_keyval['name'];
				}	
				if(!$cnt_form['template_format']) {
					$POST_keyval = $POST_valurl;
				}
			}
	
			if($cnt_form['template_format']) { //HTML
			
				if(is_array($POST_keyval) && !isset($POST_keyval['folder'])) {
					$POST_keyval = html_specialchars($POST_keyval);
				} elseif(is_array($POST_keyval) && isset($POST_keyval['folder'])) {
					$POST_keyval = '<a href="'.$POST_valurl.'" target="_blank">'.html_specialchars($POST_keyval['name']).'</a>';
				}

			}
			
			$cnt_form['template'] = preg_replace('/\{'.$POST_key.'\}/i', $POST_keyval, $cnt_form['template']);
	
		}
	
	}


	
	// now try to send or save message
	// on form success
	/*
	if($cnt_form["onsuccess_redirect"]) {
		
		header('Location: '.str_replace('{SITE}', PHPWCMS_URL, $cnt_form["onsuccess"]));
		exit();
		
	} else {
	*/
		// send mail
		require_once ('include/inc_ext/phpmailer/class.phpmailer.php');
		$cnt_form["target"] = explode(';', $cnt_form["target"]);
		$cnt_form["message_sender"] = empty($cnt_form["target"][0]) ? $phpwcms['SMTP_FROM_EMAIL'] : $cnt_form["target"][0];
		
		// $cnt_form["fromEmail"]		= $phpwcms['SMTP_USER'];
		
		// first try to send copy message
		if(!empty($cnt_form['sendcopy']) && !empty($cnt_form["copyto"]) && is_valid_email($cnt_form["copyto"])) {
		
			$mail = new PHPMailer();
			$mail->Mailer 			= $phpwcms['SMTP_MAILER'];
			$mail->Host 			= $phpwcms['SMTP_HOST'];
			$mail->Port 			= $phpwcms['SMTP_PORT'];
			if($phpwcms['SMTP_AUTH']) {
				$mail->SMTPAuth 	= 1;
				$mail->Username 	= $phpwcms['SMTP_USER'];
				$mail->Password 	= $phpwcms['SMTP_PASS'];
			}
			$mail->CharSet	 		= $phpwcms["charset"];
			$mail->IsHTML($cnt_form['template_format']);
			$mail->Subject			= $cnt_form["subject"];
			$mail->Body 			= $cnt_form['template'];
			if(!$mail->SetLanguage($phpwcms['default_lang'])) {
				$mail->SetLanguage('en');
			}
		
			$mail->From 		= $phpwcms['SMTP_FROM_EMAIL'];
			$mail->FromName 	= $phpwcms['SMTP_FROM_NAME'];
			$mail->Sender	 	= $cnt_form["message_sender"];

			$mail->AddAddress($cnt_form["copyto"]);
			
			if(!$mail->Send()) {
				$cnt_form["copytoError"] = 'Copy could not be send to: '.html_specialchars($cnt_form["copyto"].' ('.$mail->ErrorInfo.')');
			} else {
				$cnt_form["fromEmail"] = $cnt_form["copyto"];
			}
			unset($mail);
		}
		
		// now send original message
		$mail = new PHPMailer();
		$mail->Mailer 			= $phpwcms['SMTP_MAILER'];
		$mail->Host 			= $phpwcms['SMTP_HOST'];
		$mail->Port 			= $phpwcms['SMTP_PORT'];
		if($phpwcms['SMTP_AUTH']) {
			$mail->SMTPAuth 	= 1;
			$mail->Username 	= $phpwcms['SMTP_USER'];
			$mail->Password 	= $phpwcms['SMTP_PASS'];
		}
		$mail->CharSet	 		= $phpwcms["charset"];
		$mail->IsHTML($cnt_form['template_format']);
		$mail->Subject			= $cnt_form["subject"];
		$mail->Body 			= $cnt_form['template'];
		if(!$mail->SetLanguage($phpwcms['default_lang'])) {
			$mail->SetLanguage('en');
		}
		
		$mail->From 		= $cnt_form["fromEmail"];
		$mail->FromName		= $cnt_form["fromEmail"];
		$mail->Sender	 	= $cnt_form["fromEmail"];

		if(!empty($cnt_form["target"]) && is_array($cnt_form["target"]) && count($cnt_form["target"])) {
		
			foreach($cnt_form["target"] as $e_value) {
				$mail->AddAddress($e_value);
			}

		} else {
			// use default email address
			$mail->AddAddress($phpwcms['SMTP_FROM_EMAIL']);
		}
		
		if(count($POST_attach)) {
			foreach($POST_attach as $attach_file) {
				$mail->AddAttachment($attach_file);
			}
		}

		if(!$mail->Send()) {
			$CNT_TMP .= '<p>'.html_specialchars($mail->ErrorInfo).'</p>';
		} elseif($cnt_form["onsuccess_redirect"]) {
			// redirect on success
			header('Location: '.str_replace('{SITE}', PHPWCMS_URL, $cnt_form["onsuccess"]));
			exit();
		} elseif($cnt_form["onsuccess"]) {
			// success
			$CNT_TMP .= '<div class="'.$cnt_form["class"].'"><p>'.nl2br(html_specialchars($cnt_form["onsuccess"])).'</p></div>';
		}
		if(!empty($cnt_form["copytoError"])) {
			$CNT_TMP .= '<p>'.$cnt_form["copytoError"].'</p>';
		}
		
		unset($mail);
	
	//}
	
	$form_cnt = '';
	
} elseif(isset($POST_ERR)) {
	// do on POST_ERROR
	
	if(isset($_FILES)) {
		foreach($_FILES as $file_key => $file_val) {
			@unlink($_FILES[$file_key]['tmp_name']);
		}
		if(isset($POST_val) && count($POST_val)) {
			foreach($POST_val as $file_key => $file_val) {
				@unlink(PHPWCMS_ROOT.'/'.$cnt_form['upload_value']['folder'].'/'.$POST_val[$file_key]['name']);
			}
		}
	}
	
	if($cnt_form["onerror_redirect"]) {
	
		header('Location: '.str_replace('{SITE}', PHPWCMS_URL, $cnt_form["onerror"]));
		exit();
	
	} else {
	
		if($cnt_form["onerror"]) {
			$form_error_text = '<p>'.nl2br(html_specialchars($cnt_form["onerror"])).'</p>';
		}
	
		$POST_ERR = array_diff(	$POST_ERR , array('') );
		$POST_ERR = array_map( 'html_specialchars', $POST_ERR );
		if( count( $POST_ERR ) ) {
			$form_error = "<tr>\n";
			if($cnt_form['labelpos'] == 0) { // label: field
				$form_error .= '<td class="'.$cnt_form['labelClass'].'">'."&nbsp;</td>\n";
			}
			$form_error .= '<td'.(!empty($cnt_form["error_class"]) ? ' class="'.$cnt_form["error_class"].'"' : '').'>';
			$form_error .= implode("<br />", $POST_ERR);
			$form_error .= "</td>\n</tr>\n";
		
			$form_cnt = $form_error.$form_cnt;
			unset($form_error);
		}
		
	}
}


if($form_cnt) {
	$form_cnt = str_replace('###RESET###', '', $form_cnt);
	$cnt_form["class_close"] = '';
	if($cnt_form["class"]) {
		$CNT_TMP .= '<div class="'.$cnt_form["class"].'">';
		$cnt_form["class_close"] = '</div>';
	}
	$CNT_TMP .= $form_error_text;
	$CNT_TMP .= '<form name="phpwcmsForm'.$crow["acontent_id"].'" id="phpwcmsForm'.$crow["acontent_id"].'" ';
	$CNT_TMP .= 'action="index.php?'.htmlentities($_SERVER['QUERY_STRING']).'" method="post" enctype="multipart/form-data">';
	$CNT_TMP .= '<input type="hidden" name="cpID'.$crow["acontent_id"].'" value="'.$crow["acontent_id"].'" />';
	$CNT_TMP .= $form_field_hidden;
	$CNT_TMP .=	getFormTrackingValue(); //hidden form tracking field
	$CNT_TMP .= '<table cellspacing="0" cellpadding="0" border="0">';
	$CNT_TMP .= "\n".$form_cnt.'</table>';
	$CNT_TMP .= '</form>'.$cnt_form["class_close"];
}

unset($form, $form_cnt, $form_field, $form_field_hidden, $form_counter, $form_error_text);

?>