<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2005 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/


//specific functions for the frontend

// -------------------------------------------------------------

function spacer($width=1, $height=1) {
	//creates a placeholder image (transparent gif)
	$width  = intval($width); $height = intval($height);
	return ($width && $height) ? '<img src="img/leer.gif" width="'.$width.'" height="'.$height.'" alt="" />' : '';
}

// -------------------------------------------------------------

function headline($head, $subhead, $layout) {
	$c = '';
	if($head) {
		$c .= $layout["content_head_before"].
			  //span_class(html_specialchars($head), $layout["content_head_class"]).
			  html_specialchars($head).
			  $layout["content_head_after"];
	}
	if($subhead) {
		$c .= $layout["content_subhead_before"].
			  //span_class(html_specialchars($subhead), $layout["content_subhead_class"]).
			  html_specialchars($subhead).
			  $layout["content_subhead_after"];
	}
	return $c;
}

// -------------------------------------------------------------

function imagetable($phpwcms, $image, $rand="0:0:0:0", $align=0) {
	// creates the image tags if text w/image
	// 0   :1       :2   :3        :4    :5     :6      :7       :8
	// dbid:filename:hash:extension:width:height:caption:position:zoom
	
	$thumb_image = get_cached_image(
						array(	"target_ext"	=>	$image[3],
								"image_name"	=>	$image[2] . '.' . $image[3],
								"max_width"		=>	$image[4],
								"max_height"	=>	$image[5],
								"thumb_name"	=>	md5($image[2].$image[4].$image[5].$phpwcms["sharpen_level"])
        					  )
						);
						
	if($image[8]) {
	
		$zoominfo = get_cached_image(
						array(	"target_ext"	=>	$image[3],
								"image_name"	=>	$image[2] . '.' . $image[3],
								"max_width"		=>	$phpwcms["img_prev_width"],
								"max_height"	=>	$phpwcms["img_prev_height"],
								"thumb_name"	=>	md5($image[2].$phpwcms["img_prev_width"].$phpwcms["img_prev_height"].$phpwcms["sharpen_level"])
        					  )
						);
			
		if($zoominfo == false) $image[8] = 0;
	
	}
						
	$table = '';

	if($thumb_image != false) {
	
		// read content image info
		$table_class 	= $GLOBALS["template_default"]["article"]["image_table_class"];
		$table_class	= ($table_class) ? ' class="'.$table_class.'"' : '';
		$table_bgcolor 	= $GLOBALS["template_default"]["article"]["image_table_bgcolor"];
		$table_bgcolor	= ($table_bgcolor) ? ' bgcolor="'.$table_bgcolor.'"' : '';
		$image_align	= $GLOBALS["template_default"]["article"]["image_align"];
		$image_align	= ($image_align) ? ' align="'.$image_align.'"' : '';
		$image_valign	= $GLOBALS["template_default"]["article"]["image_valign"];
		$image_valign	= ($image_valign) ? ' valign="'.$image_valign.'"' : '';
		$image_border	= ' border="'.intval($GLOBALS["template_default"]["article"]["image_border"]).'"';
		$image_imgclass	= $GLOBALS["template_default"]["article"]["image_imgclass"];
		$image_imgclass	= ($image_imgclass) ? ' class="'.$image_imgclass.'"' : '';
		$image_class 	= $GLOBALS["template_default"]["article"]["image_class"];
		$image_class	= ($image_class) ? ' class="'.$image_class.'"' : '';
		$image_bgcolor 	= $GLOBALS["template_default"]["article"]["image_bgcolor"];
		$image_bgcolor	= ($image_bgcolor) ? ' bgcolor="'.$image_bgcolor.'"' : '';
		$caption_class 	= $GLOBALS["template_default"]["article"]["image_caption_class"];
		$caption_class	= ($caption_class) ? ' class="'.$caption_class.'"' : '';
		$caption_bgcolor= $GLOBALS["template_default"]["article"]["image_caption_bgcolor"];
		$caption_bgcolor= ($caption_bgcolor) ? ' bgcolor="'.$caption_bgcolor.'"' : '';
		$caption_valign	= $GLOBALS["template_default"]["article"]["image_caption_valign"];
		$caption_valign	= ($caption_valign) ? ' valign="'.$caption_valign.'"' : '';
		$caption_align	= $GLOBALS["template_default"]["article"]["image_caption_align"];
		$caption_align	= ($caption_align) ? ' align="'.$caption_align.'"' : '';
		$capt_before 	= $GLOBALS["template_default"]["article"]["image_caption_before"];
		$capt_after 	= $GLOBALS["template_default"]["article"]["image_caption_after"];
	
		// image caption
		$caption	= base64_decode($image[6]);
		$caption	= explode('|', $caption);
		$caption[0]	= nl2br(html_specialchars($caption[0]));
		$caption[1] = (!isset($caption[1])) ? html_specialchars($image[1]) : html_specialchars($caption[1]);
		if(!isset($caption[2])) {
			$caption[2] = array('',' target="_blank"');
		} else {
			//proof target of link
			$caption[2] = explode(' ', trim($caption[2]));
			$caption[2][1] = (!isset($caption[2][1])) ? '' : ' target="'.$caption[2][1].'"';
		}
	
		// image source
		$img = '<img src="'.PHPWCMS_IMAGES.$thumb_image[0].'" '.$thumb_image[3].$image_border.$image_imgclass.' alt="'.$caption[1].'">';
		
		$tablewidth = $thumb_image[1];

		// spaces around image table
		$rand = explode(":", $rand);
		if(count($rand)) { foreach($rand as $key => $value) $rand[$key] = intval($value); } else { $rand = array(0,0,0,0); }
		if($rand[2] && $rand[3]) {
			$colspan = ' colspan="3"';
		} else {
			if($rand[2] || $rand[3]) { $colspan = ' colspan="2"'; } else { $colspan = ""; }
		}
		$tablewidth += $rand[2] + $rand[3];
		
		$table .= '<table width="'.$tablewidth.'" border="0" cellspacing="0" cellpadding="0" ';
		$table .= ($align) ? 'align="'.$align.'"' : '';
		$table .= $table_bgcolor.$table_class.">\n";
		$table .= ($rand[0]) ? '<tr><td'.$colspan.'>'.spacer(1,$rand[0])."</td></tr>\n" : '';
		$table .= '<tr>';
		$table .= ($rand[2]) ? '<td>'.spacer($rand[2],1).'</td>' : '';
		if($image[8]) {
			
			$open_popup_link = "image_zoom.php?show=".base64_encode($zoominfo[0].'?'.$zoominfo[3]);
			$table .= '<td'.$image_align.$image_valign.$image_bgcolor.$image_class.">";
			if($caption[2][0]) {
				$open_link = $caption[2][0];
				$return_false = '';
			} else {
				$open_link = $open_popup_link;
				$return_false = 'return false;';
			}
			//$table .= "<a href=\"".$open_link."\" onClick=\"window.open('".$open_popup_link."','previewpic','width=";
			$table .= "<a href=\"".$open_link."\" onClick=\"checkClickZoom();clickZoom('".$open_popup_link."','previewpic','width=";
			$table .= $zoominfo[1].",height=".$zoominfo[2]."');".$return_false."\"".$caption[2][1].">";
			$table .= $img.'</a></td>';
		} else {
			$table .= '<td'.$image_align.$image_valign.$image_bgcolor.$image_class.">";
			if($caption[2][0]) {
				$table .= '<a href="'.$caption[2][0].'"'.$caption[2][1].'>'.$img.'</a>';
			} else {
				$table .= $img;
			}
			$table .= '</td>';
		}
		$table .= ($rand[3]) ? "<td>".spacer($rand[3],1)."</td>" : "";
		$table .= "</tr>\n";
		if($caption[0]) {
	
			//$table .= "<tr><td".$colspan.">".spacer(1,3)."</td></tr>\n";
			$table .= "<tr>";
			$table .= ($rand[2]) ? "<td>".spacer($rand[2],1)."</td>" : "";
			$table .= '<td'.$caption_valign.$caption_align.$caption_bgcolor.$caption_class.'>'.$capt_before.$caption[0].$capt_after."</td>";
			$table .= ($rand[3]) ? "<td>".spacer($rand[3],1)."</td>" : "";
			$table .= "</tr>\n";
		}	
		$table .= ($rand[1]) ? "<tr><td".$colspan.">".spacer(1,$rand[1])."</td></tr>\n" : "";		
		$table .= "</table>";
		
	}

	return $table;
}

function imagediv($phpwcms, $image, $classname='') {
	// creates the image tags if text w/image
	// 0   :1       :2   :3        :4    :5     :6      :7       :8
	// dbid:filename:hash:extension:width:height:caption:position:zoom
	
	$classname = 'imgDIV'.$classname;
	
	$thumb_image = get_cached_image(
						array(	"target_ext"	=>	$image[3],
								"image_name"	=>	$image[2] . '.' . $image[3],
								"max_width"		=>	$image[4],
								"max_height"	=>	$image[5],
								"thumb_name"	=>	md5($image[2].$image[4].$image[5].$phpwcms["sharpen_level"])
        					  )
						);
						
	if($image[8]) {
	
		$zoominfo = get_cached_image(
						array(	"target_ext"	=>	$image[3],
								"image_name"	=>	$image[2] . '.' . $image[3],
								"max_width"		=>	$phpwcms["img_prev_width"],
								"max_height"	=>	$phpwcms["img_prev_height"],
								"thumb_name"	=>	md5($image[2].$phpwcms["img_prev_width"].$phpwcms["img_prev_height"].$phpwcms["sharpen_level"])
        					  )
						);
			
		if($zoominfo == false) $image[8] = 0;
	
	}
						
	$image_block = '';

	if($thumb_image != false) {
	
		// read content image info
		$image_border	= ' border="'.intval($GLOBALS["template_default"]["article"]["image_border"]).'"';
		$image_imgclass	= $GLOBALS["template_default"]["article"]["image_imgclass"];
		$image_imgclass	= ($image_imgclass) ? ' class="'.$image_imgclass.'"' : '';
		$image_class 	= $GLOBALS["template_default"]["article"]["image_class"];
		$image_class	= ($image_class) ? ' class="'.$image_class.'"' : ' class="imgClass"';
		$caption_class 	= $GLOBALS["template_default"]["article"]["image_caption_class"];
		$caption_class	= ($caption_class) ? ' class="'.$caption_class.'"' : ' class="caption"';
		$capt_before 	= $GLOBALS["template_default"]["article"]["image_caption_before"];
		$capt_after 	= $GLOBALS["template_default"]["article"]["image_caption_after"];
	
		// image caption
		$caption	= base64_decode($image[6]);
		$caption	= explode('|', $caption);
		$caption[0]	= nl2br(html_specialchars($caption[0]));
		$caption[1] = (!isset($caption[1])) ? html_specialchars($image[1]) : html_specialchars($caption[1]);
		if(!isset($caption[2])) {
			$caption[2] = array('',' target="_blank"');
		} else {
			//proof target of link
			$caption[2] = explode(' ', trim($caption[2]));
			$caption[2][1] = (!isset($caption[2][1])) ? '' : ' target="'.$caption[2][1].'"';
		}
	
		// image source
		$img  = '<img src="'.PHPWCMS_IMAGES.$thumb_image[0].'" '.$thumb_image[3];
		$img .= $image_border.$image_imgclass.' alt="'.$caption[1].'" title="'.$caption[1].'">';
		
		$image_block .= '<div class="'.$classname.'">';

		if($image[8]) {
			
			$open_popup_link = "image_zoom.php?show=".base64_encode($zoominfo[0].'?'.$zoominfo[3]);
			$image_block .= '<div'.$image_class.">";
			if($caption[2][0]) {
				$open_link = $caption[2][0];
				$return_false = '';
			} else {
				$open_link = $open_popup_link;
				$return_false = 'return false;';
			}
			$image_block .= '<a href="'.$open_link."\" onclick=\"checkClickZoom();clickZoom('".$open_popup_link."','previewpic','width=";
			$image_block .= $zoominfo[1].",height=".$zoominfo[2]."');".$return_false."\"".$caption[2][1].">";
			$image_block .= $img.'</a></div>';
		} else {
			$image_block .= '<div'.$image_class.">";
			if($caption[2][0]) {
				$image_block .= '<a href="'.$caption[2][0].'"'.$caption[2][1].'>'.$img.'</a>';
			} else {
				$image_block .= $img;
			}
			$image_block .= '</div>';
		}
		if($caption[0]) {
			$image_block .= '<p'.$caption_class.'>'.$capt_before.$caption[0].$capt_after."</p>";
		}	
		
		$image_block .= "</div>";
		
	}

	return $image_block;
}

// -------------------------------------------------------------

function imagelisttable($imagelist, $rand="0:0:0:0", $align=0, $type=0) {
	// build imagelist or ecard chooser table
	// image: type = 0
	// ecard: type = 1
	$template_type = (!$type) ? 'imagelist' : 'ecard';

	$table_class 	= $GLOBALS["template_default"]["article"][$template_type."_table_class"];
	$table_class	= ($table_class) ? ' class="'.$table_class.'"' : '';
	$table_bgcolor 	= $GLOBALS["template_default"]["article"][$template_type."_table_bgcolor"];
	$table_bgcolor	= ($table_bgcolor) ? ' bgcolor="'.$table_bgcolor.'"' : '';
	$image_align	= $GLOBALS["template_default"]["article"][$template_type."_align"];
	$image_align	= ($image_align) ? ' align="'.$image_align.'"' : '';
	$image_valign	= $GLOBALS["template_default"]["article"][$template_type."_valign"];
	$image_valign	= ($image_valign) ? ' valign="'.$image_valign.'"' : '';
	$image_border	= ' border="'.intval($GLOBALS["template_default"]["article"][$template_type."_border"]).'"';
	$image_imgclass	= $GLOBALS["template_default"]["article"][$template_type."_imgclass"];
	$image_imgclass	= ($image_imgclass) ? ' class="'.$image_imgclass.'"' : '';
	$image_class 	= $GLOBALS["template_default"]["article"][$template_type."_class"];
	$image_class	= ($image_class) ? ' class="'.$image_class.'"' : '';
	$image_bgcolor 	= $GLOBALS["template_default"]["article"][$template_type."_bgcolor"];
	$image_bgcolor	= ($image_bgcolor) ? ' bgcolor="'.$image_bgcolor.'"' : '';
	$caption_class 	= $GLOBALS["template_default"]["article"][$template_type."_caption_class"];
	$caption_class	= ($caption_class) ? ' class="'.$caption_class.'"' : '';
	$caption_bgcolor= $GLOBALS["template_default"]["article"][$template_type."_caption_bgcolor"];
	$caption_bgcolor= ($caption_bgcolor) ? ' bgcolor="'.$caption_bgcolor.'"' : '';
	$caption_valign	= $GLOBALS["template_default"]["article"][$template_type."_caption_valign"];
	$caption_valign	= ($caption_valign) ? ' valign="'.$caption_valign.'"' : '';
	$caption_align	= $GLOBALS["template_default"]["article"][$template_type."_caption_align"];
	$caption_align	= ($caption_align) ? ' align="'.$caption_align.'"' : '';
	$capt_before 	= $GLOBALS["template_default"]["article"][$template_type."_caption_before"];
	$capt_after 	= $GLOBALS["template_default"]["article"][$template_type."_caption_after"];

	$align = (!$align) ? '' : ' align="'.$align.'"';
	$rand = explode(":", $rand);
	if(count($rand)) { 
		foreach($rand as $key => $value) {
			$rand[$key] = intval($value);
		}
	} else {
		$rand = array(0,0,0,0);
	}
	$col_rand = ($rand[2] && $rand[3]) ? 2 : (($rand[2] || $rand[3]) ? 1 : 0 );
	
	if($count_images = count($imagelist['images'])) {
	
		//Tabelle starten
		$table = '<table border="0" cellspacing="0" width="1%" cellpadding="0"'.$align.$table_bgcolor.$table_class.">\n";
		$x=0; 
		$y=0; 
		$z=0;
		foreach($imagelist['images'] as $key => $value) {
			$y++;
			if($z && $x==1) {
				$table .= ($col_space) ? "<tr><td".(($col_total>1)?" colspan=\"".$col_total."\"":"").">".spacer(1,$col_space)."</td></tr>\n" : "";
			}
	
			if(!$x) {
				//Some default values
				$col_space = $imagelist['space'];	//Space between images
				$col_count = $imagelist['col'];		//columns
				$col_total = $col_count + (($col_space)?($col_count-1):(0)) + $col_rand;
				//Wenn oberer Rand definiert
				$table .= ($rand[0]) ? '<tr><td'.(($col_total>1)?' colspan="'.$col_total.'"':'').'>'.spacer(1,$rand[0])."</td></tr>\n" : "";
				$x=1;
			}
			if($x==1) {
					
				// if left border
				$table_tmp	 = ($rand[2]) ? '<td width="'.$rand[2].'">'.spacer($rand[2],1).'</td>' : '';
				
				//Neue Tabellenzeile
				$capt_tmp	 = '';
				$capt_row	 = '<tr>'.$table_tmp;		
				$table 		.= $capt_row;
				
			}
			//Aktuelle Bildspalte ausgeben
			$table .= '<td'.$image_align.$image_valign.$image_bgcolor.$image_class.'>'; //width="'.$imagelist[$key]["w"].'" 
																						//removed because no centered image
																						//possible
			
			
			$thumb_image = get_cached_image(
						array(	"target_ext"	=>	$imagelist['images'][$key][3],
								"image_name"	=>	$imagelist['images'][$key][2] . '.' . $imagelist['images'][$key][3],
								"max_width"		=>	$imagelist['images'][$key][4],
								"max_height"	=>	$imagelist['images'][$key][5],
								"thumb_name"	=>	md5(	$imagelist['images'][$key][2].$imagelist['images'][$key][4].
															$imagelist['images'][$key][5].$GLOBALS['phpwcms']["sharpen_level"]
														)
        					  )
						);
						
			if($imagelist['zoom']) {
	
				$zoominfo = get_cached_image(
						array(	"target_ext"	=>	$imagelist['images'][$key][3],
								"image_name"	=>	$imagelist['images'][$key][2] . '.' . $imagelist['images'][$key][3],
								"max_width"		=>	$GLOBALS['phpwcms']["img_prev_width"],
								"max_height"	=>	$GLOBALS['phpwcms']["img_prev_height"],
								"thumb_name"	=>	md5(	$imagelist['images'][$key][2].$GLOBALS['phpwcms']["img_prev_width"].
															$GLOBALS['phpwcms']["img_prev_height"].$GLOBALS['phpwcms']["sharpen_level"]
														)
        					  )
						);
			}
			
			// now try to build caption and if neccessary add alt to image or set external link for image
			$caption	= explode('|', $imagelist['images'][$key][6]);
			// set caption and ALT Image Text for imagelist
			$caption[0]	= !$type ? html_specialchars($caption[0]) : $caption[0];
			$caption[1] = !isset($caption[1]) ? htmlentities($imagelist['images'][$key][1]) : html_specialchars($caption[1]);
			$capt_cur = $caption[0];
						
			if(!isset($caption[2])) {
				$caption[2] = array('',' target="_blank"');
			} else {
				//proof target of link
				$caption[2] = explode(' ', trim($caption[2]));
				$caption[2][1] = (!isset($caption[2][1])) ? '' : ' target="'.$caption[2][1].'"';
			}
			
			

			$list_img_temp  = '<img src="'.PHPWCMS_IMAGES.$thumb_image[0].'" '.$thumb_image[3].$image_border.$image_imgclass;
			$list_img_temp .= ' alt="'.$caption[1].'">';
			
			if($imagelist['zoom'] && isset($zoominfo) && $zoominfo != false) {
				// if click enlarge the image
				$open_popup_link = "image_zoom.php?show=".base64_encode($zoominfo[0].'?'.$zoominfo[3]);
				if($caption[2][0]) {
					$open_link = $caption[2][0];
					$return_false = '';
				} else {
					$open_link = $open_popup_link;
					$return_false = 'return false;';
				}
				//$table .= "<a href=\"".$open_link."\" onClick=\"window.open('".$open_popup_link."','previewpic','width=";
				$table .= "<a href=\"".$open_link."\" onClick=\"checkClickZoom();clickZoom('".$open_popup_link."','previewpic','width=";
				$table .= $zoominfo[1].",height=".$zoominfo[2]."');".$return_false.'"'.$caption[2][1].'>';
				$table .= $list_img_temp."</a>";
			} else {
				// if not click enlarge
				if($caption[2][0]) {
					$table .= '<a href="'.$caption[2][0].'"'.$caption[2][1].'>'.$list_img_temp.'</a>';
				} else {
					$table .= $list_img_temp;
				}
			}
			$table .= "</td>";
			
			/*
			if(!$type) {
				$capt_cur = html_specialchars($imagelist['images'][$key][6]);
			} else {
				$capt_cur = $imagelist['images'][$key][6];
			}
			*/
			$capt_tmp .= $capt_cur;
			$capt_row .= '<td'.$caption_valign.$caption_align.$caption_bgcolor.$caption_class.'>'.$capt_before.$capt_cur.$capt_after."</td>\n";
			
		
			//Gegenchecken wieviele Tabellenspalten als Rest bleiben und ergnzen
			if($y == $count_images && $col_count > 1) {	//wenn eigentlich alle Bilder durchlaufen sind
				if ($col_space && $x<$col_count) {
					$xct = '<td>'.spacer($col_space,1).'</td>';
					$table 		.= $xct;
					$capt_row 	.= $xct;
				}
				$rest_image = (ceil($count_images / $col_count) * $col_count) - $count_images;
				for ($i=1; $i <= $rest_image; $i++) {
					$table 		.= '<td>&nbsp;</td>';
					$capt_row 	.= '<td>&nbsp;</td>';
					if($i < $rest_image) {
						if($col_space) {
							$xct = '<td width="'.$col_space.'">'.spacer($col_space,1).'</td>';
							$table 		.= $xct;
							$capt_row 	.= $xct;
						}
					}
					$x++;
				}
			}
			
			if($x==$col_count) {	//Wenn maximale Anzahl Bildspalten erreicht
				$xct = ($rand[3]) ? '<td width="'.$rand[3].'">'.spacer($rand[3],1).'</td>' : '';
				$table 		.= $xct;
				$capt_row 	.= $xct;
				$table		.= "</tr>\n";
				$capt_row	.= "</tr>\n";
				if($capt_tmp) {
					$table	.= $capt_row;
					$capt_row = '';
					$capt_tmp = '';
				}
				$x=1; $z++;
			} else {
				$xct 	 	 = ($col_space) ? '<td width="'.$col_space.'">'.spacer($col_space,1).'</td>' : '';
				$table 		.= $xct;
				$capt_row 	.= $xct;
				$x++;
			}
		}
	
		$table .= ($rand[1]) ? "<tr><td".(($col_total>1)?" colspan=\"".$col_total."\"":"").">".spacer(1,$rand[1])."</td></tr>\n" : "";	
		$table .= "</table>";
	}
	return $table;
}

// -------------------------------------------------------------

//defines multimedia plugin specific values for width or height
function plugin_size($mediatype, $player, $width, $height) {

	switch($mediatype) {
		case 0: //Video
				switch($player) {
					case 0:	//Quicktime
							$width = ($width) ? $width : "";
							$height = ($height) ? $height+16 : "";
							break;
							
					case 1:	//RealPlayer
							$width = ($width) ? $width : "";
							$width = ($height) ? $height+36 : "";
							break;
					
					case 2:	//MediaPlayer
							$width = ($width) ? $width : "";
							$width = ($height) ? $height : "";
							break;
					
					case 3:	//Flash
							$width = ($width) ? $width : "";
							$width = ($height) ? $height : "";
							break;				
				}
				break;
				
		case 1:	//Audio
				break;
				
		case 2:	//Flash
				break;

	}
}

// -------------------------------------------------------------

function must_filled($c) {
	//spaceholder for form fields that have to be filled
	//with some content or has to be marked or like that
	return (intval($c)) ? '<img src="img/article/fill_in_here.gif" alt="" />' : '';
}

// -------------------------------------------------------------

function add_attribute($baseval, $attribute, $val, $space=" ") {
	//to add all relevant attributes that contains
	//values to a string maybe a html tag
	$attribute = (!isEmpty(strval($val))) ? $attribute."=\"".$val."\"" : "";
	$attribute = ($baseval && !isEmpty($val)) ? $space.$attribute : $attribute;
	return $attribute;
}

function add_style_attribute($attribute='', $val='') {
	//to add all relevant attributes that contains
	//values to a string maybe a html tag
	$attribute = (!isEmpty(strval($val))) ? $attribute.':'.$val.';' : '';
	return $attribute;
}

// -------------------------------------------------------------

function html_attribute($attribute='', $val='') {
	//to return only 1 well formatted attributes and values
	return (!isEmpty($val)) ? $attribute."=\"".$val."\"" : "";
}

function html_height_attribute($val=0) {
	//to return only 1 well formatted attributes and values
	return (intval($val)) ? ' style="height:'.$val.'px;" ' : '';
}

// -------------------------------------------------------------

function get_body_attributes($values) {
	//return a standard list of standard html body attributes
	//based on the pagelayout definitions

	if(is_array($values)) {
		$body  = "";
		if(isset($values["layout_bgcolor"])) {
			$body .= add_attribute($body, "bgcolor", $values["layout_bgcolor"]);
		}
		if(isset($values["layout_bgimage"])) {
			$body .= add_attribute($body, "background", $values["layout_bgimage"]);
		}
		if(isset($values["layout_textcolor"])) {
			$body .= add_attribute($body, "text", $values["layout_textcolor"]);
		}
		if(isset($values["layout_linkcolor"])) {
			$body .= add_attribute($body, "link", $values["layout_linkcolor"]);
		}
		if(isset($values["layout_vcolor"])) {
			$body .= add_attribute($body, "vlink", $values["layout_vcolor"]);
		}
		if(isset($values["layout_acolor"])) {
			$body .= add_attribute($body, "alink", $values["layout_acolor"]);
		}
		if(empty($values["layout_noborder"])) {
			$body .= add_attribute($body, "style", 'margin:'.
						(empty($values["layout_border_top"]) ? 0 : intval($values["layout_border_top"])).'px '.
						(empty($values["layout_border_right"]) ? 0 : intval($values["layout_border_right"])).'px '.
						(empty($values["layout_border_bottom"]) ? 0 : intval($values["layout_border_bottom"])).'px '.
						(empty($values["layout_border_left"]) ? 0 : intval($values["layout_border_left"])).'px;');
		}		
		if(isset($values["layout_jsonload"])) {
			$body .= add_attribute($body, "onLoad", $values["layout_jsonload"]);
		}
		return " ".$body;
	} else {
		return "";
	}
}

// -------------------------------------------------------------

function align_base_layout($value) {
	//to get the alignment of the base layout table
	switch($value) {
		case  1: $align = "center"; break;
		case  2: $align = "right"; break;
		default: $align = 0;
	}
	return ($align) ? " align=\"".$align."\"" : "";
}

// -------------------------------------------------------------

function get_colspan($value) {
	//returns colspan value back to table row
	if(!isset($value["layout_type"]))				$value["layout_type"] = 0;
	switch($value["layout_type"]) {
		case  0:	$col=3; break;
		case  1:	$col=2; break;
		case  2:	$col=2; break;
		case  3:	$col=0; break;
		default:	$col=3;
	}
	if(!empty($value["layout_leftspace_width"]))  $col++;
	if(!empty($value["layout_rightspace_width"])) $col++;
	//if($value["layout_leftspace_width"]) $col++;
	//if($value["layout_rightspace_width"]) $col++;
	return ($col) ? (" colspan=\"".$col."\"") : "";
}

// -------------------------------------------------------------

function colspan_table_row($val, $block, $colspan="", $rowcontent="&nbsp;") {
	//creates a new table row for header or footer or such rows
	return ($rowcontent) ? "<tr>\n<td".$colspan.td_attributes($val, $block, 0).">".$rowcontent."</td>\n</tr>\n" : "";
}

// -------------------------------------------------------------

function get_table_block($val, $content="", $leftblock="", $rightblock="") {
	//creates the string with all relevant main block data
	//$val = $pagelayout array values
	$mainblock  = "<tr>\n"; //start row
	
	//if 3column or 2column (with left block)
	if($val["layout_type"]==0 || $val["layout_type"]==1) {
		$mainblock .= "<td".td_attributes($val, "left").">".$leftblock."</td>\n";
	}
	
	//if there is a spacer column between left and main block
	if($val["layout_leftspace_width"]) {
		$mainblock .= "<td".td_attributes($val, "leftspace").">";
		$mainblock .= spacer($val["layout_leftspace_width"]);
		$mainblock .= "</td>\n";
	}
	
	$mainblock .= "<td".td_attributes($val, "content").">".$content."</td>\n";
	
	//if there is a spacer column between main block and right column
	if($val["layout_rightspace_width"]) {
		$mainblock .= "<td".td_attributes($val, "rightspace").">";
		$mainblock .= spacer($val["layout_rightspace_width"]);
		$mainblock .= "</td>\n";
	}
	
	//if 3column or 2column (with right block)
	if($val["layout_type"]==0 || $val["layout_type"]==2) {
		$mainblock .= "<td".td_attributes($val, "right").">".$rightblock."</td>\n";
	}
	
	$mainblock .= "</tr>\n"; //end row
	return $mainblock;
}

// -------------------------------------------------------------

function td_attributes($val, $block, $top=1) {
	//creates a string with all relevant cell attributes like nackground color/image, class
	$td_attrib  = ($top) ? ' valign="top"' : "";
	if(!empty($val["layout_".$block."_height"])) {
		$td_attrib .= html_height_attribute($val["layout_".$block."_height"]);
	}
	if(!empty($val["layout_".$block."_width"])) {
		$td_attrib .= html_attribute(" width", $val["layout_".$block."_width"]);
	}
	if(!empty($val["layout_".$block."_bgcolor"])) {
		$td_attrib .= html_attribute(" bgcolor", $val["layout_".$block."_bgcolor"]);
	}
	if(!empty($val["layout_".$block."_bgimage"])) {
		$td_attrib .= html_attribute(" background", $val["layout_".$block."_bgimage"]);
	}
	if(!empty($val["layout_".$block."_class"])) {
		$td_attrib .= html_attribute(" class", $val["layout_".$block."_class"]);
	}
	return $td_attrib;
}

// -------------------------------------------------------------

function table_attributes($val, $var_part, $top=1, $tr=false) {
	//creates a string with all relevant cell attributes like background color/image, class
	//P.S. it is nearly the same as td_attributes - but it was boring to rewrite code ;-)
	$td_attrib = '';
	if($top) {
		$td_attrib = ' valign="top"';
	}

	if(!$tr) {
		$td_attrib .= html_attribute(" border", (!empty($val[$var_part."_border"])) ? $val[$var_part."_border"] : '0');
		$td_attrib .= html_attribute(" cellspacing", (!empty($val[$var_part."_cspace"])) ? $val[$var_part."_cspace"] : '0');
		$td_attrib .= html_attribute(" cellpadding", (!empty($val[$var_part."_cpad"])) ? $val[$var_part."_cpad"] : '0');
	}
	
	if(!empty($val[$var_part."_height"])) {
		$td_attrib .= html_height_attribute($val[$var_part."_height"]);
	}
	if(!empty($val[$var_part."_width"])) {
		$td_attrib .= html_attribute(" width", $val[$var_part."_width"]);
	}
	if(!empty($val[$var_part."_bgcolor"])) {
		$td_attrib .= html_attribute(" bgcolor", $val[$var_part."_bgcolor"]);
	}
	if(!empty($val[$var_part."_bgimage"])) {
		$td_attrib .= html_attribute(" background", $val[$var_part."_bgimage"]);
	}
	if(!empty($val[$var_part."_class"])) {
		$td_attrib .= html_attribute(" class", $val[$var_part."_class"]);
	}
	
	return $td_attrib;
}

// -------------------------------------------------------------

function get_breadcrumb ($start_id, $struct_array) {
	//returns the breadcrumb path starting with given start_id
	$data = array();
	while ($start_id) {
		$data[$start_id] = $struct_array[$start_id]["acat_name"];
		$start_id		 = $struct_array[$start_id]["acat_struct"];
	}
	if(!empty($struct_array[$start_id]["acat_name"])) {
		$data[$start_id] = $struct_array[$start_id]["acat_name"];
	}
	return array_reverse($data, 1);
}

// -------------------------------------------------------------

function breadcrumb ($start_id, $struct_array, $end_id, $link_to="index.php", $spacer=" &gt; ") {
	//builds the breadcrumb menu based on given values
	//$link_to = the page on which the breadcrum part links
	//$root_name = name of the breadcrumb part if empty/false/0 $start_id
	//$spacer = how should breadcrumb parts be divided
	
	$start_id = intval($start_id);
	$end_id = intval($end_id);
	$act_id = $start_id; //store actual ID for later comparing
		
	while ($start_id) { //get the breadcrumb path starting with given start_id
		$data[$start_id] = $struct_array[$start_id]["acat_name"];
		$start_id		 = $struct_array[$start_id]["acat_struct"];
		if($end_id && $start_id == $end_id) break;
	}
	$data[$start_id] = $struct_array[$start_id]["acat_name"];
	$crumbs_part = array_reverse($data, 1);	
	
	if(is_array($crumbs_part) && count($crumbs_part)) {
		$breadcrumb = "";
		foreach($crumbs_part as $key => $value) {	
			$alias = '';
			if ($act_id != $key) {
				if($breadcrumb) $breadcrumb .= $spacer;
				if(!$struct_array[$key]["acat_redirect"]) {
					$breadcrumb .= '<a href="index.php?';
					$alias = $struct_array[$key]["acat_alias"];
					$breadcrumb .= ($alias) ? html_specialchars($alias) : 'id='.$key.',0,0,1,0,0';
					$breadcrumb .= '">';
				} else {
					$redirect = get_redirect_link($struct_array[$key]["acat_redirect"], ' ', '');
					$breadcrumb .= '<a href="'.$redirect['link'].'"'.$redirect['target'].'>';
				}
				$breadcrumb .= html_specialchars($crumbs_part[$key]).'</a>';
			} else {
				if($breadcrumb) $breadcrumb .= $spacer;
				$breadcrumb .= html_specialchars($crumbs_part[$key]);
			}
		}
	} else {
		$breadcrumb = "";
	}
	return $breadcrumb;
}

// -------------------------------------------------------------

function get_redirect_link($link='#', $pre='', $after=' ') {
	// returns the link var and target var if available
	$link 			= explode(' ', $link);
	$l['link']		= !empty($link[0]) ? $link[0] : '#';
	$l['target']	= !empty($link[1]) ? $pre.'target="'.strtolower($link[1]).'"'.$after : '';
	return $l;
}

// -------------------------------------------------------------

function get_struct_data ($dbcon, $root_name="Home", $root_info="") {
	//returns the complete active and public struct data as array
	//so it is reusable by many menu functions -> lower db access
	
	//struct array caching check
	//if(file_exists(PHPWCMS_TEMP.'temp_struct_array.php')) {
	
		
	
	//} else {
	
		$data[0] = array(	"acat_id"		=> 0,
						"acat_name"		=> $GLOBALS['indexpage']['acat_name'],
						"acat_info"		=> $GLOBALS['indexpage']['acat_info'],
						"acat_struct"	=> 0,
						"acat_sort"		=> 0,
						"acat_hidden"	=> intval($GLOBALS['indexpage']['acat_hidden']),
						"acat_regonly"	=> intval($GLOBALS['indexpage']['acat_regonly']),
						"acat_ssl"		=> intval($GLOBALS['indexpage']['acat_ssl']),
						"acat_template"	=> intval($GLOBALS['indexpage']['acat_template']),
						"acat_alias"	=> $GLOBALS['indexpage']['acat_alias'],
						"acat_topcount"	=> intval($GLOBALS['indexpage']['acat_topcount']),
						"acat_redirect"	=> $GLOBALS['indexpage']['acat_redirect'],
						"acat_order"	=> intval($GLOBALS['indexpage']['acat_order']),
						"acat_timeout"	=> $GLOBALS['indexpage']['acat_timeout'],
						"acat_nosearch"	=> $GLOBALS['indexpage']['acat_nosearch'],
						"acat_nositemap"=> $GLOBALS['indexpage']['acat_nositemap'],
						"acat_permit"	=> !empty($GLOBALS['indexpage']['acat_permit']) && is_array($GLOBALS['indexpage']['acat_permit']) ? $GLOBALS['indexpage']['acat_permit'] : array()
					);
		$sql  = "SELECT * FROM ".DB_PREPEND."phpwcms_articlecat WHERE ";
		// VISIBLE_MODE: 0 = frontend (all) mode, 1 = article user mode, 2 = admin user mode
		if(VISIBLE_MODE != 2) {
			// for 0 AND 1
			$sql .= "acat_aktiv=1 AND acat_public=1 AND ";
		}
		$sql .= "acat_trash=0 ORDER BY acat_struct, acat_sort;";
		
		if($result = mysql_query($sql, $dbcon)) {
			while($row = mysql_fetch_assoc($result)) {			
				$data[$row["acat_id"]] = array(	"acat_id"		=> $row["acat_id"],
											"acat_name"		=> $row["acat_name"],
											"acat_info"		=> $row["acat_info"],
											"acat_struct"	=> $row["acat_struct"],
											"acat_sort"		=> $row["acat_sort"],
											"acat_hidden"	=> $row["acat_hidden"],
											"acat_regonly"	=> $row["acat_regonly"],
											"acat_ssl"		=> $row["acat_ssl"],
											"acat_template"	=> $row["acat_template"],
											"acat_alias"	=> $row["acat_alias"],
											"acat_topcount"	=> $row["acat_topcount"],
											"acat_redirect"	=> $row["acat_redirect"],
											"acat_order"	=> $row["acat_order"],
											"acat_timeout"	=> $row["acat_cache"],
											"acat_nosearch"	=> $row["acat_nosearch"],
											"acat_nositemap"=> $row["acat_nositemap"],
											"acat_permit"	=> !empty($row["acat_permit"]) ? explode(',', $row["acat_permit"]) : array()
										  );
			}
			mysql_free_result($result);
		}
	
	//}
	return (is_array($data) && count($data)) ? $data : array();
}

// -------------------------------------------------------------

function get_actcat_articles_data ($act_cat_id, $dbcon) {
	//returns the complete active and public article data as array (basic infos only)
	//so it is reusable by many functions -> lower db access
	
	$data = array();
	$ao = get_order_sort($GLOBALS['content']['struct'][ $act_cat_id ]['acat_order']);

	$sql  = "SELECT *, UNIX_TIMESTAMP(article_tstamp) AS article_date FROM ".DB_PREPEND."phpwcms_article ";
	$sql .= "WHERE article_cid=".intval($act_cat_id);
	// VISIBLE_MODE: 0 = frontend (all) mode, 1 = article user mode, 2 = admin user mode
	switch(VISIBLE_MODE) {
		case 0: $sql .= " AND article_public=1 AND article_aktiv=1";
				break;
		case 1: $sql .= " AND article_uid=".$_SESSION["wcs_user_id"];
				break;
		//case 2: admin mode no additional neccessary
	}
	$sql .= " AND article_deleted=0 AND article_begin < NOW() AND article_end > NOW() ";
	$sql .= "ORDER BY ".$ao[2];	
	
	if($result = mysql_query($sql, $dbcon)) {
		while($row = mysql_fetch_assoc($result)) {
			$data[$row["article_id"]] = array(
									"article_id"		=> $row["article_id"],
									"article_cid"		=> $row["article_cid"],
									"article_title"		=> $row["article_title"],
									"article_subtitle"	=> $row["article_subtitle"],
									"article_keyword"	=> $row["article_keyword"],
									"article_summary"	=> $row["article_summary"],
									"article_redirect"	=> $row["article_redirect"],
									"article_date"		=> $row["article_date"],
									"article_username"	=> $row["article_username"],
									"article_sort"		=> $row["article_sort"],
									"article_notitle"	=> $row["article_notitle"],
									"article_created"	=> $row["article_created"],
									"article_image"		=> unserialize($row["article_image"]),
									"article_timeout"	=> $row["article_cache"],
									"article_nosearch"	=> $row["article_nosearch"],
									"article_nositemap"	=> $row["article_nositemap"],
									"article_aliasid"	=> $row["article_aliasid"],
									"article_headerdata"=> $row["article_headerdata"],
									"article_morelink"	=> $row["article_morelink"]
											);
			// now check for article alias ID
			if($row["article_aliasid"]) {
				$aid = $row["article_id"];
				$alias_sql  = "SELECT *, UNIX_TIMESTAMP(article_tstamp) AS article_date FROM ".DB_PREPEND."phpwcms_article ";
				$alias_sql .= "WHERE article_deleted=0 AND article_id=".intval($row["article_aliasid"]);
				if(!$row["article_headerdata"]) {
					switch(VISIBLE_MODE) {
						case 0: $alias_sql .= " AND article_public=1 AND article_aktiv=1";
								break;
						case 1: $alias_sql .= " AND article_uid=".$_SESSION["wcs_user_id"];
								break;
					}
					$alias_sql .= " AND article_begin < NOW() AND article_end > NOW()";
				}
				$alias_sql .= " AND article_deleted=0 LIMIT 1";
				if($alias_result = mysql_query($alias_sql, $dbcon)) {
					if($alias_row = mysql_fetch_assoc($alias_result)) {
						$data[$aid]["article_id"] = $alias_row["article_id"];
						// use alias article header data
						if(!$row["article_headerdata"]) {
							$data[$aid]["article_title"]	= $alias_row["article_title"];
							$data[$aid]["article_subtitle"]	= $alias_row["article_subtitle"];
							$data[$aid]["article_keyword"]	= $alias_row["article_keyword"];
							$data[$aid]["article_summary"]	= $alias_row["article_summary"];
							$data[$aid]["article_redirect"]	= $alias_row["article_redirect"];
							$data[$aid]["article_date"]		= $alias_row["article_date"];
							$data[$aid]["article_image"]	= unserialize($alias_row["article_image"]);
						}
					}
					mysql_free_result($alias_result);
				}
			}
		}
		mysql_free_result($result);
	}
	return $data;
}

// -------------------------------------------------------------

//menu creating
function nav_table_simple_struct($struct, $act_cat_id, $link_to="index.php") {
	//returns a simple table based navigation menu of possible
	//structure levels based on current structure level
	$nav_table  = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n<tr>\n";
	$nav_table .= "<td width=\"10\"><img src=\"img/leer.gif\" width=\"10\" height=\"1\" alt=\"\" /></td>\n";
	$nav_table .= "<td width=\"100%\"><strong>";
	$nav_table .= html_specialchars($struct[$act_cat_id]["acat_name"]);
	$nav_table .= "</strong></td>\n<tr>";
	foreach($struct as $key => $value) {
		//if($struct[$key]["acat_struct"] == $act_cat_id && $key != $act_cat_id && !$struct[$key]["acat_hidden"]) { 
		//show also if hidden category is selected
		if($struct[$key]["acat_struct"] == $act_cat_id && $key != $act_cat_id && (!$struct[$key]["acat_hidden"] || isset($GLOBALS['LEVEL_KEY'][$key]))) {
			$nav_table .= "<tr>\n";
			$nav_table .= "<td width=\"10\"><img src=\"img/leer.gif\" width=\"10\" height=\"1\" alt=\"\" /></td>\n";
			$nav_table .= '<td width="100%">';
			
			if(!$struct[$key]["acat_redirect"]) {
				$nav_table .= '<a href="index.php?';
				if($struct[$key]["acat_alias"]) {
					$nav_table .= html_specialchars($struct[$key]["acat_alias"]);
				} else {
					$nav_table .= 'id='.$key.',0,0,1,0,0';
				}
				$nav_table .= '">';
			} else {
				$redirect = get_redirect_link($struct[$key]["acat_redirect"], ' ', '');
				$nav_table .= '<a href="'.$redirect['link'].'"'.$redirect['target'].'>';
			}
			
			$nav_table .= html_specialchars($struct[$key]["acat_name"])."</a></td>\n<tr>";
		}
	}
	$nav_table .= "</table>";
	return $nav_table;
}

// -------------------------------------------------------------

function nav_level_row($show_id, $show_home=1) {
	//returns a simple row based navigation
	
	if(strtoupper($show_id) == "CURRENT") {
		$act_cat_id = $GLOBALS['content']["cat_id"];
	} else {
		$act_cat_id = intval($show_id);
	}
	
	$nav = '';
	
	if($show_home) {
		if($GLOBALS['content']["cat_id"] == $act_cat_id) {
			$before = $GLOBALS['template_default']["nav_row"]["link_before_active"];
			$after  = $GLOBALS['template_default']["nav_row"]["link_after_active"];
			$direct_before	= $GLOBALS['template_default']["nav_row"]["link_direct_before_active"];
			$direct_after	= $GLOBALS['template_default']["nav_row"]["link_direct_after_active"];
		} else {
			$before = $GLOBALS['template_default']["nav_row"]["link_before"];
			$after  = $GLOBALS['template_default']["nav_row"]["link_after"];
			$direct_before	= $GLOBALS['template_default']["nav_row"]["link_direct_before"];
			$direct_after	= $GLOBALS['template_default']["nav_row"]["link_direct_after"];
		}
		$nav .= $before;
		$nav .= '<a href="index.php?';
		$nav .= ($GLOBALS['content']['struct'][$act_cat_id]['acat_alias']) ? html_specialchars($GLOBALS['content']['struct'][$act_cat_id]['acat_alias']) : 'id='.$act_cat_id.',0,0,1,0,0';
		$nav .= '">'.$direct_before;
		$nav .= html_specialchars($GLOBALS['content']['struct'][$act_cat_id]['acat_name']);
		$nav .= $direct_after.'</a>'.$after;
	}

	// check against breadcrumb - active site tree
	if($GLOBALS['content']['struct'][$GLOBALS['content']["cat_id"]]['acat_struct'] != 0) {
		$breadcrumb = get_breadcrumb($GLOBALS['content']["cat_id"], $GLOBALS['content']['struct']);
	}
	
	foreach($GLOBALS['content']['struct'] as $key => $value) {
		//2005-03-28 Oliver Georgi
		//if($GLOBALS['content']['struct'][$key]["acat_struct"] == $act_cat_id && $key != $act_cat_id && !$GLOBALS['content']['struct'][$key]['acat_hidden']) {
		//also show when selected structure is hidden but is within selected tree
		
		if($GLOBALS['content']['struct'][$key]["acat_struct"] == $act_cat_id && $key != $act_cat_id 
			&& (!$GLOBALS['content']['struct'][$key]['acat_hidden'] 
			|| ((!empty($GLOBALS['template_default']["nav_row"]["show_active_hidden"]) && isset($GLOBALS['LEVEL_KEY'][$key])) ? true : false) )) {
			
			if($nav) {
				$nav .= $GLOBALS['template_default']["nav_row"]["between"];
			}
			
			if($GLOBALS['content']["cat_id"] == $key || isset($breadcrumb[$key])) {
				$before = $GLOBALS['template_default']["nav_row"]["link_before_active"];
				$after  = $GLOBALS['template_default']["nav_row"]["link_after_active"];
				$direct_before	= $GLOBALS['template_default']["nav_row"]["link_direct_before_active"];
				$direct_after	= $GLOBALS['template_default']["nav_row"]["link_direct_after_active"];
			} else {
				$before = $GLOBALS['template_default']["nav_row"]["link_before"];
				$after  = $GLOBALS['template_default']["nav_row"]["link_after"];
				$direct_before	= $GLOBALS['template_default']["nav_row"]["link_direct_before"];
				$direct_after	= $GLOBALS['template_default']["nav_row"]["link_direct_after"];
			}
			
			$nav .= $before;
			
			if(!$GLOBALS['content']['struct'][$key]["acat_redirect"]) {
				$nav .= '<a href="index.php?';
				if($GLOBALS['content']['struct'][$key]["acat_alias"]) {
					$nav .= html_specialchars($GLOBALS['content']['struct'][$key]["acat_alias"]);
				} else {
					$nav .= 'id='.$key.',0,0,1,0,0';
				}
				$nav .= '">';
			} else {
				$redirect = get_redirect_link($GLOBALS['content']['struct'][$key]["acat_redirect"], ' ', '');
				$nav .= '<a href="'.$redirect['link'].'"'.$redirect['target'].'>';
			}
			$nav .= $direct_before;
			$nav .= html_specialchars($GLOBALS['content']['struct'][$key]['acat_name']);;
			$nav .= $direct_after.'</a>'.$after;
		}
	}
	if($nav) {
		$nav  = $GLOBALS['template_default']["nav_row"]["before"].$nav;
		$nav .= $GLOBALS['template_default']["nav_row"]["after"];
	}
	return $nav;
}

// -------------------------------------------------------------


function nav_table_struct ($struct, $act_cat_id, $level, $nav_table_struct, $link_to="index.php") {
	// start with home directory for the listing = top nav structure
	// 1. Build the recursive tree for given actual article category ID
	
	// return the tree starting with given start_id (like breadcrumb)
	// if the $start_id = 0 then this stops because 0 = top level
	
	$level = intval($level);
	$start_id = $act_cat_id;
	$data = array();
	$c = 0;
	$total_levels = 0;
	
	while ($start_id) {
		$data[$start_id] = 1;
		$start_id		 = $struct[$start_id]["acat_struct"];
		$total_levels++;
	}
	
	if(is_array($data) && count($data)) {
		$temp_tree = array_reverse($data, 1);
	} else {
		$temp_tree = false;
	}
	
	foreach($struct as $key => $value) {
		//2005-03-28 Oliver Georgi
		//if($struct[$key]["acat_struct"] == $act_cat_id && $key && !$struct[$key]["acat_hidden"]) {
		//show also when hidden level is on selected tree
		if($struct[$key]["acat_struct"] == $act_cat_id && $key && (!$struct[$key]["acat_hidden"] || isset($GLOBALS['LEVEL_KEY'][$key]))) {
			$c++;
		}
	}
	$c = (!$c) ? 1 : 0;
	
	//get depth of level
	$level_depth = 0;
	$start_level = $level;
	while ($start_level) {
		$start_level = $struct[$start_level]["acat_struct"];
		$level_depth++;
	}
	
	
	//build image src path and real image tag
	//$nav_table_struct["linkimage_norm_js"]   = get_real_imgsrc($nav_table_struct["linkimage_norm"]);
	$nav_table_struct["linkimage_over_js"]   = get_real_imgsrc($nav_table_struct["linkimage_over"]);
	//$nav_table_struct["linkimage_active_js"] = get_real_imgsrc($nav_table_struct["linkimage_active"]);
	
	$nav_table_struct["linkimage_norm"]		= add_linkid($nav_table_struct["linkimage_norm"],   '#');
	$nav_table_struct["linkimage_over"]		= add_linkid($nav_table_struct["linkimage_over"],   '#');
	$nav_table_struct["linkimage_active"]	= add_linkid($nav_table_struct["linkimage_active"], '#');
	
	// create neccessary linkimage_array
	//if(!isset($nav_table_struct['array_struct'])) {
	//	$nav_table_struct['array_struct'] = array();
	//}
	$lc = count($temp_tree);
	for($l = 0; $l <= $lc; $l++) {
	
		if(!isset($nav_table_struct['array_struct'][$l])) {
		
			$nav_table_struct['array_struct'][$l]["linkimage_over_js"]	= $nav_table_struct["linkimage_over_js"];
			$nav_table_struct['array_struct'][$l]["linkimage_norm"]		= $nav_table_struct["linkimage_norm"];
			$nav_table_struct['array_struct'][$l]["linkimage_over"]		= $nav_table_struct["linkimage_over"];
			$nav_table_struct['array_struct'][$l]["linkimage_active"]	= $nav_table_struct["linkimage_active"];

			$nav_table_struct['array_struct'][$l]["row_norm_bgcolor"]	= $nav_table_struct["row_norm_bgcolor"];
			$nav_table_struct['array_struct'][$l]["row_norm_class"]		= $nav_table_struct["row_norm_class"];
			$nav_table_struct['array_struct'][$l]["row_over_bgcolor"]	= $nav_table_struct["row_over_bgcolor"];
			$nav_table_struct['array_struct'][$l]["row_active_bgcolor"]	= $nav_table_struct["row_active_bgcolor"];
			$nav_table_struct['array_struct'][$l]["row_active_class"]	= $nav_table_struct["row_active_class"];
			
			$nav_table_struct['array_struct'][$l]["space_celltop"]		= $nav_table_struct["space_celltop"];
			$nav_table_struct['array_struct'][$l]["space_cellbottom"]	= $nav_table_struct["space_cellbottom"];

			$nav_table_struct['array_struct'][$l]["cell_height"]		= $nav_table_struct["cell_height"];
			$nav_table_struct['array_struct'][$l]["cell_class"]			= $nav_table_struct["cell_class"];
			$nav_table_struct['array_struct'][$l]["cell_active_height"]	= $nav_table_struct["cell_active_height"];
			$nav_table_struct['array_struct'][$l]["cell_active_class"]	= $nav_table_struct["cell_active_class"];
		
		} else {
		
			$nav_table_struct['array_struct'][$l]["linkimage_over_js"]	= get_real_imgsrc($nav_table_struct['array_struct'][$l]["linkimage_over"]);
			$nav_table_struct['array_struct'][$l]["linkimage_norm"]		= add_linkid($nav_table_struct['array_struct'][$l]["linkimage_norm"],   '#');
			$nav_table_struct['array_struct'][$l]["linkimage_over"]		= add_linkid($nav_table_struct['array_struct'][$l]["linkimage_over"],   '#');
			$nav_table_struct['array_struct'][$l]["linkimage_active"]	= add_linkid($nav_table_struct['array_struct'][$l]["linkimage_active"], '#');

		}
	
	}
	$temp_menu = build_levels ($struct, $level, $temp_tree, $act_cat_id, $nav_table_struct, $level_depth, $c, $link_to); //starts at root level
	return ($temp_menu) ? ("<table".table_attributes($nav_table_struct, "table", 0).">\n".$temp_menu."</table>") : "";
}

function get_real_imgsrc($img='') {
	// strips real src attribute from image tag
	if($img) {	
		$img = preg_replace('/.*src=["|\'](.*?)["|\'].*/i', "$1", $img);
	}
	return $img;
}

function add_linkid($img='', $linkid='') {
	//used to add the link ID for js over functions
	$img = preg_replace('/( \/>|>)$/', $linkid."$1", $img);
	return $img;
}

// -------------------------------------------------------------

function build_levels ($struct, $level, $temp_tree, $act_cat_id, $nav_table_struct, $count, $div, $link_to) {
	// this returns the level structure based on given arrays
	// it is special for browsing from root levels
	
	$nav_table_struct["linkimage_over_js"]	= $nav_table_struct['array_struct'][$count]["linkimage_over_js"];
	$nav_table_struct["linkimage_norm"]		= $nav_table_struct['array_struct'][$count]["linkimage_norm"];
	$nav_table_struct["linkimage_over"]		= $nav_table_struct['array_struct'][$count]["linkimage_over"];
	$nav_table_struct["linkimage_active"]	= $nav_table_struct['array_struct'][$count]["linkimage_active"];
	$nav_table_struct["row_norm_bgcolor"]	= $nav_table_struct['array_struct'][$count]["row_norm_bgcolor"];
	$nav_table_struct["row_norm_class"]		= $nav_table_struct['array_struct'][$count]["row_norm_class"];
	$nav_table_struct["row_over_bgcolor"]	= $nav_table_struct['array_struct'][$count]["row_over_bgcolor"];
	$nav_table_struct["row_active_bgcolor"]	= $nav_table_struct['array_struct'][$count]["row_active_bgcolor"];
	$nav_table_struct["row_active_class"]	= $nav_table_struct['array_struct'][$count]["row_active_class"];
	$nav_table_struct["space_celltop"]		= $nav_table_struct['array_struct'][$count]["space_celltop"];
	$nav_table_struct["space_cellbottom"]	= $nav_table_struct['array_struct'][$count]["space_cellbottom"];
	$nav_table_struct["cell_height"]		= $nav_table_struct['array_struct'][$count]["cell_height"];
	$nav_table_struct["cell_class"]			= $nav_table_struct['array_struct'][$count]["cell_class"];
	$nav_table_struct["cell_active_height"]	= $nav_table_struct['array_struct'][$count]["cell_active_height"];
	$nav_table_struct["cell_active_class"]	= $nav_table_struct['array_struct'][$count]["cell_active_class"];
	
	
	$temp_menu	= "";
	$js = "";
	$depth  = sizeof($temp_tree)-$div;
	$current_level = $count;
	$count++; 
	$depth2 = $depth-$count+2;
	
	//$temp_menu .= "\n\n<!------------ level is: ".$current_level." depth: ".sizeof($temp_tree)." current: ".$depth2." -------------- //-->\n\n";
	
	$right_cell = ""; $left_cell = ""; $cell_top = ""; $cell_bottom = ""; $space_right = ""; $space_cell = ""; $space_row = "";
	$cell_height = ($nav_table_struct["cell_height"]) ? $nav_table_struct["cell_height"] : 1;
	if($nav_table_struct["space_right"]) {
		$right_cell  = "<td width=\"".$nav_table_struct["space_left"]."\">";
		$right_cell .= spacer($nav_table_struct["space_right"], $cell_height)."</td>\n";
		$space_right = "<td>".spacer(1, 1)."</td>";
	}
	if($nav_table_struct["space_left"]) {
		$colspan	= ($count > 1) ? " colspan=\"".$count."\"" : "";
		$left_cell	= "<td width=\"".$nav_table_struct["space_left"]."\"".$colspan.">";
		$left_cell .= spacer($nav_table_struct["space_left"], $cell_height)."</td>\n";
		$space_cell = "<td".$colspan.">".spacer(1, 1)."</td><td>".spacer(1, 1)."</td>";
	} else {
		if($count > 1) {
			$colspan	= ($count > 2) ? " colspan=\"".($count-1)."\"" : "";
			$left_cell	= "<td ".$colspan.">".spacer(1, 1)."</td>\n";
			$space_cell = "<td".$colspan.">".spacer(1, 1)."</td><td>".spacer(1, 1)."</td>";
		}
	}
	if($nav_table_struct["space_celltop"]) $cell_top = spacer(1, $nav_table_struct["space_celltop"])."<br />";
	if($nav_table_struct["space_cellbottom"]) $cell_bottom = "<br />".spacer(1, $nav_table_struct["space_cellbottom"]);
	
	$colspan	= ($depth2 > 1) ? " colspan=\"".$depth2."\"" : "";
	
	foreach($struct as $key => $value) {
		
		if(isset($_SESSION["frontend_user_in"]) && $struct[$key]["acat_regonly"]) {
			$struct[$key]["acat_regonly"] = 0;
		}
		//2005-03-28 Oliver Georgi
		//enahced for display also when hidden but within selected tree
		if($struct[$key]["acat_struct"] == $level && $key && (!$struct[$key]["acat_hidden"] || isset($GLOBALS['LEVEL_KEY'][$key])) && !$struct[$key]["acat_regonly"]) {
		
			$link_image_id	= "linkid".randpassword(6);
			$link_name_id 	= ' name="'.$link_image_id.'" id="'.$link_image_id.'"';
						
			if(!$struct[$key]["acat_redirect"]) {
				$link = 'index.php?';
				if($struct[$key]["acat_alias"]) {
					$link .= html_specialchars($struct[$key]["acat_alias"]);
				} else {
					$link .= 'id='.$key.',0,0,1,0,0';
				}
				$redirect['target'] = '';
			} else {
				$redirect = get_redirect_link($struct[$key]["acat_redirect"], ' ', '');
				$link = $redirect['link'];
			}
			
			$js		= ' style="cursor:pointer;cursor:hand;"'; //display:block;
			$js_act = $js;
			if($nav_table_struct["js_over_effects"]) {
			
				if($redirect['target'] != ' target="_blank"') {
					$js .= " onClick=\"location.href='".js_singlequote($link)."';return false;\"";
				} else {
					$js .= " onClick=\"window.open('".js_singlequote($link)."', 'phpwcmnewwin');return false;\"";
				}
				
				$js_act = $js;
				$js .= ' onMouseOver="';
				if($nav_table_struct["linkimage_over_js"]) {
					$js .= "MM_swapImage('".$link_image_id."','','".$nav_table_struct["linkimage_over_js"]."',1);";
				}
				if($nav_table_struct["row_over_bgcolor"]) $js .= "this.bgColor='".$nav_table_struct["row_over_bgcolor"]."';";
				$js .= '" onMouseOut="';
				if($nav_table_struct["linkimage_over_js"]) $js .= "MM_swapImgRestore();";
				if($nav_table_struct["row_norm_bgcolor"]) $js .= "this.bgColor='".$nav_table_struct["row_norm_bgcolor"]."';";
				$js .= '"';
			} else {
				$js = '';
			}
			
			//spacer row
			if($nav_table_struct["row_space"]) {
				$space_row  = "<tr".table_attributes($nav_table_struct, "row_space", 0, true).">\n".$space_cell;
				$space_row .= "<td".$colspan.">".spacer(1, $nav_table_struct["row_space"])."</td>";
				$space_row .= $space_right."\n</tr>\n";
				$temp_menu .= $space_row;
			}
			
			if(!empty($temp_tree[$key])) {
				//if($act_cat_id == $key) {
				//check if inside active tree structure
				if($act_cat_id == $key || (!empty($nav_table_struct["all_nodes_active"]) && isset($GLOBALS['LEVEL_KEY'][$key]))) {
					$temp_menu .= "<tr".table_attributes($nav_table_struct, "row_active", 0, true).$js_act.">\n".$left_cell;
					$temp_menu .= "<td valign=\"top\">".str_replace('#', $link_name_id, $nav_table_struct["linkimage_active"])."</td>\n";
					$temp_menu .= "<td".table_attributes($nav_table_struct, "cell_active", 1, true).$colspan.">".$cell_top;				
					$temp_menu .= '<a href="'.$link.'"'.$redirect['target'].'>'.html_specialchars($struct[$key]["acat_name"]).'</a>';
				} else {
					$temp_menu .= "<tr".table_attributes($nav_table_struct, "row_norm", 0, true).$js.">\n".$left_cell;
					$temp_menu .= "<td valign=\"top\">".str_replace('#', $link_name_id, $nav_table_struct["linkimage_norm"])."</td>\n";
					$temp_menu .= "<td".table_attributes($nav_table_struct, "cell", 1, true).$colspan.">".$cell_top;				
					$temp_menu .= '<a href="'.$link.'"'.$redirect['target'].'>'.html_specialchars($struct[$key]["acat_name"])."</a>";
				}
				
				$temp_menu .= $cell_bottom."</td>\n".$right_cell."</tr>\n";
				$temp_menu .= build_levels ($struct, $key, $temp_tree, $act_cat_id, $nav_table_struct, $count, $div, $link_to);
			} else {
				$temp_menu .= "<tr".table_attributes($nav_table_struct, "row_norm", 0, true).$js.">\n".$left_cell;
				$temp_menu .= "<td valign=\"top\">".str_replace('#', $link_name_id, $nav_table_struct["linkimage_norm"])."</td>\n";
				$temp_menu .= "<td".table_attributes($nav_table_struct, "cell", 1, true).$colspan.">".$cell_top;
				$temp_menu .= '<a href="'.$link.'"'.$redirect['target'].'>'.html_specialchars($struct[$key]["acat_name"])."</a>";
				$temp_menu .= $cell_bottom."</td>\n".$right_cell."</tr>\n";
			}
		}
	}
	
	if($nav_table_struct["row_space"] && $count == 1) {
		$temp_menu .= $space_row;
	}
	
	
	
	return $temp_menu;
}

// -------------------------------------------------------------

function list_articles_summary ($article_list, $template_default, $cat_id=0) {
	// returns an article listing only with headline and summary text
	// and with an listing of all other available articles of this category
	
	$listing = $template_default["space_top"]; //start with space at top
	
	$tmpllist = array(); //temporary array for storing templates to minimize load
	
	$temp_topcount = $GLOBALS['content']['struct'][ $GLOBALS['content']['cat_id'] ]['acat_topcount'];
	
	$temp_counter = 0;
	foreach($article_list as $key => $value) {
		
		//$article_link  = $link_to."?id=".$cat_id.",".$article_list[$key]["article_id"].",0,0,1,0";
		$article_link  = "index.php?id=".$article_list[$key]["article_cid"].",".$article_list[$key]["article_id"].",0,0,1,0";
		
		//add available keywords to page wide keyword field
		$GLOBALS['content']['all_keywords'] .= $article_list[$key]["article_keyword"].',';
		
		//if($temp_counter < $template_default["top_count"]) {
		if($temp_counter < $temp_topcount) {
			// as long as the counter is lower than the default "top_count" value
			// show the complete article summary listing
			
			// build image/image link
			$article_list[$key]["article_image"]["poplink"] = '';
			$thumb_image = false;
			$thumb_img = '';
			
			if(!empty($article_list[$key]["article_image"]["caption"])) {
				$caption	= explode('|', $article_list[$key]["article_image"]["caption"]);
			} else {
				$caption[0] = '';
			}
			$article_list[$key]["article_image"]["caption"] = $caption[0]; //$caption[0]
			
			if(!empty($article_list[$key]["article_image"]["hash"])) {
			
				$thumb_image = get_cached_image(
									array(	"target_ext"	=>	$article_list[$key]["article_image"]['ext'],
											"image_name"	=>	$article_list[$key]["article_image"]['hash'] . '.' . $article_list[$key]["article_image"]['ext'],
											"max_width"		=>	$article_list[$key]["article_image"]['width'],
											"max_height"	=>	$article_list[$key]["article_image"]['height'],
											"thumb_name"	=>	md5($article_list[$key]["article_image"]['hash'].$article_list[$key]["article_image"]['width'].$article_list[$key]["article_image"]['height'].$GLOBALS['phpwcms']["sharpen_level"])
        							  ));
								
				if($thumb_image != false) {
				
					$caption[1] = (!isset($caption[1])) ? '' : html_specialchars($caption[1]);
					if(!isset($caption[2])) {
						$caption[2] = array('',' target="_blank"');
					} else {
						//proof target of link
						$caption[2] = explode(' ', trim($caption[2]));
						$caption[2][1] = (!isset($caption[2][1])) ? '' : ' target="'.$caption[2][1].'"';
					}
				
					$thumb_img = '<img src="'.PHPWCMS_IMAGES . $thumb_image[0] .'" border="0" '.$thumb_image[3].' alt="'.$caption[1].'" title="'.$caption[1].'">';
						
					if($article_list[$key]["article_image"]["zoom"]) {
						
						$zoominfo = get_cached_image(
											array(	"target_ext"	=>	$article_list[$key]["article_image"]['ext'],
													"image_name"	=>	$article_list[$key]["article_image"]['hash'] . '.' . $article_list[$key]["article_image"]['ext'],
													"max_width"		=>	$GLOBALS['phpwcms']["img_prev_width"],
													"max_height"	=>	$GLOBALS['phpwcms']["img_prev_height"],
													"thumb_name"	=>	md5($article_list[$key]["article_image"]['hash'].$GLOBALS['phpwcms']["img_prev_width"].$GLOBALS['phpwcms']["img_prev_height"].$GLOBALS['phpwcms']["sharpen_level"])
        					  						)
												);
						
						if($zoominfo != false) {
						
							$article_list[$key]["article_image"]["poplink"] =	'image_zoom.php?show='.base64_encode($zoominfo[0].'?'.$zoominfo[3]);
							
							if(!empty($caption[2][0])) {
								$open_link = $caption[2][0];
								$return_false = '';
							} else {
								$open_link = $article_list[$key]["article_image"]["poplink"];
								$return_false = 'return false;';
							}
							
							$article_list[$key]["article_image"]["poplink"] =	'<a href="'.$article_list[$key]["article_image"]["poplink"].'" '.
																	 			//'onClick="window.open(\''.$open_link.
																				'onClick="checkClickZoom();clickZoom(\''.$open_link.
																				"','previewpic','width=".$zoominfo[1].
																				",height=".$zoominfo[2]."');".$return_false.
																				'"'.$caption[2][1].'>'.$thumb_img.'</a>';
						}
						
						unset($caption);
						
					}
				
				}
			
			}
			
			
		
			// article list based template check
			if(!empty($article_list[$key]["article_image"]['tmpllist']) && $article_list[$key]["article_image"]['tmpllist']!='default') {
				// try to read the template files
				// 1. try to check if template was read
				if(!isset($tmpllist[ $article_list[$key]["article_image"]['tmpllist'] ])) {
					$tmpllist[ $article_list[$key]["article_image"]['tmpllist'] ] = include_ext_php(PHPWCMS_ROOT.$GLOBALS['phpwcms']['templates'].'inc_cntpart/articlesummary/list/'.$article_list[$key]["article_image"]['tmpllist'], 1);
				}
				if($tmpllist[ $article_list[$key]["article_image"]['tmpllist'] ]) {
					//rendering
					$tmpl = $tmpllist[ $article_list[$key]["article_image"]['tmpllist'] ];
					$tmpl = render_cnt_template($tmpl, 'TITLE', html_specialchars($article_list[$key]["article_title"]));
					$tmpl = render_cnt_template($tmpl, 'SUB', html_specialchars($article_list[$key]["article_subtitle"]));
					$tmpl = render_cnt_template($tmpl, 'SUMMARY', $article_list[$key]["article_summary"]);
					$tmpl = render_cnt_template($tmpl, 'IMAGE', $thumb_img);
					$tmpl = render_cnt_template($tmpl, 'ZOOMIMAGE', $article_list[$key]["article_image"]["poplink"]);
					$tmpl = render_cnt_template($tmpl, 'CAPTION', nl2br(html_specialchars($article_list[$key]["article_image"]["caption"])));
					$tmpl = render_cnt_template($tmpl, 'ARTICLELINK', $article_link);
					$tmpl = render_cnt_template($tmpl, 'EDITOR', html_specialchars($article_list[$key]["article_username"]));
					$tmpl = render_cnt_template($tmpl, 'ARTICLEID', $article_list[$key]["article_id"]);					
					$tmpl = render_cnt_template($tmpl, 'MORE', $template_default["top_readmore_link"]);
					$tmpl = render_cnt_template($tmpl, 'BEFORE', '<!--before//-->');
					$tmpl = render_cnt_template($tmpl, 'AFTER', '<!--after//-->');
					$tmpl = render_cnt_date($tmpl, $article_list[$key]["article_date"]);
					if($temp_counter) {
						$tmpl = render_cnt_template($tmpl, 'SPACE', '<!--space//-->');
					} else {
						$tmpl = render_cnt_template($tmpl, 'SPACE', '');
					}
					$listing .= $tmpl;
					$article_list[$key]["article_image"]['tmpllist'] = 1;
				} else {
					$article_list[$key]["article_image"]['tmpllist'] = 0;
				}
			}
			
			if (empty($article_list[$key]["article_image"]['tmpllist']) || $article_list[$key]["article_image"]['tmpllist'] == 'default') {
			
				$listing .= $template_default["top_listentry_before"];
			
				// space between summary listings
				if($temp_counter) {
					$listing .= $template_default["space_between_sum"];
				}
			
				if($article_list[$key]["article_title"] && !$article_list[$key]["article_notitle"]) {
					//$listing .= get_html_part($article_list[$key]["article_title"], $template_default["top_headline_class"], $article_link);
					$listing .= $template_default["top_headline_before"];
					if($article_list[$key]["article_morelink"]) {
						$listing .= '<a href="'.$article_link.'">';
						$listing .= html_specialchars($article_list[$key]["article_title"]);
						$listing .= '</a>';
					} else {
						$listing .= html_specialchars($article_list[$key]["article_title"]);
					}
					$listing .= $template_default["top_headline_after"];
					$listing .= $template_default["top_headline_space"];
				}
				if($article_list[$key]["article_subtitle"]) {
					//$listing .= get_html_part($article_list[$key]["article_subtitle"], $template_default["top_subheadline_class"], $article_link);
					$listing .= $template_default["top_subheadline_before"];
					if($article_list[$key]["article_morelink"]) {
						$listing .= '<a href="'.$article_link.'">';
						$listing .= html_specialchars($article_list[$key]["article_subtitle"]);
						$listing .= '</a>';
					} else {
						$listing .= html_specialchars($article_list[$key]["article_subtitle"]);
					}
					$listing .= $template_default["top_subheadline_after"];
					$listing .= $template_default["top_subheadline_space"];
				}
				if($article_list[$key]["article_summary"] || !empty($article_list[$key]["article_image"]['cname'])) {
					//$listing .= "<span class=\"".$template_default["top_text_class"]."\">";
					$listing .= $template_default["top_text_before"];
				
					//build image table when image available
					if(!empty($thumb_img)) {
						$listing .= '<table width="1%" cellspacing="0" border="0" cellpadding="0" align="left" ';
						if($template_default["article"]["image_table_bgcolor"]) {
							$listing .= 'bgcolor="'.$template_default["article"]["image_table_bgcolor"].'" ';
						}
						$listing .= 'style="float:left;margin:2px 5px 3px 0;">';
						$listing .= "\n<tr><td";
						if($template_default["article"]["image_class"]) {
							$listing .= ' class="'.$template_default["article"]["image_class"].'"';
						}
						$listing .= '>';
						if($article_list[$key]["article_morelink"]) {
							$listing .= '<a href="'.$article_link.'">'.$thumb_img."</a>";
						} else {
							$listing .= $thumb_img;
						}
						$listing .= "</td></tr>\n";
						
						if($article_list[$key]["article_image"]["caption"]) {
							//$listing .= '<tr><td><img src="img/leer.gif" alt="" width="1" height="3"></td></tr>';
							$listing .= "\n<tr><td";
							if($template_default["article"]["image_caption_class"]) {
								$listing .= ' class="'.$template_default["article"]["image_caption_class"].'"';
							}
							if($template_default["article"]["image_caption_bgcolor"]) {
								$listing .= ' bgcolor="'.$template_default["article"]["image_caption_bgcolor"].'"';
							}
							if($template_default["article"]["image_caption_valign"]) {
								$listing .= ' valign="'.$template_default["article"]["image_caption_valign"].'"';
							}
							if($template_default["article"]["image_caption_align"]) {
								$listing .= ' align="'.$template_default["article"]["image_caption_align"].'"';
							}
							$listing .= '>';
							$listing .= $template_default["article"]["image_caption_before"];
							$listing .= nl2br(html_specialchars($article_list[$key]["article_image"]["caption"]));
							$listing .= $template_default["article"]["image_caption_after"];
							$listing .= "</td></tr>\n";
						}
						$listing .= '</table>';
					}
				
					$listing .= $article_list[$key]["article_summary"];
					if($article_list[$key]["article_morelink"]) {
						$listing .= $template_default["top_readmore_before"];
						$listing .= '<a href="'.$article_link.'">';
						$listing .= $template_default["top_readmore_link"];
						$listing .= '</a>'.$template_default["top_readmore_after"];
					}
					$listing .= $template_default["top_text_after"];
				}			
				$listing .= $template_default["top_listentry_after"];
			}
		
		} else { 
			// if "top_count" value is equal or larger
			// show only the article headline listing
			//if($temp_counter && $temp_counter == $template_default["top_count"]) {
			if($temp_counter && $temp_counter == $temp_topcount) {
				$listing .= $template_default["space_aftertop_text"];
			} elseif ($temp_counter) {
				$listing .= $template_default["space_between_list"];
			}
			$listing .= $template_default["list_headline_before"];
			$listing .= '<a href="'.$article_link.'">';
			$listing .= $template_default["list_startimage"];
			//$listing .= get_html_part($article_list[$key]["article_title"], $template_default["list_headline_class"]);
			$listing .= html_specialchars($article_list[$key]["article_title"]);
			$listing .= '</a>'.$template_default["list_headline_after"];
		
		}
		$temp_counter++;
	}
	
	$listing .= $template_default["space_bottom"]; //ends with space at bottom
	return str_replace("<br /><br />", "<br />", $listing);
}

// -------------------------------------------------------------

function get_html_part($value, $class="", $link="", $span_or_div=1) {
	// returns a content part for html output like
	// <span class="xxx">html</span>
	if($value) {
		$html_tag  = ($span_or_div) ? 'span' : 'div';
		$html_part = ($link) ? '<a href="'.$link.'">'.html_specialchars($value).'</a>' : html_specialchars($value);
		if($class) {
			$html_part = '<'.$html_tag.' class="'.$class.'">'.$html_part;
		} else {
			$html_part = '<'.$html_tag.'>'.$html_part;
		}
		return $html_part.'</'.$html_tag.'>';
	} else {
		return '';
	}
}

// -------------------------------------------------------------

function span_class($value, $class) {
	return !empty($class) ? '<span class="'.$class.'">'.$value.'</span>' : $value;
}

// -------------------------------------------------------------

function div_class($value, $class, $tag='div') {
	return !empty($class) ? '<'.$tag.' class="'.$class.'">'.$value.'</'.$tag.'>' : $value;
}

// -------------------------------------------------------------

function get_class_attrib($class) {
	return !empty($class) ? ' class="'.$class.'"' : '';
}

// -------------------------------------------------------------

function html_parser($string) {
	// parse the $string and replace all possible
	// values with $replace
	
	// page TOP link
	$search[0]		= '/\[TOP\](.*?)\[\/TOP\]/i';
	$replace[0]		= '<a href="#top">$1</a>';
	
	// internal Link to category alias (string)
	$search[1]		= '/\[ID (\w+)\](.*?)\[\/ID\]/';
	$replace[1]		= '<a href="index.php?$1">$2</a>';
	
	// external Link (string)
	$search[2]		= '/\[EXT (.*?)\](.*?)\[\/EXT\]/';
	$replace[2]		= '<a href="$1" target="_blank">$2</a>';
	
	// internal Link (string)
	$search[3]		= '/\[INT (.*?)\](.*?)\[\/INT\]/';
	$replace[3]		= '<a href="$1" target="_top">$2</a>';
	
	// random GIF Image
	$search[4]		= '/\{RANDOM_GIF:(.*?)\}/';
	$replace[4]		= '<img src="img/random_image.php?type=0&imgdir=$1" border="0" alt="" />';
	
	// random JPEG Image
	$search[5]		= '/\{RANDOM_JPEG:(.*?)\}/';
	$replace[5]		= '<img src="img/random_image.php?type=1&amp;imgdir=$1" border="0" alt="" />';
	
	// random PNG Image
	$search[6]		= '/\{RANDOM_PNG:(.*?)\}/';
	$replace[6]		= '<img src="img/random_image.php?type=2&amp;imgdir=$1" border="0" alt="" />';
	
	// insert non db image standard
	$search[7]		= '/\{IMAGE:(.*?)\}/';
	$replace[7]		= '<img src="picture/$1" border="0" alt="" />';
	
	// insert non db image left
	$search[8]		= '/\{IMAGE_LEFT:(.*?)\}/';
	$replace[8]		= '<img src="picture/$1" border="0" align="left" alt="" />';
	
	// insert non db image right
	$search[9]		= '/\{IMAGE_RIGHT:(.*?)\}/';
	$replace[9]		= '<img src="picture/$1" border="0" align="right" alt="" />';
	
	// insert non db image center
	$search[10]		= '/\{IMAGE_CENTER:(.*?)\}/';
	$replace[10]		= '<div align="center"><img src="picture/$1" border="0" alt="" /></div>';
	
	// insert non db image right
	$search[11]	 	= '/\{SPACER:(\d+)x(\d+)\}/';
	$replace[11] 	= '<img src="img/leer.gif" border="0" width="$1" height="$2" alt="" />';
	
	// RSS feed link based on structure (category) ID
	$search[12]		= '/\[RSS (\d+)\](.*?)\[\/RSS\]/';
	$replace[12]	= '<a href="rss.php?rssfeed=$1" target="_blank">$2</a>';
	
	// RSS feed link based on structure (category) ALIAS
	$search[13]		= '/\[RSS (\w+)\](.*?)\[\/RSS\]/';
	$replace[13]	= '<a href="rss.php?$1" target="_blank">$2</a>';
	
	// back Link (string)
	$search[14]		= '/\[BACK\](.*?)\[\/BACK\]/i';
	$replace[14] 	= '<a href="javascript:history.back();" target="_top" title="go back">$1</a>';
	
	// random Image Tag
	$search[15]		= '/\{RANDOM:(.*?)\}/e';
	$replace[15]	= 'get_random_image_tag("$1");';

	// span or div style
	$search[16]		= '/\[(span|div)_style:(.*?)\](.*?)\[\/style\]/s';
	$replace[16]	= '<$1 style="$2">$3</$1>';
	
	// span or div class
	$search[17]		= '/\[(span|div)_class:(.*?)\](.*?)\[\/class\]/s';
	$replace[17]	= '<$1 class="$2">$3</$1>';
	
	// typical html formattings
	$search[18]		= '/\[i\](.*?)\[\/i\]/is';			$replace[18]	= '<i>$1</i>';
	$search[19]		= '/\[u\](.*?)\[\/u\]/is';			$replace[19]	= '<u>$1</u>';
	$search[20]		= '/\[s\](.*?)\[\/s\]/is';			$replace[20]	= '<strike>$1</strike>';
	$search[21]		= '/\[b\](.*?)\[\/b\]/is';			$replace[21]	= '<strong>$1</strong>';
	
	// anchor link
	$search[22]		= '/\{A:(.*?)\}/is';
	$replace[22]	= '<a name="$1"></a>';
	
	// this pharses out an E-Mail Link without subject (by Florian, 21-11-2003)
	$search[23]     = '/\[MAIL (.*?)\](.*?)\[\/MAIL\]/i';
	$replace[23]    = '<a href="mailto:$1">$2</a>'; 
    
	// this tags out a Mailaddress with an predifined subject (by Florian, 21-11-2003)
	$search[24]     = '/\[MAILSUB (.*?) (.*?)\](.*?)\[\/MAILSUB\]/i';
	$replace[24]    = '<a href="mailto:$1?subject=$2">$3</a>';
	
	// added simple [br] -> <br />
	$search[25]     = '/\[br\]/i';
	$replace[25]    = '<br />';
	
	// create "make bookmark" javascript code
	$search[26]     = '/\[BOOKMARK\s{0,}(.*)\](.*?)\[\/BOOKMARK\]/i';
	$replace[26]    = '<a href="#" onClick="BookMark_Page();return false;" title="$1">$2</a>';
	
	$string = preg_replace($search, $replace, $string);
	$string = str_replace('&#92;&#039;', '&#039;', $string);
	$string = str_replace('&amp;quot;', '&quot;', $string);
	return $string;
}

// -------------------------------------------------------------

function include_ext_php($inc_file, $t=0) {
	// includes an external PHP script file and returns
	// the result as string from buffered include content
	$ext_php_content = '';
	
	//check if this is a local file
	if(is_file($inc_file)) {
	
		if(!$t) {
			$this_path = str_replace("\\", '/', dirname(realpath($inc_file)));
			$this_path = preg_replace('/\/$/', '', $this_path);
		
			$root_path = str_replace("\\", '/', realpath(PHPWCMS_ROOT));
			$root_path = preg_replace('/\/$/', '', $root_path);
			
			if(strpos($this_path, $root_path) === 0) $t = 1;
		}
	} else {
		
		if(!$t) {
			//if remote URL is allowed in conf.inc.php
			if(intval($GLOBALS['phpwcms']['allow_remote_URL'])) $t = 1;
		}
		
	}
	
	if($t) {
		ob_start();
		@include($inc_file);
		$ext_php_content = ob_get_contents();
		ob_end_clean();
	}
	
	return $ext_php_content;
}

// -------------------------------------------------------------

function international_date_format($language="EN", $format="Y/m/d", $date_now=0) {
	// formats the given date
	// for the specific language
	// use the normal date format options
	
	if(!$format) $format = "Y/m/d";
	if(!intval($date_now)) $date_now = time();
	if($language == "EN" || !$language) {
		$date = date($format, $date_now);
	} else {
		$lang_include = PHPWCMS_ROOT.'/include/inc_lang/date/'.strtolower($language).'.date.lang.php';
		if(file_exists($lang_include)) {
		
			include($lang_include);
			$date_format_function = array (	"a" => 1, "A" => 1, "B" => 1, "d" => 1, "g" => 1, "G" => 1, 
									"h" => 1, "H" => 1, "i" => 1, "I" => 1, "j" => 1, "m" => 1,
									"n" => 1, "s" => 1, "t" => 1, "T" => 1, "U" => 1, "w" => 1, 
									"Y" => 1, "y" => 1, "z" => 1, "Z" => 1,									
									"D" => 0, "F" => 0, "l" => 0, "M" => 0, "S" => 0
								   );
			
			$str_length = strlen($format); $date = "";
			for($i = 0; $i < $str_length; $i++) $date_format[$i] = substr($format, $i, 1);		
			foreach($date_format as $key => $value) {
				if(isset($date_format_function[$value])) {
					if($date_format_function[$value]) {
						$date .= date($value, $date_now);
					} else{
						switch($value) {
							case "D":	$date .= $weekday_short[ intval(date("w", $date_now)) ]; break; //short weekday name
							case "l":	$date .= $weekday_long[ intval(date("w", $date_now)) ]; break; //long weekday name
							case "F":	$date .= $month_long[ intval(date("n", $date_now)) ]; break; //long month name
							case "M":	$date .= $month_short[ intval(date("n", $date_now)) ]; break; //long month name
							case "S":	$date .= ""; break;
						}
					}
				} else {
					$date .= $value;
				}		
			}
			
		} else {
			$date = date($format, $date_now);
		}
	}
	return $date;
}

// -------------------------------------------------------------

function get_random_image_tag($path) {
	// returns an random image from the give path
	// it looks for image of following type:
	// gif, jpg, jpeg, png

	$imgArray = array();
	$imgpath = str_replace("//", "/", PHPWCMS_ROOT."/".$path."/");
	$imageinfo = false;

	if(is_dir($imgpath)) {
		$handle = opendir( $imgpath );
		while($file = readdir( $handle )) {
   			if( $file != "." && $file != ".." ) {
				if( preg_match('/(\.jpg|\.jpeg|\.gif|\.png)$/', strtolower($file)) ) $imgArray[] = $file;
			}
		}
		closedir( $handle );
	}
	
	if(sizeof($imgArray)) $imageinfo = is_random_image($imgArray, $imgpath);
	//return $imageinfo;
	return ($imageinfo) ?	"<img src=\"".$path."/".$imageinfo["imagename"].
							"\" ".$imageinfo[3]." border=\"0\" alt=\"".
							$imageinfo["imagename"]."\" />"
							: "";	
}

// -------------------------------------------------------------

function is_random_image($imgArray, $imagepath, $count=0) {
	// tests if the random choosed image is really an image
	$count++;
	mt_srand( (double)microtime( ) * 1000000 );
	$randval = mt_rand( 0, sizeof( $imgArray ) - 1 );
	$file = $imagepath.$imgArray[ $randval ];
	//gets -> better tests for image info
	$imageinfo = @getimagesize($file);
	//if $imageinfo is not true repeat function and count smaller count all images
	if(!$imageinfo) {
		if($count < sizeof($imgArray)) $imageinfo = is_random_image($imgArray, $imagepath, $count);
	} else {
		$imageinfo["imagename"] = $imgArray[ $randval ];
	}
	return $imageinfo;
}

// -------------------------------------------------------------

function return_struct_level($struct, $struct_id) {
	// walk through the given struct level and returns an array with available levels
	if(sizeof($struct)) {
		$level_entry = array();
		foreach($struct as $key => $value) {
			if($key && $struct[$key]["acat_struct"] == $struct_id && !$struct[$key]["acat_hidden"]) {
				$level_entry[$key] = $value;
			}
		}
	}
	return $level_entry;
}

// -------------------------------------------------------------

function get_active_categories($struct, $act_struct_id) {
	// returns an array with all active categories/structure levels
	
	$which_cat_array = array();
	$which_category = $act_struct_id;
	while($which_category) {
		$which_cat_array[$which_category] = 1;
		$which_category = $GLOBALS['content']["struct"][$which_category]["acat_struct"];
	}
	return $which_cat_array;
}

// -------------------------------------------------------------

function css_list_top($struct, $struct_path, $homelink='', $class="list_top") {
	// returns list <div><ul><li></li></ul></div> of level 0
	// if $homelink is not empty it will also create a "Home" link
	// you can set $homelink to the name you like
	// predefined class for this menu is "list_top"	
	
	$link_to = "index.php";
	if(!trim($class)) $class = "list_top";
	$homelink = trim($homelink);
	if(!$homelink) {
		$homelink = $GLOBALS['template_default']["article"]["index_name"];
		if(!$homelink) $homelink = 'Home';
	}	
	$activated = 0; //no active list set
	$css_list = "";
	
	//returns the complete top level AND home of NON hidden categories
	$top_struct = return_struct_level($struct, 0);
	
	// enhancement by cyrilo
	// 17-05-2004 (http://www.phpwcms.de/forum/viewtopic.php?p=12149#12149)
	$breadcrumb = get_breadcrumb(key($struct_path), $struct);
	
	
	if(sizeof($top_struct)) {
		foreach($top_struct as $key => $value) {
		
			if(!$top_struct[$key]["acat_redirect"]) {
				$link = 'index.php?';
				if($top_struct[$key]["acat_alias"]) {
					$link .= html_specialchars($top_struct[$key]["acat_alias"]);
				} else {
					$link .= 'id='.$key.',0,0,1,0,0';
				}
				$redirect['target'] = '';
			} else {
				$redirect = get_redirect_link($top_struct[$key]["acat_redirect"], ' ', '');
				$link = $redirect['link'];
			}
		
			//$link  = 'index.php?';
			//$link .= ($top_struct[$key]["acat_alias"]) ? html_specialchars($top_struct[$key]["acat_alias"]) : "id=".$key.",0,0,1,0,0";
			$css_list .= "    <li";
			//cyrilo, 17-05-2004
			//if($struct_path[$key]) {
			if(!empty($breadcrumb[$key])) {
				$css_list .= ' id="'.$class.'_active"';
				$activated = 1;
			}
			$css_list .= '><a href="'.$link.'"';
			//cyrilo, 17-05-2004
			//$css_list .= (!$struct_path[$key]) ? "" : " id=\"".$class."_active_link\"";
			if(!empty($breadcrumb[$key])) $css_list .= ' id="'.$class.'_active_link"';
			$css_list .= $redirect['target'].'>';
			$css_list .= html_specialchars($top_struct[$key]["acat_name"]).'</a>';
			$css_list .= "</li>\n";
		}
	}
	
	if($homelink) {
		$css_list_home  = "    <li id=\"".$class. ((!$activated) ? "_home_active" : "_home") ."\">";
		$css_list_home .= '<a href="index.php?index"';
		if(!$activated) {
			$css_list_home .= ' id="'.$class.'_home_active_link"';
		}
		$css_list_home .= '>'.html_specialchars($homelink)."</a>";
		$css_list_home .= "</li>\n";
		$css_list = $css_list_home . $css_list;
	}
	if($css_list) {
		$css_list = "<div id=\"".$class."\">\n  <ul id=\"".$class."_ul\">\n". $css_list ."  </ul>\n</div>";
	}
	return $css_list;
}

// -------------------------------------------------------------

function css_list_current_level($struct, $struct_path, $level, $parent_level_name="", $parent_level=1, $class="list_level", $link_to="index.php") {
	// returns list <div><ul><li></li></ul></div> of the current structure level
	// if $parent_level=1 the first list entry will be the parent level
	// $parent_level=0 - only the list of all levels in this structure
	// if $parent_leve_name != "" then it uses the given string
	// predefined class for this menu is "list_level"	
	
	if(!trim($class)) $class = "list_level";
	$parent_level_name = trim($parent_level_name);
	$level = intval($level);
	$parent_level = intval($parent_level);
	$activated = 0; //no active list set
	$css_list = "";
	
	//returns the complete level of NON hidden categories
	$level_struct = return_struct_level($struct, $level); 

	if(sizeof($level_struct)) {
		foreach($level_struct as $key => $value) {
			
			if(!$level_struct[$key]["acat_redirect"]) {
				$link = 'index.php?';
				if($level_struct[$key]["acat_alias"]) {
					$link .= html_specialchars($level_struct[$key]["acat_alias"]);
				} else {
					$link .= 'id='.$key.',0,0,1,0,0';
				}
				$redirect['target'] = '';
			} else {
				$redirect = get_redirect_link($level_struct[$key]["acat_redirect"], ' ', '');
				$link = $redirect['link'];
			}
			$css_list .= '    <li><a href="'.$link.'"'.$redirect['target'].'>';
			$css_list .= html_specialchars($level_struct[$key]["acat_name"])."</a>";
			$css_list .= "</li>\n";

		}
	}
	
	if($parent_level && $level) {
		$css_list_home  = '    <li id="'.$class.'_parent">';
		$css_list_home .= '<a href="'.$link_to.'?id='.$struct[$level]["acat_struct"];
		$css_list_home .= ',0,0,1,0,0" id="'.$class.'_parent_link">';
		$css_list_home .= html_specialchars((!$parent_level_name) ? $struct[$level]["acat_name"] : $parent_level_name);
		$css_list_home .= "</a></li>\n";
		$css_list = $css_list_home . $css_list;
	}
	if($css_list) {
		$css_list = "<div id=\"".$class."\">\n  <ul id=\"".$class."_ul\">\n". $css_list ."  </ul>\n</div>";
	}
	return $css_list;
}

// -------------------------------------------------------------

// REWRITE - PATCHED FOR 04/04 // jan212
function url_search($query) { 
	if ( substr($query,0,4) == '?id=') { 
		$noid = substr($query, 4); 
		//$file = str_replace(',', '.', $noid).'.html'; 
		$file = str_replace(',', '.', $noid).'.phtml'; 
		//$file = $noid.'.phtml'; 
	} else { 
		$noid = substr($query,1); 
		//$file = str_replace(',', '.', $noid).'.html'; 
		$file = str_replace(',', '.', $noid).'.phtml';
		//$file = $noid.'.phtml'; 
	} 
	$link = ' href="'.$file.'"'; 
	return($link); 
} 

function js_url_search($query) { 
	if ( substr($query,0,4) == '?id=') { 
		$noid = substr($query, 4);
		//$file = str_replace(',', '.', $noid).'.html'; 
		$file = str_replace(',', '.', $noid).'.phtml';
		$file = $noid.'.phtml'; 
	} else { 
		$noid = substr($query,1); 
		//$file = str_replace(',', '.', $noid).'.html';
		$file = str_replace(',', '.', $noid).'.phtml';
		$file = $noid.'.phtml';
	} 
	$link = "onClick=\"location.href='".$file."'"; 
	return($link); 
} 

// -------------------------------------------------------------

function get_related_articles($keywords, $current_article_id, $template_default, $max_cnt_links=0, $dbcon) {
	// find keyword for current article used for RELATED replacementtag
	// prepared and inspired by Magnar Stav Johanssen

	$keyword_links = ""; 
	$max_cnt_links = intval($max_cnt_links);
	
	$keywords = str_replace("ALLKEYWORDS", $GLOBALS['content']['all_keywords'].',', $keywords);
	
	// replace unwanted chars and convert to wanted
	$keywords = str_replace(";", ",", $keywords);
	$keywords = str_replace("'", "", $keywords);
	$keywords = str_replace(" ", ",", $keywords);
	$keywords = str_replace(",,", ",", $keywords);

	// choose comma separated keywords
	$keywordarray = explode (",", $keywords);
	$keywordarray = array_map('trim', $keywordarray);
	$keywordarray = array_diff($keywordarray, array(''));
	$keywordarray = array_unique($keywordarray);
	$keywordarray = array_map('strtoupper', $keywordarray);
	// check for empty keywords or keywords smaller than 3 chars
	if(is_array($keywordarray) && count($keywordarray)) {
		foreach($keywordarray as $key => $value) {
			
			if(substr($keywordarray[$key], 0, 1) == '-') {
				$doNotUse = substr($keywordarray[$key], 1);
				foreach($keywordarray as $key2 => $value2) {
					if($doNotUse == $value2) {
						unset($keywordarray[$key2]);
						unset($keywordarray[$key]);
					}
				}
			}
			
			if(isset($keywordarray[$key]) && (strlen($keywordarray[$key]) < 3 || empty($keywordarray[$key]))) {
				unset($keywordarray[$key]);
			}
		}
	}

	if(is_array($keywordarray) && count($keywordarray)) {
		$where = "";
		foreach($keywordarray as $value) {
				//build where keyword = blabla
				$where .= ($where) ? " OR " : "";
				//replace every "'" to "''" for security reasons with aporeplace()
				$where .= "article_keyword LIKE '%".aporeplace($value)."%'";	
		}
		$limit = ($max_cnt_links) ? " LIMIT ".$max_cnt_links : "";
		$sql  =	"SELECT article_id, article_title, article_cid, article_subtitle, article_summary ";
		$sql .=	"FROM ".DB_PREPEND."phpwcms_article WHERE article_deleted=0 AND ";
		$sql .=	"article_id<>".intval($current_article_id)." AND ";
		// VISIBLE_MODE: 0 = frontend (all) mode, 1 = article user mode, 2 = admin user mode
		switch(VISIBLE_MODE) {
			case 0: $sql .=	"article_public=1 AND article_aktiv=1 AND ";
					break;
			case 1: $sql .= "article_uid=".$_SESSION["wcs_user_id"]." AND ";
					break;
			//case 2: admin mode no additional neccessary
		}
		$sql .=	"article_begin < NOW() AND article_end > NOW() AND (".$where.") ";
		$sql .=	"ORDER BY article_tstamp DESC".$limit;

		// related things
		$target = ($template_default["link_target"]) ? ' target="'.$template_default["link_target"].'"' : "";
		if($result = mysql_query($sql, $dbcon)) {
			$count_results = mysql_num_rows($result);
			$count = 0;
			while ($row = mysql_fetch_row($result)) {
				$count++;
				if($template_default["link_length"] && strlen($row[1]) > $template_default["link_length"]) {
					$article_title = substr($row[1], 0, $template_default["link_length"]).$template_default["cut_title_add"];
				} else {
					$article_title = $row[1];
				}
				$keyword_links .= $template_default["link_before"].$template_default["link_symbol"];
				$keyword_links .= '<a href="index.php?id='.$row[2].','.$row[0].',0,0,1,0"';
				$keyword_links .= $target.">".html_specialchars($article_title)."</a>";
				
				//try to remove possible unwanted after - if not enclosed before.link.after
				if($keyword_links && !$template_default["link_before"] && $count < $count_results) {
					$keyword_links .= $template_default["link_after"];
				}
			}
			mysql_free_result($result);
		}
	}

	//enclose whole
	if($keyword_links) $keyword_links = $template_default["before"].$keyword_links.$template_default["after"];
	
	return $keyword_links; //.htmlentities(' '.$sql.' '.$keywords);
}

// -------------------------------------------------------------

function get_new_articles($template_default, $max_cnt_links=0, $cat, $dbcon) {
	// find all new articles
	
	$max_cnt_links = intval($max_cnt_links);
	$limit = ($max_cnt_links) ? " LIMIT ".$max_cnt_links : "";
	$cat = trim($cat);
	$cat = (intval($cat) || $cat == '0') ? 'article_cid='.intval($cat).' AND ' : '';
	
	if(isset($template_default["sort_by"]) && $template_default["sort_by"] == 'cdate') {
		//use real creation date
		$sql  =	"SELECT article_id, article_title, article_cid, article_created AS article_date ";
		$sorting = 'article_created';
	} else {
		$sql  =	"SELECT article_id, article_title, article_cid, UNIX_TIMESTAMP(article_tstamp) AS article_date ";
		$sorting = 'article_tstamp';
	}
	$sql .=	"FROM ".DB_PREPEND."phpwcms_article WHERE ".$cat;
	// VISIBLE_MODE: 0 = frontend (all) mode, 1 = article user mode, 2 = admin user mode
	switch(VISIBLE_MODE) {
		case 0: $sql .=	"article_public=1 AND article_aktiv=1 AND ";
				break;
		case 1: $sql .= "article_uid=".$_SESSION["wcs_user_id"]." AND ";
				break;
		//case 2: admin mode no additional neccessary
	}
	$sql .= "article_deleted=0 AND article_begin < NOW() AND article_end > NOW() ";
	$sql .= "ORDER BY ".$sorting." DESC".$limit;

	// new articles list
	$new_links = "";
	$target = ($template_default["link_target"]) ? ' target="'.$template_default["link_target"].'"' : "";
	if($result = mysql_query($sql, $dbcon)) {
		$count_results = mysql_num_rows($result); $count = 0;
		while ($row = mysql_fetch_row($result)) {
			$count++;
			if($template_default["link_length"] && strlen($row[1]) > $template_default["link_length"]) {
				$article_title = substr($row[1], 0, $template_default["link_length"]).$template_default["cut_title_add"];
			} else {
				$article_title = $row[1];
			}
			$article_title = html_specialchars($article_title);
			if(trim($template_default["date_format"])) {
				$article_title = 	$template_default["date_before"].
									html_specialchars(international_date_format(
									$template_default["date_language"], 
									$template_default["date_format"], 
									$row[3])).$template_default["date_after"].$article_title;
			}
			$new_links .= $template_default["link_before"].$template_default["link_symbol"];
			$new_links .= '<a href="index.php?id='.$row[2].','.$row[0].',0,0,1,0"';
			$new_links .= $target.">".$article_title."</a>";
			
			//try to remove possible unwanted after - if not enclosed before.link.after
			if($new_links && !$template_default["link_before"] && $count < $count_results) {
				$new_links .= $template_default["link_after"];
			}
		}
		mysql_free_result($result);
	}

	//enclose whole
	if($new_links) $new_links = $template_default["before"].$new_links.$template_default["after"];
	
	return $new_links;
}

// -------------------------------------------------------------

function get_article_idlink($article_id=0, $link_text="", $db) {
	// returns the internal article link to given article ID/category
	$article_id		= intval($article_id);
	$article_cid	= 0;
	$link_text		= html_entity_decode($link_text);
	$link_text		= html_specialchars($link_text);
	$article_title	= $link_text;
	
	if($article_id) {
		$sql =	"SELECT article_id, article_title, article_cid ".
				"FROM ".DB_PREPEND."phpwcms_article WHERE article_id=".$article_id." AND ".
				"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND ".
				"article_begin < NOW() AND article_end > NOW() LIMIT 1;";
		if($result = mysql_query($sql, $db)) {
			if($row = mysql_fetch_row($result)) {
				$article_id		= $row[0];
				$article_cid	= $row[2];
				$article_title	= html_specialchars($row[1]);
			}
			mysql_free_result($result);
		}
	}
	$article_link = '<a href="index.php?id='.$article_cid.','.$article_id.
					',0,0,1,0" title="'.$article_title.'">'.$link_text.'</a>';
	return $article_link;
}

// -------------------------------------------------------------

function get_keyword_link($keywords="", $db) {
	// returns a link or linklist for special article keywords
	// used for replacement tag {KEYWORD:Charlie}
	
	$keywords = explode(",", $keywords); 
	$where = ""; 
	$keyword_list = "";
	$link = "";
	
	if(count($keywords)) {
		foreach($keywords as $value) {
			$value = trim($value);
			if($value) {
				if($where) {
					$where .= " AND ";
					$keyword_list .= ", ";
				}
				$where .= "article_keyword LIKE '%*".aporeplace($value)."*%'";
				//$where .= "article_keyword REGEXP '\\\\*".aporeplace($value)."\\\\*'";
				$keyword_list .= html_specialchars($value);
			}
		}
	} else {
		$keyword_list = $keywords;
	}
	
	if($where) {
		
		$x = 0;
		$sql  = "SELECT article_id, article_cid, article_title FROM ".DB_PREPEND."phpwcms_article WHERE ";
		// VISIBLE_MODE: 0 = frontend (all) mode, 1 = article user mode, 2 = admin user mode
		switch(VISIBLE_MODE) {
			case 0: $sql .=	"article_public=1 AND article_aktiv=1 AND ";
					break;
			case 1: $sql .= "article_uid=".$_SESSION["wcs_user_id"]." AND ";
					break;
			//case 2: admin mode no additional neccessary
		}
		$sql .= "article_deleted=0 AND article_begin < NOW() ";
		$sql .=	"AND article_end > NOW() AND (".$where.")";
	
		if($result = mysql_query($sql, $db)) {
			$article_list = array();
			while($row = mysql_fetch_row($result)) {
				$article_list[$x][0] = $row[0]; //article ID
				$article_list[$x][1] = $row[1]; //article catID
				$article_list[$x][2] = html_specialchars($row[2]); //article title
				$x++;
			}
			mysql_free_result($result);
		}
		
		if($x) {
			// if keyword(s) found
			if($x == 1) {
				// if only 1 article found
				$link .= '<a href="index.php?id='.$article_list[0][1].','.$article_list[0][0];
				$link .= ',0,0,1,0" title="'.$article_list[0][2].'">'.$keyword_list.'</a>';
			} else {
				// if more than one article found
				foreach($article_list as $key => $value) {
					if($link) $link .= '|';
					$link .= '<a href="index.php?id='.$article_list[$key][1].','.$article_list[$key][0];
					$link .= ',0,0,1,0" title="'.$article_list[$key][2].'">'.($key+1).'</a>';					
				}
				$link = $keyword_list.' ['.$link.']';				
			}
		}
	}
	if(!$link) $link = $keyword_list;
	$link  = $GLOBALS['template_default']["article"]["keyword_before"] . $link;
	$link .= $GLOBALS['template_default']["article"]["keyword_after"];
	return $link;

}

// -------------------------------------------------------------

function clean_replacement_tags($text = '') {
	// strip out special replacement tags
	$text = render_PHPcode($text);
	$text = str_replace('<td>', '<td> ', $text);
	$text = strip_tags($text, '<a><b><i><u>');
	$text = str_replace("|", " ", $text);
	$text = preg_replace('/\{.*?\}/si', "", $text);
	$text = preg_replace('/\[ID.*?\/ID\]/si', "", $text);
	$text = preg_replace('/(\s+)/i', " ", $text);
	return trim($text);
}

// -------------------------------------------------------------

function get_search_action($id, $dbcon) {
	// return the search form action
	$id = intval($id); $cid = 0;
	if($id) {
		$sql  = "SELECT article_cid FROM ".DB_PREPEND."phpwcms_article WHERE ";
		$sql .=	"article_public=1 AND article_aktiv=1 AND article_deleted=0 AND article_begin < NOW() ";
		$sql .=	"AND article_end > NOW() AND article_id=".$id." LIMIT 1;";
		if($result = mysql_query($sql, $dbcon)) {
			if($row = mysql_fetch_row($result)) {
				$cid = $row[0];
			}
			mysql_free_result($result);	
		}
	}
	return ($cid) ? 'index.php?id='.$cid.','.$id.',0,0,1,0' : '';
}

// -------------------------------------------------------------

function get_index_link_up($linktext) {
	// return the link to parent category of current category
	$cat_id = $GLOBALS['content']['cat_id'];
	$linktext = trim($linktext);
	$link = '';
	if(!$linktext) $linktext = 'UP';
	if($cat_id && !$GLOBALS['content']['struct'][$cat_id]['acat_hidden']) {
		$link = '<a href="index.php?id='.$GLOBALS['content']['struct'][$cat_id]['acat_struct'].',0,0,1,0,0">';
	}
	return ($link) ? $link.$linktext.'</a>' : $linktext;
}

// -------------------------------------------------------------

function get_index_link_next($linktext, $cat_down=0) {
	// return the link to next article in current ctageory
	$a_id = ($GLOBALS['content']['article_id']) ? $GLOBALS['content']['article_id'] : $GLOBALS['aktion'][1];
	$linktext = trim($linktext);
	if(!$linktext) $linktext = 'NEXT';
	$link = '';

	if(count($GLOBALS['content']['articles']) > 1) {

		$c = 0; //temp counter
		foreach($GLOBALS['content']['articles'] as $key => $value) {
			if($c || !$a_id) {
				$link  = '<a href="index.php?id='.$GLOBALS['content']['articles'][$key]['article_cid'].',';
				$link .= $key.',0,0,1,0">';
				break;
			}
			if($key == $a_id) $c++;
		}
	}
	
	if($cat_down && !$link) {
		// go cat down or to next cat above
		
		if($GLOBALS['content']['cat_id']) {
			foreach($GLOBALS['content']['struct'] as $key => $value) {
				if($GLOBALS['content']['struct'][$key]['acat_struct'] == $GLOBALS['content']['cat_id']) {
					$link = '<a href="index.php?id='.$key.',0,0,1,0,0">';
					break;
				}
			}
		} else {
			$c = 0;
			foreach($GLOBALS['content']['struct'] as $key => $value) {
				if($c) {
					$link = '<a href="index.php?id='.$key.',0,0,1,0,0">';
					break;
				}
				$c++;
			}
		}
		
		if(!$link && $GLOBALS['content']['cat_id']) {
			$c=0; 
			$temp_key = array();
			foreach($GLOBALS['content']['struct'] as $key => $value) {
				if($GLOBALS['content']['struct'][$key]['acat_struct'] == $GLOBALS['content']['struct'][ $GLOBALS['content']['cat_id'] ]['acat_struct']) {
					$temp_key[] = $key;
				}
			}
			$count_temp = count($temp_key);
			if($count_temp) {
				$c=0;
				foreach($temp_key as $value) {
					if($value == $GLOBALS['content']['cat_id'] && $c+1 < $count_temp) {
						$link = '<a href="index.php?id='.$temp_key[$c+1].',0,0,1,0,0">';
						break;
					}
					$c++;
				}
				if($c == $count_temp && !$link) {
					// back reverese to higher next structure level
					$current_id = $GLOBALS['content']['cat_id'];
					
					while($c=1) {
						$parent_id = $GLOBALS['content']['struct'][ $current_id ]['acat_struct'];
						$parent_struct_id = $GLOBALS['content']['struct'][ $parent_id ]['acat_struct'];
					
						$c=0;
						foreach($GLOBALS['content']['struct'] as $key => $value) {
							if($GLOBALS['content']['struct'][$key]['acat_struct'] == $parent_struct_id) {
								if($c) {
									$link = '<a href="index.php?id='.$key.',0,0,1,0,0">';
									break;
								}
								if($key == $parent_id) $c=1;
							}
						}
					
						if(!$parent_struct_id) {
							if(!$parent_id) $link = '';
							break;
						} else {
							$current_id = $parent_id;
						}
						
					}
					
					
				}
			}
		}

	}
	
	return ($link) ? $link.$linktext.'</a>' : $linktext;
}

// -------------------------------------------------------------

function get_index_link_prev($linktext, $cat_up=0) {
	// return the link to next article in current ctageory
	$a_id = ($GLOBALS['content']['article_id']) ? $GLOBALS['content']['article_id'] : $GLOBALS['aktion'][1];
	$linktext = trim($linktext);
	if(!$linktext) $linktext = 'PREV';
	$link = '';
	$c = 0; //temp counter

	if(count($GLOBALS['content']['articles']) > 1 && $a_id) {
		
		foreach($GLOBALS['content']['articles'] as $key => $value) {
			if($key == $a_id && $c) {
				$link  = '<a href="index.php?id='.$prev_cat_id.',';
				$link .= $prev_art_id.',0,0,1,0">';
				break;
			}
			$c++;
			$prev_cat_id = $GLOBALS['content']['articles'][$key]['article_cid'];
			$prev_art_id = $key;
		}
	}
	if($a_id && $c && !$link) {
		$link = '<a href="index.php?id='.$GLOBALS['content']['cat_id'].',0,0,1,0,0">';
	}
	
	if($cat_up && !$link) {
		// go cat down or to next cat above
		$temp_key = array();
		foreach($GLOBALS['content']['struct'] as $key => $value) {
			if($GLOBALS['content']['struct'][$key]['acat_struct'] == $GLOBALS['content']['struct'][ $GLOBALS['content']['cat_id'] ]['acat_struct']) {
				$temp_key[] = $key;
			}
		}
		if(count($temp_key) && $GLOBALS['content']['cat_id']) {
			$c = 0;
			foreach($temp_key as $value) {
				if($value == $GLOBALS['content']['cat_id']) {
					$prev_cat_id = (!$c) ? $GLOBALS['content']['struct'][$value]['acat_struct'] : $temp_key[$c-1];
					$link = '<a href="index.php?id='.$prev_cat_id.',0,0,1,0,0">';
					break;
				}
				$c++;
			}
		}
	}
	
	return ($link) ? $link.$linktext.'</a>' : $linktext;
}

// -------------------------------------------------------------

function include_int_php($string) {
	// return the PHP var value
	$s = html_despecialchars($string[1]);
	if((strpos($s,'$GLOBALS') || strpos($s,'$_'))===false) {
		$s = preg_replace('/^\$(.*?)\[(.*?)/si', '$GLOBALS["$1"][$2', $s);
		if(substr($s,strlen($s)-1) != ']') {
			$s = str_replace('$', '', $s);
			$s = '$GLOBALS["'.$s.'"]';
			//$s = preg_replace('/^\$(.*?)/si', '$GLOBALS["$1"]', $s);
		}
	}
	$s = str_replace('$phpwcms', '$notavailable', $s);
	$s = str_replace('["phpwcms"]', '["notavailable"]', $s);
	$s = str_replace("['phpwcms']", '["notavailable"]', $s);
	ob_start();
	eval('echo '.$s.';');
	$return = ob_get_contents();
	ob_end_clean();
	return $return;
}

// -------------------------------------------------------------

function include_int_phpcode($string) {
	// return the PHP code
	$s = html_despecialchars($string[1]);
	$s = str_replace('<br>', "\n", $s);
	$s = str_replace('<br />', "\n", $s);
	ob_start();
	eval($s.";");
	$return = ob_get_contents();
	ob_end_clean();
	return $return;
}

// -------------------------------------------------------------

function build_sitemap($start=0, $counter=0) {
	// create sitemap

	$s = '';
	$c = '';
	$counter++;
	

	if($GLOBALS['sitemap']['classcount']) {
		if($GLOBALS['sitemap']['catclass']) $c = ' class="'.$GLOBALS['sitemap']['catclass'].$counter.'"';
	} else {
		if($GLOBALS['sitemap']['catclass']) $c = ' class="'.$GLOBALS['sitemap']['catclass'].'"';
	}
	
	foreach($GLOBALS['content']['struct'] as $key => $value) {

		if ($start == $GLOBALS['content']['struct'][$key]['acat_struct'] && 
			!$GLOBALS['content']['struct'][$key]['acat_hidden'] && $key && $GLOBALS['content']['struct'][$key]['acat_nositemap'])
		{
			$s .= '<li'.$GLOBALS['sitemap']['cat_style'].$c.'>';
						
			if(!$GLOBALS['content']['struct'][$key]["acat_redirect"]) {
				$s .= '<a href="index.php?';
				if($GLOBALS['content']['struct'][$key]['acat_alias']) {
					$s .= $GLOBALS['content']['struct'][$key]['acat_alias'];
				} else {
					$s .= 'id='.$key.',0,0,1,0,0';
				}
			} else {
				$redirect = get_redirect_link($GLOBALS['content']['struct'][$key]["acat_redirect"], ' ', '');
				$s .= '<a href="'.$redirect['link'].'"'.$redirect['target'];
			}
			
			$s .= '">';
			$s .= html_specialchars($GLOBALS['content']['struct'][$key]['acat_name']);
			$s .= '</a>';
			if($GLOBALS['sitemap']["display"]) $s .= build_sitemap_articlelist($key, $counter);
			
			$s .= build_sitemap($key, $counter);
			
			$s .= "</li>\n";
		}
	}


	if($s) $s = "\n<ul".$c.">\n".$s.'</ul>';
	
	return $s;
}

// -------------------------------------------------------------

function build_sitemap_articlelist($cat, $counter=0) {
	// create list of articles for given category
	
	$ao = get_order_sort($GLOBALS['content']['struct'][ $cat ]['acat_order']);
	
	$sql  = "SELECT article_id, article_title FROM ".DB_PREPEND."phpwcms_article ";
	$sql .= "WHERE article_cid=".intval($cat)." AND article_nositemap=1 AND ";
	// VISIBLE_MODE: 0 = frontend (all) mode, 1 = article user mode, 2 = admin user mode
	switch(VISIBLE_MODE) {
		case 0: $sql .=	"article_public=1 AND article_aktiv=1 AND ";
				break;
		case 1: $sql .= "article_uid=".$_SESSION["wcs_user_id"]." AND ";
				break;
		//case 2: admin mode no additional neccessary
	}	
	$sql .= "article_deleted=0 AND article_begin<NOW() AND article_end>NOW() ";
	$sql .= "ORDER BY ".$ao[2];
	
	$s = '';
	$c = '';
	if($GLOBALS['sitemap']['classcount']) {
		if($GLOBALS['sitemap']['articleclass']) $c = ' class="'.$GLOBALS['sitemap']['articleclass'].$counter.'"';
	} else {
		if($GLOBALS['sitemap']['articleclass']) $c = ' class="'.$GLOBALS['sitemap']['articleclass'].'"';
	}
	
	if($result = mysql_query($sql, $GLOBALS['db'])) {
		while($row = mysql_fetch_row($result)) {
		
			$s .= '<li'.$GLOBALS['sitemap']['article_style'].$c.'>';
			$s .= '<a href="index.php?id='.$cat.','.$row[0].',0,0,1,0">';
			$s .= html_specialchars($row[1]);
			$s .= "</a></li>\n";
			
		}
		mysql_free_result($result);
	}
	
	if($s) $s = "\n<ul".$c.">\n".$s.'</ul>';
	
	return $s;

}

// -------------------------------------------------------------

function render_cnt_template($text='', $tag='', $value='') {
	// render content part by replacing placeholder tags by value
	if(strval($value)) {
		$text = preg_replace('/\['.$tag.'\](.*?)\[\/'.$tag.'\]/is', '$1', $text);
		$text = str_replace('{'.$tag.'}', $value, $text);
	} else {
		$text = preg_replace('/\['.$tag.'\](.*?)\[\/'.$tag.'\]/is', '', $text);
		$text = str_replace('{'.$tag.'}', '', $text);
	}
	return $text;
}

// -------------------------------------------------------------

function render_cnt_date($text='', $date) {
	// render date by replacing placeholder tags by value
	//$language="EN", $format="Y/m/d", $date_now=0
	$text = preg_replace('/\{DATE:(.*?):(.*)\}/ie', 'international_date_format("$2","$1","'.$date.'")', $text);
	$text = preg_replace('/\{DATE:(.*?)\}/ie', 'date("$1",'.$date.')', $text);
	return $text;
}

// -------------------------------------------------------------

function include_url($url) {
	// include given URL but only take content between <body></body>
	
	$k = '';
	$url = trim($url);
	if($url && function_exists('file_get_contents')) {
		$GLOBALS['include_urlparts'] = parse_url($url);
		if(isset($GLOBALS['include_urlparts']['path']) && $GLOBALS['include_urlparts']['path']) {
			$GLOBALS['include_urlparts']['path'] = dirname($GLOBALS['include_urlparts']['path']);
			$GLOBALS['include_urlparts']['path'] = str_replace("\\", '/', $GLOBALS['include_urlparts']['path']);
		}
		$k = @file_get_contents($url);
		$k = preg_replace("/.*<body[^>]*?".">(.*?)<\/body>.*/si", "$1", $k);
		$k = str_replace('<?', '&lt;?', $k);
		$k = str_replace('?>', '?&gt;', $k);
		$k = str_replace('<%', '&lt;&#37;', $k);
		$k = str_replace('%>', '&#37;&gt;', $k);
		//$k = preg_replace_callback('/(href|src|action)=[\'|"](.*?)[\'|"]/i', 'make_absoluteURL', $k);
		$k = preg_replace_callback('/(href|src|action)=[\'|"]{0,1}(.*?)[\'|"]{0,1}( .*?){0,1}>/i', 'make_absoluteURL', $k);
		$GLOBALS['include_urlparts'] = '';
	}
	return $k;
}

// -------------------------------------------------------------

function make_absoluteURL($matches) {
	// replaces all relative URLs in href=/src=
	// to absolute paths based on called URI
	$parts = $GLOBALS['include_urlparts'];
	$path  = $matches[2];
	$k = '';
	if(preg_match('/^(http|mailto|ftp)/i', $path)) {
		$k = $path;
	} else {
		if(empty($parts['path'])) $parts['path'] = '';
		$k = $parts['host'].$parts['path'].'/'.$path;
		$k = str_replace('///', '/', $k);
		$k = str_replace('//', '/', $k);
		$k = $parts['scheme'].'://'.$k;
	}
	if(empty($matches[3])) $matches[3] = '';
	return $matches[1].'="'.$k.'"'.$matches[3].'>';

}

// -------------------------------------------------------------

function render_PHPcode($string='') {
	// combined PHP replace renderer
	// includes external PHP script and returns the content
	// if/elseif construct
	//$string = 
	$string = preg_replace('/\{PHP:(.*?)\}/e', 'include_ext_php("$1");', $string);
	// do complete PHP code
	$string = preg_replace_callback("/\[PHP\](.*?)\[\/PHP\]/s", 'include_int_phpcode', $string);
	// includes external PHP script and returns the content
	$string = preg_replace_callback("/\{PHPVAR:(.*?)\}/s", 'include_int_php', $string);
	return $string;
}

// -------------------------------------------------------------

function build_dhtmlmenu($start=0, $class='', $activeclass='', $counter=0) {
	// builds a <ul><li> list based on structure
	// layout settings for $class = array(
	// 'count'	=> 0 (if the depth should be added to class/id name)
	// 'every'	=> 0 (if set 1 every sub-<ul> will get the class/id name
	// 'ul_i'	=> 'mydhtmlid'
	// 'ul_c'	=> 'mydhtmlclass'
	// 'ul_ia'	=> 'mydhtmlactiveid'
	// 'ul_c'	=> 'mydhtmlactiveclass'
	// 'li_ca'	=> 'myactiveclass' (for setting different class for active <li>)
	
	$s = ''; 
	$g = '';
	foreach($GLOBALS['content']['struct'] as $key => $value) { 
		//2005-03-28 Oliver Georgi
		//enhanced: show also when hidden but within selected tree
		if ($start == $GLOBALS['content']['struct'][$key]['acat_struct'] && 
			(!$GLOBALS['content']['struct'][$key]['acat_hidden'] || isset($GLOBALS['LEVEL_KEY'][$key])) && $key) 
		{ 
			$s .= '<li';
			if($key == $GLOBALS['aktion'][0] && $activeclass) $s .= ' '.$activeclass;
			$s .= '>'; 

			if(!$GLOBALS['content']['struct'][$key]["acat_redirect"]) { 
				$s .= '<a href="index.php?'; 
				if($GLOBALS['content']['struct'][$key]['acat_alias']) { 
					$s .= $GLOBALS['content']['struct'][$key]['acat_alias']; 
				} else { 
					$s .= 'id='.$key.',0,0,1,0,0'; 
				}
				$s .= '">'; 
			} else { 
				$redirect = get_redirect_link($GLOBALS['content']['struct'][$key]["acat_redirect"], ' ', ''); 
				$s .= '<a href="'.$redirect['link'].'"'.$redirect['target'].'>'; 
			}

			$s .= html_specialchars($GLOBALS['content']['struct'][$key]['acat_name']); 
			$s .= '</a>'; 

			$s .= build_dhtmlmenu($key, $class, $counter+1); 

			$s .= "</li>\n"; 
		} 
	} 

	if($s) {
		$g  = "\n<ul";
		if(!$counter && $class) $g .= ' '.$class;
		$g .= ">\n".$s.'</ul>';
	}
	
	return $g; 
}

// -------------------------------------------------------------

function parse_ini_str($Str,$ProcessSections = TRUE,$SplitInNameValue = FALSE) {
	/*
	for parsing a string formatted like INI file
	[Files]
	x=File1
	y=File2
	*/
	$Section = NULL;
	$Data = array();
	if ($Temp = strtok($Str,"\r\n")) {
		do {
			switch ($Temp{0}) {
				
				case ';':
				
				case '#':	break;
				
				case '[':	if (!$ProcessSections) break;
							$Pos = strpos($Temp,'[');
							$Section = substr($Temp,$Pos+1,strpos($Temp,']',$Pos)-1);
							if($Section) $Data[$Section] = array();
							break;
				
				default:	$Pos = strpos($Temp,'=');
							if ($Pos === FALSE) break;
							if(!$SplitInNameValue) {
								$key = trim(substr($Temp,0,$Pos));
								$val = trim(substr($Temp,$Pos+1),' "');
								if ($ProcessSections && $Section) {
									$Data[$Section][$key] = $val;
								} else {
									$Data[$key] = $val;
								}
							} else {
								$Value = array();
								$Value["NAME"] = trim(substr($Temp,0,$Pos));
								$Value["VALUE"] = trim(substr($Temp,$Pos+1),' "');
								if ($ProcessSections && $Section) {
									$Data[$Section][] = $Value;
								} else {
									$Data[] = $Value;
								}
							}
							break;
			}
		} while ($Temp = strtok("\r\n"));
	}
	return $Data;
}

// -------------------------------------------------------------

function getRSSFeed($url, $cache_time=1200, $cache_dir='content/rss') {

	// check if chache is set
	$RSS = false;
	if ($cache_time && $cache_dir && is_dir($cache_dir)) {

		$RSScache_file = $cache_dir.'/rss_'.md5($url);
		$timeout = time() - @filemtime($RSScache_file);

		if ($timeout < $cache_time) {
		
			// read cached RSS value
			$RSS = unserialize(@file_get_contents($RSScache_file));
			if ($RSS) $RSS['cached'] = 1;
		
		} else {
		
			// update RSS cache
			$RSS = parseRSS($url);
			if(is_array($RSS) && count($RSS['ITEMS'])) {
				write_textfile($RSScache_file, serialize($RSS));
			}
			if ($RSS) {
				$RSS['cached'] = 0;
			}
		}

	} else {
		$RSS = parseRSS($url);
		if ($RSS) $RSS['cached'] = 0;
	}

	return $RSS;
}

// -------------------------------------------------------------

function parseRSS($url) {

	$RSSresult = array('GENERAL' => array(), 'FEEDINFO' => array(), 'ITEMS' => array() );
	$RSSresult['GENERAL']['URL'] = $url;
	$f = '';
	if(function_exists('file_get_contents')) {
		$f = @file_get_contents($url);
	} else {
		return false;
	}
	// parse given URL
	if($f) {
		$p = xml_parser_create();
		xml_parse_into_struct($p, $f, $vals, $index);
		xml_parser_free($p);

		$rss = array();
		$level = 0;
		$c = 0;
		$alternate_pubdate = date('r');

		// retrieve basic info like encoding
		preg_match('/encoding=[\'\"](.*?)[\'\"]/si', $f, $encode);
		$RSSresult['GENERAL']['ENCODING'] = (isset($encode[1])) ? strtoupper($encode[1]) : 'UTF-8';

		if(isset($index['TITLE']) && count($index['TITLE'])>1) {
		
			if($RSSresult['GENERAL']['ENCODING'] != 'UTF-8') {
				require_once(PHPWCMS_ROOT.'/include/inc_ext/ConvertCharset/ConvertCharset.class.php');
				$NewEncoding = new ConvertCharset;
			}

			foreach($index['TITLE'] as $key => $value) {

				if($vals[$value]['level'] > $level)	$level = $vals[$value]['level'];			

				$rss[$c]['LINK']  = isset($index['LINK'][$key]) && isset($vals[$index['LINK'][$key]]['value']) ? $vals[$index['LINK'][$key]]['value'] : '';
				$rss[$c]['TITLE'] = $vals[$value]['value'];
				if(isset($index['DESCRIPTION'][$key]) && isset($vals[$index['DESCRIPTION'][$key]]['value'])) {
					$rss[$c]['DESCRIPTION'] = $vals[$index['DESCRIPTION'][$key]]['value'];
				} else {
					$rss[$c]['DESCRIPTION'] = '';
				}
				if(isset($index['PUBDATE'][$key]) && isset($vals[$index['PUBDATE'][$key]]['value'])) {
					$rss[$c]['PUBDATE'] = $vals[$index['PUBDATE'][$key]]['value'];
					$alternate_pubdate = $rss[$c]['PUBDATE'];
					//echo 'pub:'.$alternate_pubdate.' | ';
				} elseif(isset($index['DC:DATE'][$key]) && isset($vals[$index['DC:DATE'][$key]]['value'])) {
					$rss[$c]['PUBDATE'] = $vals[$index['DC:DATE'][$key]]['value'];
					$alternate_pubdate = $rss[$c]['PUBDATE'];
				} else {
					$rss[$c]['PUBDATE'] = ($alternate_pubdate) ? $alternate_pubdate : date('r');
				}
				if(isset($index['IMAGE'][$key]) && isset($index['URL'][$key]) && isset($vals[$index['IMAGE'][$key]]['value']) && isset($vals[$index['URL'][$key]]['value'])) {
					$rss[$c]['IMAGE']['IMGURL'] = $vals[$index['URL'][$key]]['value'];
					$rss[$c]['IMAGE']['IMG_H'] = isset($index['HEIGHT'][$key]) && isset($vals[$index['HEIGHT'][$key]]['value']) ? $vals[$index['HEIGHT'][$key]]['value'] : '';
					$rss[$c]['IMAGE']['IMG_W'] = isset($index['WIDTH'][$key]) && isset($vals[$index['WIDTH'][$key]]['value']) ? $vals[$index['WIDTH'][$key]]['value'] : '';
				} else {
					$rss[$c]['IMAGE'] = false;
				}
				if($RSSresult['GENERAL']['ENCODING'] == 'UTF-8') {
					$rss[$c]['HTML_TITLE'] = utf2html($rss[$c]['TITLE']);
					$rss[$c]['HTML_DESCRIPTION'] = utf2html($rss[$c]['DESCRIPTION']);
				} else {
					//$rss[$c]['HTML_TITLE'] = htmlentities($rss[$c]['TITLE']);
					//$rss[$c]['HTML_DESCRIPTION'] = htmlentities($rss[$c]['DESCRIPTION']);
					$rss[$c]['HTML_TITLE'] = !empty($rss[$c]['TITLE']) ? $NewEncoding->Convert($rss[$c]['TITLE'], $RSSresult['GENERAL']['ENCODING'], 'UTF-8', 1) : '';
					$rss[$c]['HTML_DESCRIPTION'] = !empty($rss[$c]['DESCRIPTION']) ? $NewEncoding->Convert($rss[$c]['DESCRIPTION'], $RSSresult['GENERAL']['ENCODING'], 'UTF-8', 1) : '';
				}

				$c++;

			}
			$RSSresult['ITEMS']		= array_merge(array_slice($rss, $level - 2));
			$RSSresult['FEEDINFO']	= array_merge(array_slice($rss, 0, $level - 2));
		}
	}
	
	return $RSSresult;
}

// -------------------------------------------------------------

// taken from http://www.php.net/manual/en/function.utf8-decode.php
// vpribish at shopping dot com, 10-Sep-2004 08:55
function utf2html($str) {
	$ret = '';
	$max = strlen($str);
	$last = 0;  // keeps the index of the last regular character
	for ($i=0; $i < $max; $i++) {
		$c = $str{$i};
		$c1 = ord($c);
		if ($c1>>5 == 6) {  // 110x xxxx, 110 prefix for 2 bytes unicode
			$ret .= substr($str, $last, $i-$last); // append all the regular characters we've passed
			$c1 &= 31; // remove the 3 bit two bytes prefix
			$c2 = ord($str{++$i}); // the next byte
			$c2 &= 63;  // remove the 2 bit trailing byte prefix
			$c2 |= (($c1 & 3) << 6); // last 2 bits of c1 become first 2 of c2
			$c1 >>= 2; // c1 shifts 2 to the right
			$ret .= "&#" . ($c1 * 100 + $c2) . ";"; // this is the fastest string concatenation
			$last = $i+1;
		} 
	}
	return $ret . substr($str, $last, $i); // append the last batch of regular characters
}

// -------------------------------------------------------------
// by ionrock http://ionrock.umemusic.com
// 2005.01.17 Paul (paal@mailbox.hu)
// Added 2 new line around 900 line by Thifi (tnx!):  if(trim($temp_menu) == "<ul>") return "";
// 2005.01.30 Enhanced and optimized by Oliver

function nav_list_struct ($struct, $act_cat_id, $level, $class='') {
	// start with home directory for the listing = top nav structure
	// 1. Build the recursive tree for given actual article category ID
	
	// return the tree starting with given start_id (like breadcrumb)
	// if the $start_id = 0 then this stops because 0 = top level
	
	$level		= intval($level);
	$data		= array();
	$start_id 	= $act_cat_id;
	$class 		= trim($class);
	$depth		= 0;
	
	while ($start_id) {
		$data[$start_id] = 1;
		$start_id		 = $struct[$start_id]["acat_struct"];
	}
	$temp_tree = sizeof($data) ? array_reverse($data, 1) : false;

	$temp_menu = build_list ($struct, $level, $temp_tree, $act_cat_id, $class, $depth);
	$temp_menu = str_replace("\n\n", "\n", $temp_menu);
	return $temp_menu ? $temp_menu : '';
}

// -------------------------------------------------------------

function build_list ($struct, $level, $temp_tree, $act_cat_id, $class='', $depth=0) {
	// this returns the level structure based on given arrays
	// it is special for browsing from root levels
	
	if($class != '') {
		$curClass = ' class="'.$class.$depth.'"';
		$curClassNext = ' class="'.$class.($depth+1).'"';
		$curClassActive = ' class="'.$class.'Active'.$depth.'"';
	} else {
		$curClass = '';
		$curClassNext = '';
		$curClassActive = ' class="listActive"';
	}
	
	$depth++;
	
	$temp_menu = "\n<ul".$curClass.">\n";
	foreach($struct as $key => $value) {
		
		if(isset($_SESSION["frontend_user_in"]) && $_SESSION["frontend_user_in"] && $struct[$key]["acat_regonly"]) {
			$struct[$key]["acat_regonly"] = 0;
		}
		
		//2005-03-28 Oliver Georgi
		//display also when hidden but within selected tree
		if($struct[$key]["acat_struct"] == $level && $key && (!$struct[$key]["acat_hidden"] || isset($GLOBALS['LEVEL_KEY'][$key])) && !$struct[$key]["acat_regonly"]) {
			
			if(!$struct[$key]["acat_redirect"]) {
				$link = 'index.php?';
				if($struct[$key]["acat_alias"]) {
					$link .= html_specialchars($struct[$key]["acat_alias"]);
				} else {
					$link .= 'id='.$key.',0,0,1,0,0';
				}
				$redirect['target'] = '';
			} else {
				$redirect = get_redirect_link($struct[$key]["acat_redirect"], ' ', '');
				$link = $redirect['link'];
			}
			
			if(!empty($temp_tree[$key])) {
			
				if($act_cat_id == $key) {
					$temp_menu .= "\n<li".$curClassActive.">";
				} else {
					$temp_menu .= "\n<li>";
				}
				/*
				if($act_cat_id == $key) {
					$temp_menu .= '<a class="listActive" href="'.$link.'"'.$redirect['target'].'>';
					$temp_menu .= html_specialchars($struct[$key]["acat_name"])."</a>";
				} else {
					$temp_menu .= '<a href="'.$link.'">'.html_specialchars($struct[$key]["acat_name"]).'</a>';
				}
				*/
				$temp_menu .= '<a href="'.$link.'">'.html_specialchars($struct[$key]["acat_name"]).'</a>';
				
				$temp_menu .= build_list ($struct, $key, $temp_tree, $act_cat_id, $class, $depth);
				$temp_menu .= '</li>';
				
			} else {
				$temp_menu .= "\n<li>".'<a href="'.$link.'"'.$redirect['target'].'>';
				$temp_menu .= html_specialchars($struct[$key]["acat_name"])."</a></li>\n";
			}
		}
	}

	$temp_menu = trim($temp_menu);
	return $temp_menu != "<ul".$curClassNext.">" ? $temp_menu."\n</ul>" : '';//$temp_menu != "<ul>"
}

// end ionrock
// -------------------------------------------------------------

function combined_POST_cleaning($val) {
	$val = clean_slweg($val);
	$val = remove_unsecure_rptags($val);
	return $val;
}

// --------------------------------------------------------------

// http://de3.php.net/manual/en/function.is-numeric.php
// kiss dot pal at expert-net dot hu
// 05-Jan-2005 09:13 
function is_float_ex($pNum) {
	$num_chars = "0123456789.,+-";
	if(strlen(trim($pNum)) == 0) { // empty $pNum -> null
		return false;
	} else {
		$i = 0;
		$f = 1;  // modify 
		$v = strlen($num_chars) - $f;
		while(($i < strlen($pNum)) && ($v >= 0)) {
			$v=strlen($num_chars)-$f;
			while(($v >= 0) && ($num_chars[$v] <> $pNum[$i])) {
				$v--;
			}
			if($f==1) { // Only first item + vagy -
				$f=3;
		 	}
			if(($pNum[$i] == '.') || ($pNum[$i] == ',')) {
				$f=5;
			}
			$i++;
		}
		return ($v < 0) ? false : true;
	}
}

// http://de3.php.net/manual/en/function.html-entity-decode.php
// daniel at brightbyte dot de
// 14-Nov-2004 03:12 
function decode_entities($text) {
	$text = html_entity_decode($text,ENT_QUOTES,"ISO-8859-1"); #NOTE: UTF-8 does not work!
	$text = preg_replace('/&#(\d+);/me',"chr(\\1)",$text); #decimal notation
	$text = preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)",$text);  #hex notation
	return $text;
}
// http://www.evilwalrus.com/viewcode.php?codeEx=627
function is_date($PASSED,$TXT_DATE_FORMAT='m/d/Y') { 
    $lib_import_datearr=array(); 
    $lib_import_datearr['h'] = 2; // 01-12 - time - hours 12 
    $lib_import_datearr['H'] = 2; // 00-23 - time - hours 24 
    $lib_import_datearr['g'] = 0; // 1-12  - time - hours 12 
    $lib_import_datearr['G'] = 0; // 0-23  - time - hours 24 
    $lib_import_datearr['i'] = 2; // 00-59 - time - minutes 
    $lib_import_datearr['k'] = 0; // 0-59  - time - minutes ** k - non standard code. 
    $lib_import_datearr['s'] = 2; // 00-59 - time - seconds 
    $lib_import_datearr['x'] = 0; // 0-59  - time - seconds ** x - non standard code. 
    $lib_import_datearr['a'] = 2; // am/pm - time 
    $lib_import_datearr['A'] = 2; // AM/PM - time 
    $lib_import_datearr['j'] = 0; // 1-31  - date - day 
    $lib_import_datearr['d'] = 2; // 01-31 - date - day 
    $lib_import_datearr['n'] = 0; // 1-12  - date - month 
    $lib_import_datearr['m'] = 2; // 01-12 - date - month 
    $lib_import_datearr['y'] = 2; // 04    - date - year 
    $lib_import_datearr['Y'] = 4; // 2004  - date - year 
    $PASSED = trim($PASSED); // No spaces at beginning or end of date value. 
    $TXT_DATE_FORMAT = trim($TXT_DATE_FORMAT); // No spaces at beginning or end of formatter string 
    $store_arr = array(); // Storage array 
    $lastchar = ""; // Badly named. This really stores the data chunk we are working with 
    $dte_frmt_lstchr = ""; // Current date formatting character 
    $dte_frmt_idx = 0; // Index of where we are in date formatting rule string 
    $bln_formatter = FALSE; // Boolean. Is the formatting character a value or a place holder (ie 'm' vs '/' or ':') 
    $bln_twelve_hour_cycle = FALSE; // Boolean. Whether or not stored hours are 1-12 or 0-23. TRUE = 1-12 
    for ($i=0;$i < strlen($PASSED); $i++) { 
        $dte_frmt_lstchr=substr($TXT_DATE_FORMAT, $dte_frmt_idx,1); // Get first date formatting character 
        $dte_frmt_idx ++; // Move index for format string ahead one. 
        if ((is_int($dte_frmt_lstchr) || is_string($dte_frmt_lstchr)) && array_key_exists($dte_frmt_lstchr, $lib_import_datearr)) { // See if this formatting character is a date value or a spacer value of some sort 
            $bln_formatter = FALSE; // This value needs to be parsed for the date value 
        } 
        else { 
            $bln_formatter = TRUE; // This is a placeholder character 
        } 
        // *** Get the value 
        if ($bln_formatter) { // Just get the character and test for equivalence 
            $lastchar = substr($PASSED,$i,1); 
            if ($lastchar!=$dte_frmt_lstchr) { // The current character does not match the expected formatting character. Crash and Burn! 
                $store_arr = FALSE; // Set the return value to false 
                $i = strlen($PASSED)+1; // Break the loop 
            } 
        } // END get character value 
        else { // Get the date value 
            switch ($lib_import_datearr[$dte_frmt_lstchr]) { // How many characters to get? Remember, type 0 means you must find the end. (As in month, 1 or 2 characters?). 
                case 0: // Zero is for those with either 1 or 2 places. Rule: if 2nd character is also a number, it belongs to the item. 
                    $lastchar = substr($PASSED,$i,1); 
                    if ($i+1 < strlen($PASSED)) { // are there more characters? 
                        if (is_numeric(substr($PASSED,$i+1,1))) { $lastchar=$lastchar.substr($PASSED,$i+1,1); $i++; } // tack on next character. Move in string pointer forward 1 
                    } 
                    switch ($dte_frmt_lstchr) { 
                        case "j": 
                            if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                            else { $store_arr['mday']=$lastchar; } // assign the value to the array 
                            break; 
                        case "n": 
                            if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                            else { $store_arr['mon']=$lastchar; } // assign the value to the array 
                            break; 
                        case "k": 
                            if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                            else { $store_arr['minutes']=$lastchar; } // assign the value to the array 
                            break; 
                        case "x": 
                            if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                            else { $store_arr['seconds']=$lastchar; } // assign the value to the array 
                            break; 
                        case "g": 
                            if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                            else { $store_arr['hours']=$lastchar; $bln_twelve_hour_cycle= TRUE; } // assign the value to the array 
                            break; 
                        case "G": 
                            if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                            else { $store_arr['hours']=$lastchar; $bln_twelve_hour_cycle= FALSE; } // assign the value to the array 
                            break; 
                    } 
                    break; 
                case 2: 
                    $lastchar = substr($PASSED,$i,2); 
                    if (strlen($lastchar)!=2) { // Crap. We ran off the end of the string. Error out 
                        $store_arr = FALSE; // Set the return value to false 
                        $i = strlen($PASSED)+1; // Break the loop 
                    } 
                    else { // Right length. Test Type 
                        $i++; // Move in string pointer forward 1 
                        switch ($dte_frmt_lstchr) { 
                            case "A": 
                                if (strtoupper($lastchar)!="AM" && strtoupper($lastchar)!="PM") { $store_arr = FALSE; $i = strlen($PASSED)+1; } // Invalid AM/PM. Crash and burn 
                                else { $store_arr['ampm']=strtoupper($lastchar); } // assign the value to the array 
                                break;   
                            case "a": 
                                if (strtoupper($lastchar)!="AM" && strtoupper($lastchar)!="PM") { $store_arr = FALSE; $i = strlen($PASSED)+1; } // Invalid AM/PM. Crash and burn 
                                else { $store_arr['ampm']=strtoupper($lastchar); } // assign the value to the array 
                                break; 
                            case "H": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['hours']=$lastchar; $bln_twelve_hour_cycle= FALSE; } // assign the value to the array 
                                break;   
                            case "h": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['hours']=$lastchar; $bln_twelve_hour_cycle= TRUE; } // assign the value to the array 
                                break;   
                            case "i": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['minutes']=$lastchar; } // assign the value to the array 
                                break;   
                            case "s": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['seconds']=$lastchar; } // assign the value to the array 
                                break;   
                            case "d": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['mday']=$lastchar; } // assign the value to the array 
                                break;                          
                            case "m": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['mon']=$lastchar; } // assign the value to the array 
                                break; 
                            case "y": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { 
                                    if ($lastchar<70) { $lastchar="20".$lastchar; } 
                                    else { $lastchar="19".$lastchar; } 
                                    $store_arr['year']=$lastchar; 
                                } // assign the value to the array 
                                break; 
                        } 
                    } 
                    break; 
                case 4: 
                    $lastchar = substr($PASSED,$i,4); 
                    if (strlen($lastchar)!=4) { // Crap. We ran off the end of the string. Error out 
                        $store_arr = FALSE; // Set the return value to false 
                        $i = strlen($PASSED)+1; // Break the loop 
                    } 
                    else { // Right length. Test Type 
                        $i=$i+3; // Move in string pointer forward 3 
                        switch ($dte_frmt_lstchr) { 
                            case "Y": 
                                if (!is_numeric($lastchar)) { $store_arr = FALSE; $i = strlen($PASSED)+1; } // The the value. Must be a number. Break out 
                                else { $store_arr['year']=$lastchar; } // assign the value to the array 
                                break; 
                        } 
                    } 
                    break; 
            } // END switch 
        } // END else get the date value 
    } 
    if (isset($store_arr['hours'])) { // are hours are set? 
        if ($bln_twelve_hour_cycle) { // If the recieved data was 12-hour cycle, we may need to test for PM and do some math! 
            if (isset($store_arr['ampm'])) { 
                if ($store_arr['ampm']=="PM") { // Is it PM? If so test to see if hour is set 
                    $store_arr['hours']=$store_arr['hours']+12; // The 12 hour date was in PM. Example 11 pm really is 11+12 or 23! 
                } 
                else { // This is AM. Only 1 test needs to be done: 12 am! 
                    if ($store_arr['hours']==12) { $store_arr['hours']=0; } // 12am in 24 cycle is really 0 (0-23!) 
                } 
            } 
        } 
    } 
    if (isset($store_arr['ampm'])) { 
        unset($store_arr['ampm']); 
    } 
    return $store_arr; 
}

// -------------------------------------------------------------

function stripped_cache_content($page='') {
	// clean up html page
	$page = preg_replace('@<script[^>]*?>.*?</script>@si', '', $page);
	$page = str_replace('><', '> <', $page);
	$page = strip_tags($page);
	$page = decode_entities($page);
	$page = preg_replace('/\s+/s', ' ', $page);
	return $page;
}

// -------------------------------------------------------------

function frontend_post_clean($postvalue='', $string_laenge=0) {
	// combined remove unsecure and clean up post value
	return remove_unsecure_rptags(clean_slweg($postvalue, $string_laenge));	
}
function frontend_post_html($postvalue='', $string_laenge=0) {
	// combined remove unsecure and keep all tags
	return remove_unsecure_rptags(slweg($postvalue, $string_laenge));	
}

// -------------------------------------------------------------

function get_fe_userinfo($forum_userID) {
	// get frontend userinformation
	$forum_userID = intval($forum_userID);
	$got_the_info = false;
	if($forum_userID != 0 && (!isset($GLOBALS['FE_USER']) || !isset($GLOBALS['FE_USER'][$forum_userID]))) {
		//connect to user db and get information
		$sql = "SELECT * FROM ".DB_PREPEND."phpwcms_user WHERE usr_id=".$forum_userID." LIMIT 1";
		if($result = mysql_query($sql, $GLOBALS['db'])) {
			if($row = mysql_fetch_assoc($result)) {
				$GLOBALS['FE_USER'][$forum_userID] = array(
					'FE_ID'		=> $forum_userID,		'login'	=> $row['usr_login'],
					'pass'		=> $row['usr_pass'],	'email'	=> $row['usr_email'],
					'admin'		=> $row['usr_admin'],	'fe'	=> $row['usr_fe'],
					'aktiv'		=> $row['usr_aktiv'],	'name'	=> $row['usr_name'],
					'lang'		=> empty($row['usr_lang']) ? $GLOBALS['phpwcms']['default_lang'] : $row['usr_lang'],
					'wysiwyg'	=> $row['usr_wysiwyg']
				);
				$got_the_info = true;
			}
			mysql_free_result($result);
		}
	} else {
		$got_the_info = true;
	}
	if(($forum_userID === 0 && !isset($GLOBALS['FE_USER'][$forum_userID])) || !$got_the_info) {
		$forum_userID = 0;
		$GLOBALS['FE_USER'][$forum_userID] = array(
					'FE_ID'		=> $forum_userID,		'login'	=> 'guest',
					'pass'		=> '',					'email'	=> 'noreply@localhost',
					'admin'		=> 0,					'fe'	=> 0,
					'aktiv'		=> 1,					'name'	=> 'Guest',
					'lang'		=> $GLOBALS['phpwcms']['default_lang'],
					'wysiwyg'	=> $GLOBALS['phpwcms']['wysiwyg_editor']
				);
	}
}

// -------------------------------------------------------------




?>