<?php
/*
 *  Copyright notice
 *
 *  (c) 2003-2004 Kasper Skaarhoj (kasper@typo3.com)
 *  All rights reserved
 *
 *  This script is part of the Typo3 project. The Typo3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
  * Class for conversion between charsets. 
  *
  * $Id: utf8.func.inc.php,v 1.1 2005/05/29 08:38:53 slackero Exp $
  *
  * @author      Kasper Skaarhoj <kasper@typo3.com>
  * @author      Martin Kutschker <martin.t.kutschker@blackbox.net>
  *
  */

function entities_to_utf8($str,$alsoStdHtmlEnt=0)       {
	if ($alsoStdHtmlEnt)    {
		$trans_tbl = array_flip(get_html_translation_table(HTML_ENTITIES));
	}
	$token = md5(microtime());
	$parts = explode($token,ereg_replace('(&([#[:alnum:]]*);)',$token.'\2'.$token,$str));
	foreach($parts as $k => $v) {
		if ($k%2) {
			if (substr($v,0,1)=='#') {       // Dec or hex entities:
				if (substr($v,1,1)=='x') {
					$v=hexdec(substr($v,2));
				}
				$parts[$k] = UnumberToChar(substr($v,1));
			} elseif ($alsoStdHtmlEnt && $trans_tbl['&'.$v.';']) {  // Other entities:
				$parts[$k] = utf8_encode($trans_tbl['&'.$v.';'],'iso-8859-1');
			} else {        // No conversion:
				$parts[$k] ='&'.$v.';';
			}
		}
	}
	return implode('',$parts);
}

function UnumberToChar($cbyte)  {
	$str='';

	if ($cbyte < 0x80) {
		$str.=chr($cbyte);
	} else if ($cbyte < 0x800) {
		$str.=chr(0xC0 | ($cbyte >> 6));
		$str.=chr(0x80 | ($cbyte & 0x3F));
	} else if ($cbyte < 0x10000) {
		$str.=chr(0xE0 | ($cbyte >> 12));
		$str.=chr(0x80 | (($cbyte >> 6) & 0x3F));
		$str.=chr(0x80 | ($cbyte & 0x3F));
	} else if ($cbyte < 0x200000) {
		$str.=chr(0xF0 | ($cbyte >> 18));
		$str.=chr(0x80 | (($cbyte >> 12) & 0x3F));
		$str.=chr(0x80 | (($cbyte >> 6) & 0x3F));
		$str.=chr(0x80 | ($cbyte & 0x3F));
	} else if ($cbyte < 0x4000000) {
		$str.=chr(0xF8 | ($cbyte >> 24));
		$str.=chr(0x80 | (($cbyte >> 18) & 0x3F));
		$str.=chr(0x80 | (($cbyte >> 12) & 0x3F));
		$str.=chr(0x80 | (($cbyte >> 6) & 0x3F));
		$str.=chr(0x80 | ($cbyte & 0x3F));
	} else if ($cbyte < 0x80000000) {
		$str.=chr(0xFC | ($cbyte >> 30));
		$str.=chr(0x80 | (($cbyte >> 24) & 0x3F));
		$str.=chr(0x80 | (($cbyte >> 18) & 0x3F));
		$str.=chr(0x80 | (($cbyte >> 12) & 0x3F));
		$str.=chr(0x80 | (($cbyte >> 6) & 0x3F));
		$str.=chr(0x80 | ($cbyte & 0x3F));
	} else { // Cannot express a 32-bit character in UTF-8
		$str .= chr(127);
	}
	return $str;
}


/*************************************************************/
?>