<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2005 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

// for debugging only
//error_reporting(E_ALL);

@ini_set( 'arg_separator.output' , '&amp;' );


// build the database table prepend part
define ("DB_PREPEND", $phpwcms["db_prepend"] ? $phpwcms["db_prepend"]."_" : "");

define ("PHPWCMS_CHARSET", ($phpwcms["charset"] ? $phpwcms["charset"] : "iso-8859-1"));

// define the real path of the phpwcms installation
// important to script that must know the real path to files or something else
if(!empty($phpwcms["root"])) {
	$phpwcms['DOC_ROOT']	.= '/'.$phpwcms["root"];
	$phpwcms["root"]		.= '/';
}

define ("PHPWCMS_ROOT", $phpwcms['DOC_ROOT']);
define ('PHPWCMS_FILES', $phpwcms["file_path"].'/');

$phpwcms["file_path"]    = "/".$phpwcms["file_path"]."/" ;  // "/phpwcms_filestorage/"

define ('TEMPLATE_PATH', $phpwcms["templates"].'/');
$phpwcms["templates"]    = "/".$phpwcms["templates"]."/" ;  // "/phpwcms_template/"
$phpwcms["content_path"] = $phpwcms["content_path"]."/"  ;  // "content/"
$phpwcms["cimage_path"]  = $phpwcms["cimage_path"]."/"   ;  // "images/"
$phpwcms["ftp_path"]     = "/".$phpwcms["ftp_path"]."/"  ;  // "/phpwcms_ftp/"

define ('PHPWCMS_TEMPLATE', PHPWCMS_ROOT.$phpwcms["templates"]);
define ('PHPWCMS_URL', $phpwcms["site"].$phpwcms["root"]);
define ('PHPWCMS_IMAGES', $phpwcms["content_path"].'images/');
define ('PHPWCMS_TEMP', PHPWCMS_ROOT.$phpwcms["content_path"].'temp/');
define ('MAGPIE_DIR', PHPWCMS_ROOT.'/include/inc_ext/magpierss/');
define ('MAGPIE_CACHE_DIR', PHPWCMS_ROOT.'/content/rss');
define ('MAGPIE_OUTPUT_ENCODING', PHPWCMS_CHARSET);

// check which function should be used to create thumbnail images
// and if ImageMagick check if enabled or 1 or located at give path
if($phpwcms["imagick_path"]) {
	$phpwcms["imagick_path"] = $phpwcms["imagick_path"].'/';
	$phpwcms["imagick_path"] = str_replace("\\", "/", $phpwcms["imagick_path"]);
	$phpwcms["imagick_path"] = str_replace("//", "/", $phpwcms["imagick_path"]);
	define ("IMAGICK_PATH", $phpwcms["imagick_path"]);
} else {
	define ("IMAGICK_PATH", "");
}
define ("IMAGICK_ON", intval($phpwcms["imagick"]));
define ("GD2_ON", intval($phpwcms["use_gd2"]));

if(!$phpwcms['SMTP_MAILER']) $phpwcms['SMTP_MAILER'] = 'mail';
if(!$phpwcms['SMTP_FROM_EMAIL']) $phpwcms['SMTP_FROM_EMAIL'] = $phpwcms["admin_email"];


// open the connection to MySQL database
$is_mysql_error = false;
//if(empty($NO_DB_CONNECT)) {
	if($phpwcms["db_pers"] == 1) {
		$db = @mysql_pconnect($phpwcms["db_host"], $phpwcms["db_user"], $phpwcms["db_pass"]) or ($is_mysql_error = true);
	} else {
		$db = @mysql_connect($phpwcms["db_host"], $phpwcms["db_user"], $phpwcms["db_pass"]) or ($is_mysql_error = true);
	}
	@mysql_select_db($phpwcms["db_table"],$db) or ($is_mysql_error = true);
	
//}

if($is_mysql_error) {
	header('Location: '.PHPWCMS_URL.'dbdown.php');
	exit();
} else {

	// Send charset used in phpwcms for every query
	@mysql_query("SET NAMES '".$phpwcms["charset"]."'", $db);

}

$phpwcms["version"] = "1.2.6";

// -------------------------------------------------------------

function remove_hashID($str='', $sessName='hashID') {
	// is used to remove all &hashID=...
	// not useful when when storing in cache
	// because it stores unneccessary session IDs too
	$str = preg_replace('/[&|\?]{0,1}'.$sessName.'=[a-zA-Z0-9]{1,}/', '', $str);
	return $str;
}

function readfile_chunked($filename, $retbytes=true) {
	
	if(function_exists('readfile')) {
	
		// use normal readfile function
		// normally works best
		return readfile($filename);	
	
	} else {
	
		// use custom file reading function
		$chunksize	= 1024 * 8; // how many bytes per chunk
		$buffer		= '';
		$cnt		= 0;
		$handle		= @fopen($filename, 'rb');
		if ($handle === false) {
			return false;
		}
		while (!feof($handle)) {
			$buffer = @fread($handle, $chunksize);
			echo $buffer;
			flush();
			if ($retbytes) {
				$cnt += strlen($buffer);
			}
		}
		$status = @fclose($handle);
		if($retbytes && $status) {
			return $cnt; // return num. bytes delivered like readfile() does.
		}
		return $status;

	}
}

?>