<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2005 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.

This script is part of PHPWCMS. The PHPWCMS web content management system is
free software; you can redistribute it and/or modify it under the terms of
the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
A copy is found in the textfile GPL.txt and important notices to the license
from the author is found in LICENSE.txt distributed with these scripts.

This script is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/


// this is for testing only
// returns how long this script is processed
// remove comments // to use this - look at the end of this
// page too
//
//require ("include/inc_ext/phpsniff/phpTimer.class.php");
//$timer =& new phpTimer();
//$timer->start('main');

// start session - neccessary if frontend users are available
// but neccessary also to check if a bot is visiting the site
// -> if so then do not initialize session for larger search engines
$BOTSLIST = array('googlebot', 'msnbot', 'ia_archiver', 'altavista', 'slurp', 'yahoo', 'jeeves', 'teoma', 'lycos'); 
$IS_A_BOT = false;
foreach($BOTSLIST as $value) {
	if(!$IS_A_BOT && stristr($_SERVER['HTTP_USER_AGENT'], $value)) {
		$IS_A_BOT = true;
		break;
	}
}
// if no bot was found initialize session
if(!$IS_A_BOT) {
	session_name('hashID');
	session_start();
	/*
	if (!isset($_SESSION['initiated'])) {
		session_regenerate_id();
		$_SESSION['initiated'] = true;
	}
	*/
}

// define some general vars
$content 		= array();
$phpwcms 		= array();
$BL				= array();


require_once ('config/phpwcms/conf.inc.php');
require_once ("include/inc_lib/default.inc.php");


$cache_query_string = remove_hashID($_SERVER['QUERY_STRING']);
define('FE_CURRENT_URL', PHPWCMS_URL.'index.php?'.$cache_query_string);

if(!isset($_SESSION['frontend_user'])) {

	$_SESSION['frontend_user']['id'] = 0;
	$_SESSION['frontend_user']['login'] = 'guest';
	$_SESSION['frontend_user']['name'] = 'Guest';
	
	// start frontend user login
	if(isset($_POST['fe_user_submit']) || isset($_POST['fe_user_login'])) {
	
		require_once ("include/inc_lib/general.inc.php");
		require_once ("include/inc_front/front.func.inc.php");
		
	}

}

// define VISIBLE_MODE
// 0 = frontend (all) mode
// 1 = article user mode
// 2 = admin user mode
if(empty($_SESSION["wcs_user_id"])) {
	define('VISIBLE_MODE', 0);
} else {
	define('VISIBLE_MODE', $_SESSION["wcs_user_admin"] != 1 ? 1 : 2);
}


//db based page caching
$cache_enabled = empty($phpwcms["cache_enabled"]) ? false : true;
if($cache_enabled) {

	//now try to find current page in cache

	$cache_update  = 1;
	$cache_insert  = 1;
	$cache_nosave  = (isset($_POST) && count($_POST)) ? true : false; // don't store any page result when $_POST used
	
	$cache_searchable = ''; //chache enabled
	$cache_hash = md5($_SERVER['PHP_SELF'].$cache_query_string); //create hash value

	$sql = "SELECT * FROM ".DB_PREPEND."phpwcms_cache WHERE cache_hash='".$cache_hash."'";
	if($result = mysql_query($sql, $db)) {
		if($cache_row_value = mysql_fetch_assoc($result)) {
			$cache_insert  = 0;
		}
		mysql_free_result($result);
	}
	if($phpwcms['cache_timeout'] && isset($cache_row_value) && is_array($cache_row_value)) { //if cached
	
		if($cache_row_value['cache_timeout'] == '') {
			$cache_row_value['cache_timeout'] = $phpwcms['cache_timeout'];
		}
	
		$cache_searchable = $cache_row_value['cache_searchable'];
	
		if($cache_row_value['cache_use'] && (time() - $cache_row_value['cache_changed']) < $cache_row_value['cache_timeout']) {
			$cache_update  = 0;
			$cache_enabled = 1;
		}
	}
}

//script caching to allow header redirect
if($phpwcms["compress_page"] && isset($_SESSION['session_is_set'])) {
	/*
	if(function_exists('ini_set') && !ini_get('zlib.output_compression')) {
		ini_set( 'zlib.output_compression', '1' );
		ini_set( 'zlib.output_compression_level', $phpwcms["compress_page"] );
		ob_start();
	} else {
		ob_start("ob_gzhandler"); //with old style GZ Compression
	}
	*/
	ob_start("ob_gzhandler"); //with old style GZ Compression
} else {
	$_SESSION['session_is_set'] = true;
	ob_start(); //without Compression (or use browsers default)
}

// set correct page encoding
//header('Content-Type: text/html; charset='.PHPWCMS_CHARSET);

if(!$cache_enabled || VISIBLE_MODE == 1 || VISIBLE_MODE == 2) {

	require_once ("config/phpwcms/conf.template_default.inc.php");
	require_once ("config/phpwcms/conf.indexpage.inc.php");

	require_once ("include/inc_lib/general.inc.php");
	
	cleanupPOSTandGET();
	
	require_once ("include/inc_lib/imagick.convert.inc.php");
	require_once ("include/inc_front/front.func.inc.php");
	require_once ("include/inc_front/content.func.inc.php");

	$phpwcms["templates"] = TEMPLATE_PATH;

	$content['page_start']  = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
	$content['page_start'] .= "\n<!--\n     phpwcms | free open source content management system\n";
	$content['page_start'] .= "     created by Oliver Georgi (oliver at phpwcms dot de) and licensed under GNU/GPL.\n";
	$content['page_start'] .= "     phpwcms is copyright 2003-2005 of Oliver Georgi. Extensions are copyright of\n";
	$content['page_start'] .= "     their respective owners. Visit project page http://www.phpwcms.org for details.\n//-->\n";
	$content['page_start'] .= "<html>\n<head>\n<title>".$content["pagetitle"]."</title>\n";
	//$content['page_start'] .= '<link rel="alternate" type="application/rss+xml" title="RSS" href="'.PHPWCMS_URL.'rss.php">'."\n";
	$content['page_start'] .= '<meta http-equiv="Content-Type" content="text/html; charset=';
	$content['page_start'] .= PHPWCMS_CHARSET."\">\n".'<script src="'.TEMPLATE_PATH;
	$content['page_start'] .= 'inc_js/frontend.js" type="text/javascript"></script>'."\n";
	$content['page_start'] .= '<link rel="stylesheet" type="text/css" href="'.TEMPLATE_PATH;
	$content['page_start'] .= "inc_css/".$block["css"]."\">\n".$block["htmlhead"];
	$content['page_start'] .= "\n</head>\n\n<body".$content["body"].">\n";
	
	if(VISIBLE_MODE == 1 || VISIBLE_MODE == 2) {
		$content['page_end']  = '<div id="VisualMODE" style="position:absolute;left:5px;bottom:5px;padding:5px;z-index:1;background-color:#FF3300;color:#FFFFFF;border:1px solid #000000;">';
		$content['page_end'] .= VISIBLE_MODE == 1 ? 'user: ' : 'admin: ';
		$content['page_end'] .= html_specialchars($_SESSION['wcs_user']);
		$content['page_end'] .= "</div>\n</body>\n</html>";
	} else {
		$content['page_end'] = "</body>\n</html>";
	}

	//  this regex's call the function
	if($phpwcms["rewrite_url"]) {
		$allowed_chars_in_url = "[".implode("]|[",array("@",",","\.","+","&","-","_","=","*","#","\/","%","?"))."]";
		$content["all"] = preg_replace("/( href=\"index.php?)(([a-z]|[A-Z]|[0-9]|".$allowed_chars_in_url.")*)(\")/e","url_search('\\2')",$content["all"]);
		$content["all"] = preg_replace("/(onClick=\"location.href='index.php?)(([a-z]|[A-Z]|[0-9]|".$allowed_chars_in_url.")*)(\')/e","js_url_search('\\2')",$content["all"]);
	}

	// EXPERIMENTAL
	// now try to cleanup html code with tidy
	/*
	if(isset($phpwcms['tidy']) && $phpwcms['tidy']) {

		require_once ("include/inc_front/utf8.func.inc.php");

		$tmp_tidy_file = PHPWCMS_ROOT.'/content/tmp/'.time().'_tidy_cleanup.html';
		$tidy_written = entities_to_utf8($content['page_start'].$content["all"].$content['page_end']);
		$tidy_written = write_textfile($tmp_tidy_file, $tidy_written);
		$tidy_page_end = $content['page_end'];
		if($tidy_written && filesize($tmp_tidy_file)){
			
			//echo '<!-- '.$phpwcms['tidy_command'].' "'.$tmp_tidy_file.'" //-->';
			
			@exec($phpwcms['tidy_command'].' "'.$tmp_tidy_file.'"', $tidy_return);
			if(!isset($tidy_return[0])) {
				
				if(filesize($tmp_tidy_file) && ($content['page_end'] = file_get_contents($tmp_tidy_file))) {
					
					echo $content['page_start'] = '';
					echo $content["all"] = '';
				
				} else {
				
					$content['page_end'] = $tidy_page_end;
				}
				
			}
			unlink($tmp_tidy_file);
		}
	}
	*/
	
	// return rendered content
	echo $content['page_start'];
	echo $content["all"];
	echo $content['page_end'];
	
	
		
	$phpwcms['cache_timeout'] = strval($phpwcms['cache_timeout']);


	// switch searchable setting
	// ''  -> 0 -> 1 -> is searchable
	// '1' -> 1 -> 0 -> is not searchable
	$cache_searchable	= intval($cache_searchable) ? 0 : 1;

	if($cache_enabled && VISIBLE_MODE == 0 && $cache_nosave === false) { //don't store when $_POST isset
	
		$content['all'] = remove_hashID($content['all']);
	
		if($cache_insert) {
			//insert cache
			$sql  = "INSERT INTO ".DB_PREPEND."phpwcms_cache SET ";
			$sql .= "cache_hash='".$cache_hash."', ";
			$sqb = "";
	
		} else {
			//update cache
			$sql = "UPDATE ".DB_PREPEND."phpwcms_cache SET ";
			$sqb = " WHERE cache_hash='".$cache_hash."' LIMIT 1";
	
		}
		$cache_URI = 'http://'.$_SERVER["HTTP_HOST"].$_SERVER['PHP_SELF'];
		if(!empty($cache_query_string)) {
			$cache_URI .= '?' . $cache_query_string;
		}
		$sql .= "cache_uri='".aporeplace($cache_URI)."', ";
		$sql .= "cache_cid='".$aktion[0]."', ";
		$sql .= "cache_aid='".$aktion[1]."', ";
		$sql .= "cache_timeout='".$phpwcms['cache_timeout']."', ";
		$sql .= "cache_isprint='".intval($aktion[2])."', ";
		$sql .= "cache_changed='".time()."', ";
		$sql .= "cache_use='".($phpwcms['cache_timeout'] == '0' ? 0 : 1)."', ";
		$sql .= "cache_searchable='".$cache_searchable."', ";
		$sql .= "cache_page='".aporeplace($content['page_start'].$content["all"].$content['page_end'])."', ";
		$sql .= "cache_stripped='".aporeplace(stripped_cache_content($content['all']))."'";
		$sql .= $sqb;
		mysql_query($sql, $db);
	}

} else {

	echo $cache_row_value['cache_page'];
	
}

// show how long it needs to create content
// remove comments // to use it
//$timer->stop('main');
//$t = $timer->get_current('main');
//$t = number_format ( $t, 5, '.', ','); //number_format ( float number, int decimals, string dec_point, string thousands_sep)
//$content["all"] = str_replace('{TIMER}', $t.' sec', $content["all"]);
//echo '<div align="center" style="margin-top:15px;border-top:1px dotted #cccccc;font-size:9px;"><div style="margin-top:5px;">processed in: '.$t.' sec Searchable: '.$cache_searchable.'</div></div>';

ob_end_flush();


?>