<?php
/*************************************************************************************
   Copyright notice
   
   (c) 2002-2005 Oliver Georgi (oliver@phpwcms.de) // All rights reserved.
 
   This script is part of PHPWCMS. The PHPWCMS web content management system is
   free software; you can redistribute it and/or modify it under the terms of
   the GNU General Public License as published by the Free Software Foundation;
   either version 2 of the License, or (at your option) any later version.
  
   The GNU General Public License can be found at http://www.gnu.org/copyleft/gpl.html
   A copy is found in the textfile GPL.txt and important notices to the license 
   from the author is found in LICENSE.txt distributed with these scripts.
  
   This script is distributed in the hope that it will be useful, but WITHOUT ANY 
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
   PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
   This copyright notice MUST APPEAR in all copies of the script!
*************************************************************************************/

//setup functions
$phpwcms_version = "1.2.6";

function read_textfile($filename) {
	if(is_file($filename)) {
		$fd = @fopen($filename, "rb");
		$text = fread($fd, filesize($filename));
		fclose($fd);
		return $text;				
	} else {
		return false;
	}	
}

function write_textfile($filename, $text) {
	if($fp = @fopen($filename, "w+b")) {;
		fwrite($fp, $text);
		fclose($fp);
		return true;	
	} else {
		return false;
	}
}

function set_chmod($path, $rights, $status, $file_folder=0) {

	$Cpath = $_SERVER['DOCUMENT_ROOT'].$path;
	if(@file_exists($Cpath)) {
		if(@chmod($Cpath, $rights)) {
			$status = $file_folder ? check_path_status($path) : check_file_status($path);
		}
	}
	return $status;
}

function check_path_status($path) {
	$path = $_SERVER['DOCUMENT_ROOT'].$path;
	$status = 0;
	$status += (is_dir($path)) ? 1 : 0;
	if($status) {
		$status += (is_writable($path)) ? 1 : 0;
	}
	return $status;
}

function check_file_status($path) {
	$path = $_SERVER['DOCUMENT_ROOT'].$path;
	$status = 0;
	$status += (is_file($path)) ? 1 : 0;
	if($status) {
		$status += (is_writable($path)) ? 1 : 0;
	}
	return $status;
}

function gib_bg_color($status) {
	$color = ' bgcolor="#FF3300"';
	switch($status) {
		case 2: $color = ' bgcolor="#99CC00"';
				break;
		case 1: $color = ' bgcolor="#99CC00"';
				break;
	}
	return $color;
	
}

function gib_status_text($status) {
	$msg = "&nbsp;<b>FALSE</b> (not existing)";
	switch($status) {
		case 2: $msg = "&nbsp;<b>OK</b> (exists + writable)";
				break;
		case 1: $msg = "&nbsp;<b>FALSE</b> (exists + not writable)";
				break;
		case 3: $msg = "&nbsp;<b>OK</b> (exists + not writable)";
				break;
	}
	return $msg;
}

function slweg($string_wo_slashes_weg, $string_laenge=0) {
	// Falls die Serverfunktion magic_quotes_gpc aktiviert ist, so
	// sollen die Slashes herausgenommen werden, anderenfalls nicht
	$string_wo_slashes_weg = trim($string_wo_slashes_weg);
	if( get_magic_quotes_gpc() ) $string_wo_slashes_weg = stripslashes ($string_wo_slashes_weg);
	if($string_laenge) $string_wo_slashes_weg = substr($string_wo_slashes_weg, 0, $string_laenge);
	return $string_wo_slashes_weg;
}

function clean_slweg($string_wo_slashes_weg, $string_laenge=0) {
	// Falls die Serverfunktion magic_quotes_gpc aktiviert ist, so
	// sollen die Slashes herausgenommen werden, anderenfalls nicht
	$string_wo_slashes_weg = trim($string_wo_slashes_weg);
	if( get_magic_quotes_gpc() ) $string_wo_slashes_weg = stripslashes ($string_wo_slashes_weg);
	$string_wo_slashes_weg = strip_tags($string_wo_slashes_weg);
	if($string_laenge) $string_wo_slashes_weg = substr($string_wo_slashes_weg, 0, $string_laenge);
	return $string_wo_slashes_weg;
}

function write_conf_file($val) {

	$conf_file  = "<?"."php\n\n";
	$conf_file .= "// database values\n";
	$conf_file .= "\$phpwcms[\"db_host\"]           = \"".$val["db_host"]."\";\n";
	$conf_file .= "\$phpwcms[\"db_user\"]           = \"".$val["db_user"]."\";\n";
	$conf_file .= "\$phpwcms[\"db_pass\"]           = \"".$val["db_pass"]."\";\n";
	$conf_file .= "\$phpwcms[\"db_table\"]          = \"".$val["db_table"]."\";\n";
	$conf_file .= "\$phpwcms[\"db_prepend\"]        = \"".$val["db_prepend"]."\";\n";
	$conf_file .= "\$phpwcms[\"db_pers\"]           = ".intval($val["db_pers"]).";\n";
	
	$conf_file .= "\n// site values\n";
	$conf_file .= "\$phpwcms[\"site\"]              = \"".$val["site"]."\";\n";
	$conf_file .= "\$phpwcms[\"admin_email\"]       = \"".$val["admin_email"]."\";\n";

	$conf_file .= "\n// paths\n";
	if(!$val['DOC_ROOT'] || $val['DOC_ROOT'] == $_SERVER['DOCUMENT_ROOT']) {
		$conf_file .= "\$phpwcms[\"DOC_ROOT\"]          = \$_SERVER"."['DOCUMENT_ROOT'];\n";
	} else {
		$conf_file .= "\$phpwcms[\"DOC_ROOT\"]          = \"".$val["DOC_ROOT"]."\";         //default: \$_SERVER['DOCUMENT_ROOT']\n";
	}
	$conf_file .= "\$phpwcms[\"root\"]         		= \"".$val["root"]."\";         //default: \"\"\n";
	$conf_file .= "\$phpwcms[\"file_path\"]         = \"".$val["file_path"]."\";    //default: \"phpwcms_filestorage\"\n";
	$conf_file .= "\$phpwcms[\"templates\"]         = \"".$val["templates"]."\";    //default: \"phpwcms_template\"\n";
	$conf_file .= "\$phpwcms[\"content_path\"]      = \"".$val["content_path"]."\"; //default: \"content\"\n";
	$conf_file .= "\$phpwcms[\"cimage_path\"]       = \"images\";  //default: \"images\"\n";
	$conf_file .= "\$phpwcms[\"ftp_path\"]          = \"".$val["ftp_path"]."\";     //default: \"phpwcms_ftp\"\n";

	$conf_file .= "\n// content values\n";
	$conf_file .= "\$phpwcms[\"file_maxsize\"]      = ".intval($val["file_maxsize"])."; //Bytes (50 x 1024 x 1024)\n";
	$conf_file .= "\$phpwcms[\"content_width\"]     = ".intval($val["content_width"])."; //max width of the article content column - important for rendering multi column images\n";
	$conf_file .= "\$phpwcms[\"img_list_width\"]    = ".intval($val["img_list_width"])."; //max with of the list thumbnail image\n";
	$conf_file .= "\$phpwcms[\"img_list_height\"]   = ".intval($val["img_list_height"])."; //max height of the list thumbnail image\n";
	$conf_file .= "\$phpwcms[\"img_prev_width\"]    = ".intval($val["img_prev_width"])."; //max width of the large preview image\n";
	$conf_file .= "\$phpwcms[\"img_prev_height\"]   = ".intval($val["img_prev_height"])."; //max height of the large preview image\n";
	$conf_file .= "\$phpwcms[\"max_time\"]          = ".intval($val["max_time"])."; //logout after max_time/60 seconds\n";

	$conf_file .= "\n// other stuff\n";
	$conf_file .= "\$phpwcms[\"compress_page\"]     = ".intval($val["compress_page"])."; //0 = OFF, 1-9: page compression ON (1 = low level, 9 = highest level)\n";
	
	$conf_file .= "\$phpwcms[\"imagick\"]           = 0; //0 = GD,  1 = ImageMagick, 2 = ImageMagick 4.2.9\n";
	$conf_file .= "\$phpwcms[\"imagick_path\"]      = \"\"; //Path to ImageMagick (default=\"\" - none)\n";
	$conf_file .= "\$phpwcms[\"use_gd2\"]           = 1; //0 = GD1, 1 = GD2\n";
	$conf_file .= "\$phpwcms[\"rewrite_url\"]       = 0;  //whether URL should be rewritable\n";
	$conf_file .= "\$phpwcms[\"wysiwyg_editor\"]    = 2;  //0 = no wysiwyg editor, 1 = HTMLarea, 2 = FCKeditor, 3 = browser based\n";
	$conf_file .= "\$phpwcms[\"phpmyadmin\"]        = 0;  //enable/disable phpMyAdmin in Backend\n";
	$conf_file .= "\$phpwcms[\"default_lang\"]      = \"en\";  //default language\n";
	$conf_file .= "\$phpwcms[\"charset\"]           = \"".$val["charset"]."\";  //default charset 'iso-8859-1'\n";
	$conf_file .= "\$phpwcms[\"allow_remote_URL\"]  = 0;  //0 = no remote URL in {PHP:...} replacement tag allowed, 1 = allowed\n";
	$conf_file .= "\$phpwcms[\"gt_mod\"]            = 0;  //0 = Graphical Text MOD disabled, 1 = enabled\n";
	$conf_file .= "\$phpwcms[\"jpg_quality\"]       = 75; //JPG Quality Range 25-100\n";
	$conf_file .= "\$phpwcms[\"sharpen_level\"]     = 1;  //Sharpen Level - only ImageMagick: 0, 1, 2, 3, 4, 5 -- 0 = no, 5 = extra sharp\n";
	$conf_file .= "\$phpwcms[\"allow_ext_init\"]    = 1;  //allow including of custom external scripts at frontend initialization\n";
	$conf_file .= "\$phpwcms[\"allow_ext_render\"]  = 1;  //allow including of custom external scripts at frontend rendering\n";
	$conf_file .= "\$phpwcms[\"cache_enabled\"]     = 0;        //cache On/Off - 1 = caching On / 0 = caching Off (default)\n";
	$conf_file .= "\$phpwcms[\"cache_timeout\"]     = 0;  //default cache timeout setting in seconds - 0 = caching Off\n";
	$conf_file .= "\$phpwcms[\"imgext_disabled\"]   = '';  //comma seperated list of imagetypes which should not be handled \"pdf,ps\"\n";
	$conf_file .= "\$phpwcms[\"multimedia_ext\"]    = 'aif,aiff,mov,movie,mp3,mpeg,mpeg4,mpeg2,wav,swf,swc,ram,ra,wma,wmv,avi,au,midi,moov,rm,rpm,mid,midi'; //comma seperated list of file extensiosn allowed for multimedia\n";
	$conf_file .= "\$phpwcms[\"inline_download\"]   = 1;  //1 = try to display download documents in new window; 0 = show safe under dialog\n";
	$conf_file .= "\$phpwcms[\"form_tracking\"]     = 1; //make a db entry for each form\n";
	$conf_file .= "\$phpwcms[\"formmailer_set\"]    = array('allow_send_copy' => 0, 'global_recipient_email' => 'form@localhost'); //for better security handling\n";
	$conf_file .= "\$phpwcms[\"allow_cntPHP_rt\"]   = 0; //allow PHP replacement tags and includes in content parts\n";

	$conf_file .= "\n// dynamic ssl encryption engine\n";
	$conf_file .= "\$phpwcms[\"site_ssl_mode\"]     = '0'; // tuns the SSL Support of WCMS on(1) or off (0) DEFAULT '0'\n";
	$conf_file .= "\$phpwcms[\"site_ssl_url\"]      = '';  //URL assigned to the SSL Certificate. DON'T add a slash at the End! Exp. \"https://www.yourdomainhere.tld\"\n";
	$conf_file .= "\$phpwcms[\"site_ssl_port\"]     = '443'; //The Port on which you SSL Service serve the secure Sites. Servers DEFAULT is '443'\n";
	
	$conf_file .= "\n// smtp values\n";
	$conf_file .= "\$phpwcms['SMTP_FROM_EMAIL']   = '".$val["SMTP_FROM_EMAIL"]."'; // reply/from email address\n";
	$conf_file .= "\$phpwcms['SMTP_FROM_NAME']    = '".$val["SMTP_FROM_NAME"]."'; // reply/from name\n";
	$conf_file .= "\$phpwcms['SMTP_HOST']         = '".$val["SMTP_HOST"]."'; // SMTP server (host/IP)\n";
	$conf_file .= "\$phpwcms['SMTP_PORT']         = ".intval($val["SMTP_PORT"])."; // SMTP-Server port (default 25)\n";
	$conf_file .= "\$phpwcms['SMTP_MAILER']       = '".$val["SMTP_MAILER"]."'; // default phpMailer: smtp, mail (default), sendmail\n";
	$conf_file .= "\$phpwcms['SMTP_AUTH']         = ".intval($val["SMTP_AUTH"])."; // sets SMTP_AUTH to ON/OFF\n";
	$conf_file .= "\$phpwcms['SMTP_USER']         = '".$val["SMTP_USER"]."'; // default SMTP login (user) name\n";
	$conf_file .= "\$phpwcms['SMTP_PASS']         = '".$val["SMTP_PASS"]."'; // default SMTP password\n";
	
	$conf_file .= "\n\n// Try to check and uncomment the DOCUMENT_ROOT if you have problems \n";
	$conf_file .= "// often neccessary on IIS or default MacOS X webserver settings\n";
	$conf_file .= "// Do not use backslash \"\\\" on Windows - always replace \"\\\" by \"/\"\n";
	$conf_file .= "//\$_SERVER['DOCUMENT_ROOT']     = '".str_replace("\\", "/", $_SERVER['DOCUMENT_ROOT'])."';\n";
	
	$conf_file .= "\n\n?>";
	
	write_textfile("setup.conf.inc.php", $conf_file);	
}

function aporeplace($string_to_convert="") {
	//ndert die einfachen Apostrophe fr SQL-Funktionen in doppelte
	$string_to_convert = str_replace("\\", "\\\\", $string_to_convert);
	$string_to_convert = str_replace("'", "''", $string_to_convert );
	return $string_to_convert;
}

function html_specialchars($h="") {
	//used to replace the htmlspecialchars original php function
	//not compatible with many internation chars like turkish, polish
	$h = preg_replace("/&(?!#[0-9]+;)/s", '&amp;', $h );
	$h = str_replace( "<", "&lt;"  , $h );
	$h = str_replace( ">", "&gt;"  , $h );
	$h = str_replace( '"', "&quot;", $h );
	$h = str_replace( "'", "&#039;", $h );
	$h = str_replace( "\\", "&#92;", $h );
	return $h;
}

function readfile_chunked($filename,$retbytes=true) {
   $chunksize = 1*(1024*1024); // how many bytes per chunk
   $buffer = '';
   $cnt =0;
   $handle = @fopen($filename, 'rb');
   if ($handle === false) {
       return false;
   }
   while (!feof($handle)) {
       $buffer = @fread($handle, $chunksize);
       echo $buffer;
       flush();
       if ($retbytes) {
           $cnt += strlen($buffer);
       }
   }
   $status = @fclose($handle);
   if ($retbytes && $status) {
       return $cnt; // return num. bytes delivered like readfile() does.
   }
   return $status;
}

?>